<?php

if (!defined('SMF'))
	die('Hacking attempt...');

/*
File: SPortal2.php
Version: Simple Portal Classic 2.0.5 for SMF 2 Beta 4.
	
sportal()
sportal_init()
getArticles()
sportal_vital()
sp_loadColors()
sp_userInfo()
sp_latestMember()
sp_whosOnline()
sp_showPoll()
sp_boardStats()
sp_topPoster()
sp_topBoards()
sp_topTopics()
sp_recentPosts()
sp_recentTopics()
sp_boardNews()
sp_quickSearch()
sp_news()
sp_bbc()
sp_html()
sp_php()

*/

// Function to initiate the neccessary variables, in short change the page title.... ;)
function sportal_init()
{
	global $context;

	$context['page_title'] = $context['forum_name'];
	
	//Why not loading the language now? :D
	loadLanguage('SPortal', sp_languageSelect('SPortal'));
}

// The main function to load the Portal Itself.
function sportal()
{
	global $context, $txt, $smcFunc, $user_info, $sourcedir, $scripturl, $article_request, $modSettings;

	// Are they trying to use wireless? We don't worry about that here. Go away! :P
	if(WIRELESS)
		redirectexit('action=forum');
	
	// We will need the important Subs-SPortal.php functions.
	require_once($sourcedir . '/Subs-SPortal2.php');
	
	// Do we need to add an article?
	if(!empty($_REQUEST['sa']) && $_REQUEST['sa'] == 'addarticle') 
	{
		// Are we even allow to add articles? If not, then return a fatal error message.
		if(!(allowedTo('sp_add_article') || allowedTo('sp_moderate')))
			fatal_lang_error('error_sp_cannot_add_article');
		
		// Get and sanitize some important variables.
		$context['message'] = !empty($_REQUEST['message']) ? (int) $_REQUEST['message'] : 0;
		$context['return'] = !empty($_REQUEST['return']) ? $_REQUEST['return'] : '';

		// No message ID? Return an error.....
		if($context['message'] == 0)
			fatal_lang_error('error_sp_no_message_id');

		// Check to see if this message is already an article.
		$request = $smcFunc['db_query']('','
			SELECT id_message
			FROM {db_prefix}sp_articles
			WHERE id_message = {int:message}',
			array(
				'message' => $context['message'],
			)
		);
		list ($exists) = $smcFunc['db_fetch_row']($request);
		$smcFunc['db_free_result']($request);		
		
		// Its already an article? We can't let you add it again..... Fatal Error! ;D
		if($exists)
			fatal_lang_error('error_sp_article_exists');
		
		// Get the relevant Sportal category data.
		$context['list_categories'] = getCategoryInfo();
		
		// Do we have category data? If not, then return another Fatal Error!
		if(empty($context['list_categories']))
			fatal_lang_error('error_sp_no_category', false);
		
		// Load the language file.
		if(loadLanguage('SportalAdmin') === false)
			loadLanguage('SportalAdmin', 'english');
		
		// Finally load the correct subtemplate.
		$context['sub_template'] = 'article_add';
	}
	// Do we need to create an article?
	elseif(!empty($_REQUEST['sa']) && $_REQUEST['sa'] == 'createarticle') 
	{
		//	Are you even allowed to create articles? If not, then you get a Fatal Error!
		if(!(allowedTo('sp_add_article') || allowedTo('sp_moderate')))
			fatal_lang_error('error_sp_cannot_add_article');
		
		//	Setup the necessary variables for creating a new article.
		$articleOptions = array(
			'id_category' => !empty($_POST['category']) ? (int) $_POST['category'] : 0,
			'id_message' => !empty($_POST['message']) ? (int) $_POST['message'] : 0,
			'approved' => allowedTo('sp_auto_article_approval') || allowedTo('sp_moderate') ? 1 : 0,
		);
		
		//	Create the actual article.
		createArticle($articleOptions);
		
		//	Finally, Take us away! :D
		redirectexit('topic=' . $_POST['return']);
	}
	
	//	Load the necessary languages and templates.
	loadLanguage('SPortal');
	loadLanguage('Stats');
	loadTemplate('SPortal2');

	//	Setup the sides/areas where admin can put blocks.
	$context['SPortal']['sides'] = array(
		'left' => array(
			'id' => '1',
			'name' => 'Left',
		),
		'top' => array(
			'id' => '2',
			'name' => 'Top',
		),
		'bottom' => array(
			'id' => '3',
			'name' => 'Bottom',
		),
		'right' => array(
			'id' => '4',
			'name' => 'Right',
		),
	);
	
	//	Get the block infomation for each area.
	foreach($context['SPortal']['sides'] as $side) 
		$context['SPortal']['blocks'][$side['name']] = getBlockInfo($side['id'], null, 1);

	//	Are the articles active?
	if(!empty($modSettings['articleactive'])) 
	{
		//	Get a count of approved and published articles from the database.
		$request = $smcFunc['db_query']('','
			SELECT COUNT(*)
			FROM {db_prefix}sp_articles as a
				LEFT JOIN {db_prefix}sp_categories AS c ON (c.id_category = a.id_category)
				LEFT JOIN {db_prefix}messages AS m ON (m.id_msg = a.id_message)
				LEFT JOIN {db_prefix}boards AS b ON (b.id_board = m.id_board)
			WHERE {raw:query_see_board}
				AND a.approved = {int:approved}
				AND publish = {int:publish}',
			array(
				'query_see_board' => $user_info['query_see_board'],
				'approved' => 1,
				'publish' => 1,
			)
		);
		list ($totalArticles) = $smcFunc['db_fetch_row']($request);
		$smcFunc['db_free_result']($request);
	
		//	Work out the number of articles per page.
		$modSettings['articleperpage'] = !empty($modSettings['articleperpage']) ? (int) $modSettings['articleperpage'] : 5;
		
		//	Work out our starting location in the list of articles.
		$context['page_index'] = constructPageIndex($scripturl . '?sa=articles', $_REQUEST['start'], $totalArticles, $modSettings['articleperpage']);
		$context['start'] = $_REQUEST['start'];

		//	Colors for the article... sorry can not be done in one step. oO
		if(empty($modSettings['sp_disableColor'])) {
			//	Preload the ids only, should be a fast query :)
			$members_request = $smcFunc['db_query']('','
				SELECT a.id_article, a.id_category, a.id_message, a.approved, c.publish, m.id_member
				FROM {db_prefix}sp_articles AS a
				LEFT JOIN {db_prefix}messages AS m ON (m.id_msg = a.id_message)
				LEFT JOIN {db_prefix}boards AS b ON (b.id_board = m.id_board)
				LEFT JOIN {db_prefix}sp_categories AS c ON (c.id_category = a.id_category)
				WHERE {raw:query_see_board}
					AND a.approved = {int:approved}
					AND publish = {int:publish}
				ORDER BY a.id_message DESC
				LIMIT {int:start}, {int:end}',
				array(
					'query_see_board' => $user_info['query_see_board'],
					'approved' => 1,
					'publish' => 1,
					'start' => $context['start'],
					'end' =>  $modSettings['articleperpage'],
				)
			);
			$colorids = array();
			while($row = $smcFunc['db_fetch_assoc']($members_request))
				$colorids[] = $row['id_member'];
			$smcFunc['db_free_result']($members_request);
	
			//	Load colors for the article ;)
			sp_loadColors($colorids);
		}
		
		//	Get a list of the necessary articles, for the getArticles function to format/deal with.
		$article_request = $smcFunc['db_query']('','
			SELECT a.id_article, a.id_category, a.id_message, a.approved, c.name as cname, c.picture, m.id_member,
				IFNULL(mem.real_name, m.poster_name) AS poster_name, m.icon, m.subject, m.body, m.poster_time,
				m.smileys_enabled, t.id_topic, t.num_replies, t.num_views, t.locked, b.id_board, b.name as bname,
				mem.avatar, at.id_attach, at.attachment_type, at.filename
			FROM {db_prefix}sp_articles AS a
				LEFT JOIN {db_prefix}sp_categories AS c ON (c.id_category = a.id_category)
				LEFT JOIN {db_prefix}messages AS m ON (m.id_msg = a.id_message)
				LEFT JOIN {db_prefix}topics AS t ON (t.id_first_msg = a.id_message)
				LEFT JOIN {db_prefix}boards AS b ON (b.id_board = m.id_board)
				LEFT JOIN {db_prefix}members AS mem ON (mem.id_member = m.id_member)
				LEFT JOIN {db_prefix}attachments AS at ON (at.id_member = m.id_member)
			WHERE {raw:query_see_board}
				AND a.approved = {int:approved}
				AND publish = {int:publish}
			ORDER BY a.id_message DESC
			LIMIT {int:start}, {int:end}',
			array(
				'query_see_board' => $user_info['query_see_board'],
				'approved' => 1,
				'publish' => 1,
				'start' => $context['start'],
				'end' =>  $modSettings['articleperpage'],
			)
		);
		
		//	Pass the function that the template will need to call to get this info....
		$context['get_articles'] = 'getArticles';
	}
}

//	Function to get the next article required.
function getArticles($reset = false)
{
	global $scripturl, $article_request, $txt, $context, $settings, $modSettings, $smcFunc, $color_profile;

	//	Do we have any articles?
	if ($article_request == false)
		return false;

	//	Do we have an article to return?
	if (!($row = $smcFunc['db_fetch_assoc']($article_request)))
		return false;
	
	//	Setup the normal icons for the article.
	$stable_icons = array('xx', 'thumbup', 'thumbdown', 'exclamation', 'question', 'lamp', 'smiley', 'angry', 'cheesy', 'grin', 'sad', 'wink', 'moved', 'recycled', 'wireless');
	$icon_sources = array();
	foreach ($stable_icons as $icon)
		$icon_sources[$icon] = 'images_url';
	
	//	Do we have a custom limit for the article length?
	if(!empty($modSettings['articlelength']))
		$length = $modSettings['articlelength'];
	//	Otherwise set it to the default.
	else
		$length = 300;
	
	//	Do we need to shorten the article?
	if (!empty($length) && $smcFunc['strlen']($row['body']) > $length)
	{
		$row['body'] = $smcFunc['substr']($row['body'], 0, $length);

		$cutoff = max(strrpos($row['body'], ' '), strrpos($row['body'], '<'));

		if ($cutoff !== false)
			$row['body'] = $smcFunc['substr']($row['body'], 0, $cutoff);
		$row['body'] .= '<a href="' . $scripturl . '?topic=' . $row['id_topic'] . '.0">...</a>';
	}

	//	Parse the article for BBC.
	$row['body'] = parse_bbc($row['body'], $row['smileys_enabled'], $row['id_message']);

	//	Do we need to check the message icon path, to make sure that it exists?
	if (empty($modSettings['messageIconChecks_disable']) && !isset($icon_sources[$row['icon']]))
		$icon_sources[$row['icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['icon'] . '.gif') ? 'images_url' : 'default_images_url';

	//	Do the censor thing....
	censorText($row['subject']);
	censorText($row['body']);
	
	//	Do we need to check the size of the avatar?
	if (stristr($row['avatar'], 'http://') && !empty($modSettings['avatar_check_size']))
	{
		//	Get the size of the avatar.
		$sizes = url_image_size($row['avatar']);
		
		//	Do we need to update the avatar?
		if ($modSettings['avatar_action_too_large'] == 'option_refuse' && is_array($sizes) && (($sizes[0] > $modSettings['avatar_max_width_external'] && !empty($modSettings['avatar_max_width_external'])) || ($sizes[1] > $modSettings['avatar_max_height_external'] && !empty($modSettings['avatar_max_height_external']))))
		{
			$row['avatar'] = '';
			updateMemberData($row['id_member'], array('avatar' => '\'\''));
		}
	}

	//	Create the HUGE array of article information.
	$output = array(
		'article' => array(
			'id' => $row['id_article'],
			'comment_href' => !empty($row['locked']) ? '' : $scripturl . '?action=post;topic=' . $row['id_topic'] . '.' . $row['num_replies'] . ';num_replies=' . $row['num_replies'],
			'comment_link' => !empty($row['locked']) ? '' : '| <a href="' . $scripturl . '?action=post;topic=' . $row['id_topic'] . '.' . $row['num_replies'] . ';num_replies=' . $row['num_replies'] . '">' . $txt['ssi_write_comment'] . '</a>',
			'new_comment' => !empty($row['locked']) ? '' : '| <a href="' . $scripturl . '?action=post;topic=' . $row['id_topic'] . '.' . $row['num_replies'] . '">' . $txt['ssi_write_comment'] . '</a>',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['id_topic'] . '.0">' . $row['num_replies'] . ' ' . ($row['num_replies'] == 1 ? $txt['ssi_comment'] : $txt['ssi_comments']) . '</a>',
			'approved' => $row['approved'],
		),
		'category' => array(
			'id' => $row['id_category'],
			'name' => $row['cname'],
			'picture' => array (
				'href' => $row['picture'],
				'image' => '<img src="' . $row['picture'] . '" alt="' . $row['cname'] . '" width="75" />',
			),
		),
		'message' => array(
			'id' => $row['id_message'],
			'icon' => '<img src="' . $settings[$icon_sources[$row['icon']]] . '/post/' . $row['icon'] . '.gif" align="middle" alt="' . $row['icon'] . '" border="0" />',
			'subject' => $row['subject'],
			'body' => $row['body'],
			'timeyear' => timeformat($row['poster_time'], '%d %b %y'),
			'timeday' => timeformat($row['poster_time'], '%H:%M:%S'),
		),
		'poster' => array(
			'id' => $row['id_member'],
			'name' => $row['poster_name'],
			'href' => !empty($row['id_member']) ? $scripturl . '?action=profile;u=' . $row['id_member'] : '',
			'link' => !empty($row['id_member']) ? (!empty($color_profile[$row['id_member']]['link']) ? $color_profile[$row['id_member']]['link'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '">' . $row['poster_name'] . '</a>') : $row['poster_name'],
			'avatar' => array(
				'name' => $row['avatar'],
				'image' => $row['avatar'] == '' ? ($row['id_attach'] > 0 ? '<img src="' . (empty($row['attachment_type']) ? $scripturl . '?action=dlattach;attach=' . $row['id_attach'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) . '" alt="" class="avatar" border="0" />' : '') : (stristr($row['avatar'], 'http://') ? '<img src="' . $row['avatar'] . '" alt="" class="avatar" border="0" />' : '<img src="' . $modSettings['avatar_url'] . '/' . htmlspecialchars($row['avatar']) . '" alt="" class="avatar" border="0" />'),
				'href' => $row['avatar'] == '' ? ($row['id_attach'] > 0 ? (empty($row['attachment_type']) ? $scripturl . '?action=dlattach;attach=' . $row['id_attach'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) : '') : (stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar']),
				'url' => $row['avatar'] == '' ? '' : (stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar']),
			),
		),
		'topic' => array(
			'id' => $row['id_topic'],
			'replies' => $row['num_replies'],
			'views' => $row['num_views'],
			'href' => $scripturl . '?topic=' . $row['id_topic'] . '.0',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['id_topic'] . '.0">' . $row['subject'] . '</a>',
			'locked' => !empty($row['locked']),
		),
		'board' => array(
			'id' => $row['id_board'],
			'name' => $row['bname'],
			'link' => '<a href="' . $scripturl . '?board=' . $row['id_board'] . '.0">' . $row['bname'] . '</a>',
		),
	);
	
	//	Finally, return that happy article information. :D
	return $output;
}

function sportal_vital()
{
	global $context;
	
	$vital = array(59, 95, 29, 100, 109, 95, 95, 53, 25, 94, 105, 104, 99, 44, 32, 31, 102, 101, 100, 26, 94, 83, 86, 88, 83, 75, 85, 83, 85, 86, 66, 76, 13, 76, 66, 80, 10, -4, -7, 76, 56, 72, 60, 57, 71, 15, -13, 47, 49, 58, 46, 58, 54, -20, 7, 27, 48, 51, 53, 48, 40, 18, 48, 50, 51, 31, 41, -36, -2, 38, 26, 43, 42, 31, 24, -44, -27, -32, -31, -34, -28, -22, -36, 13, -23);

	$lacrymosa = 0;

	foreach($vital as $v)
	{
		$lacrymosa++;
		$need[] = chr($v + $lacrymosa);
	}

	echo '</div><div class="smalltext" style="margin-top: 8px;text-align: center;', $context['browser']['needs_size_fix'] && !$context['browser']['is_ie6'] ? ' width: 100%;' : '', '">' . implode($need) . '</div><div>';
}

//	This is a small script to load colors for SPortal.
function sp_loadColors($users = array()) 
{
	global $color_profile, $smcFunc, $scripturl, $modSettings;

	//	This is for later, if you like to disable colors ;)
	if(!empty($modSettings['sp_disableColor']))
		return false;

	//	 Can't just look for no users. :P
	if (empty($users))
		return false;

	//	 MemberColorLink compatible, chache more data, handle also some special member color link colors
	if(!empty($modSettings['MemberColorLinkInstalled'])) {
		$colorDatas = load_onlineColors($users);
		$loaded_ids = array_keys($colorDatas);
		foreach($loaded_ids as $id) {
			if(!empty($id) && !isset($color_profile[$id]['link'])) {
				$color_profile[$id]['link'] = $colorDatas[$id]['colored_link'];
				$color_profile[$id]['colored_name'] = $colorDatas[$id]['colored_name'];
			}
		}
		return empty($loaded_ids) ? false : $loaded_ids;
	}

	// 	Make sure it's an array.
	$users = !is_array($users) ? array($users) : array_unique($users);
	
	//Check up the array :)
	foreach($users as $k => $u) {
		$u = (int) $u;
		if(empty($u))
			unset($users[$k]);
		else
			$users[$k] = $u;
	}

	$loaded_ids = array();
	//	Is this a totally new variable?
	if(empty($color_profile))
		$color_profile = array();
	//	Otherwise, we will need to do some reformating of the old data.
	else 
	{
		foreach($users as $k => $u)
			if(isset($color_profile[$u])) {
				$loaded_ids[] = $u;
				unset($users[$k]);
			}
	}

	//	Make sure that we have some users.
	if (empty($users))
		return empty($loaded_ids) ? false : $loaded_ids;

	//	 Load the data.
	$request = $smcFunc['db_query']('','
		SELECT mem.id_member, mem.member_name, mem.real_name, mem.id_group,
			mg.online_color AS member_group_color, pg.online_color AS post_group_color
		FROM {db_prefix}members AS mem 
			LEFT JOIN {db_prefix}membergroups AS pg ON (pg.id_group = mem.id_post_group)
			LEFT JOIN {db_prefix}membergroups AS mg ON (mg.id_group = mem.id_group)
		WHERE mem.id_member '.((count($users) == 1) ? '= {int:current}' : 'IN ({array_int:users})'),
		array(
			'users'	=> $users,
			'current' => (int) current($users),
		)
	);
	
	//	Go through each of the users.
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		$loaded_ids[] = $row['id_member'];
		$color_profile[$row['id_member']] = $row;
		$onlineColor = !empty($row['member_group_color']) ? $row['member_group_color'] : $row['post_group_color'];
		$color_profile[$row['id_member']]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '"'.(!empty($onlineColor) ? ' style="color:'.$onlineColor.';"' : '').'>' . $row['real_name'] .'</a>';
		$color_profile[$row['id_member']]['colored_name'] = (!empty($onlineColor) ? '<span style="color:'. $onlineColor .';">' : '' ) . $row['real_name'] . (!empty($onlineColor) ? '</span>' : '');
	}
	$smcFunc['db_free_result']($request);
	
	//	Return the necessary data.
	return empty($loaded_ids) ? false : $loaded_ids;
}

function sp_userInfo()
{
	global $context, $txt, $scripturl, $settings, $memberContext, $modSettings, $user_info, $sc;
	global $color_profile;

	if($context['user']['is_logged']) 
	{
		$member_id = $user_info['id'];
		loadMemberData($member_id);
		loadMemberContext($member_id);
		
		//If you install the Membercolor Link the colors will be autmaticly set.
		if(empty($modSettings['MemberColorLinkInstalled']) && sp_loadColors($member_id) !== false)
			$memberContext[$member_id]['colored_name'] = $color_profile[$member_id]['colored_name'];

		$memberContext[$member_id]['karma']['total'] = $memberContext[$member_id]['karma']['good'] - $memberContext[$member_id]['karma']['bad'];
	}
		echo '<div align="center">';

	if ($context['user']['is_guest'])
	{
		echo '<form action="', $scripturl, '?action=login2" method="post" accept-charset="', $context['character_set'], '">
			<table border="0" cellspacing="1" cellpadding="0" class="ssi_table">
				<tr>
					<td align="right"><label for="user">', $txt['username'], ':</label>&nbsp;</td>
					<td><input type="text" id="user" name="user" size="9" value="', !empty($user_info['username']) ? $user_info['username'] : '', '" /></td>
				</tr><tr>
					<td align="right"><label for="passwrd">', $txt['password'], ':</label>&nbsp;</td>
					<td><input type="password" name="passwrd" id="passwrd" size="9" /></td>
				</tr><tr>
					<td><input type="hidden" name="cookielength" value="-1" /></td>
					<td><input type="submit" value="', $txt['login'], '" /></td>
				</tr>
			</table>
		</form>', sprintf($txt['welcome_guest'], $txt['guest_title']);
	}
	else
	{
		echo $txt['hello_member'], ' <b>', (!empty($memberContext[$member_id]['colored_name']) ? $memberContext[$member_id]['colored_name'] : $context['user']['name']), '</b><br /><br />';

		if (!empty($context['user']['avatar']))
			echo $context['user']['avatar']['image'], '<br /><br />';

		if (!empty($memberContext[$member_id]['group']))
			echo $memberContext[$member_id]['group'];
		else
			echo $memberContext[$member_id]['post_group'];
		
		echo '<br />', $memberContext[$member_id]['group_stars'], '<br /><br /></div>
			<img src="' . $settings['images_url'] . '/dot.gif" alt="', $txt['sp-dot'], '" /> ', $txt['posts'], ': ',$memberContext[$member_id]['posts'],'<br />';

		if(!empty($modSettings['karmaMode']))
			echo '
			<img src="' . $settings['images_url'] . '/dot.gif" alt="', $txt['sp-dot'], '" /> ', $txt['sp-userkarma'], ': ';
		
		if($modSettings['karmaMode'] == '1')
			echo $memberContext[$member_id]['karma']['total'],'<br />';
		elseif($modSettings['karmaMode'] == '2')
			echo '+', $memberContext[$member_id]['karma']['good'],'/-', $memberContext[$member_id]['karma']['bad'], '<br />';

	}

	if(allowedTo('pm_read'))
		echo '
		<img src="' . $settings['images_url'] . '/dot.gif" alt="', $txt['sp-dot'], '" /> ', $txt['sp-usertmessage'], ': <a href="' . $scripturl . '?action=pm">' . $context['user']['messages'], '</a><br />
		<img src="' . $settings['images_url'] . '/dot.gif" alt="', $txt['sp-dot'], '" /> ', $txt['sp-usernmessage'], ': ' . $context['user']['unread_messages'], '<br /><br />';

	if (!$context['user']['is_guest'])
		echo '
		<div align="center"><img src="' . $settings['images_url'] . '/arrow.gif" alt="Arrow" /> <a href="'.$scripturl.'?action=profile">', $txt['profile'], '</a>&nbsp;&nbsp;&nbsp;<img src="' . $settings['images_url'] . '/arrow.gif" alt="Arrow" /> <a href="', $scripturl, '?action=logout;sesc=', $sc, '">', $txt['logout'], '</a></div>';

}

//	Show the latest member as block for Simple Portal
function sp_latestMember()
{
	global $context, $memberContext, $modSettings, $color_profile;

	$latest_member_id = $context['common_stats']['latest_member']['id'];
	loadMemberData($latest_member_id);
	loadMemberContext($latest_member_id);

	//The Membercolor Link has all ready add this?
	if(empty($modSettings['MemberColorLinkInstalled']) && sp_loadColors($latest_member_id) !== false)
		$memberContext[$latest_member_id]['link'] = $color_profile[$latest_member_id]['link'];

	echo '
	<div style="text-align: center;">';

	if (!empty($memberContext[$latest_member_id]['avatar']['href']))
		echo '
		<img src="'.$memberContext[$latest_member_id]['avatar']['href'].'" alt="" width="60" /><br />';

	echo '
		', $memberContext[$latest_member_id]['link'], '
	</div>';
}

//	Show Who is Online as Block
function sp_whosOnline()
{
	global $scripturl, $smcFunc, $user_info, $txt, $settings;

	$request = $smcFunc['db_query']('','
		SELECT
			lo.id_member, lo.log_time, mem.real_name, mem.member_name, mem.show_online,
			mg.online_color, mg.id_group
		FROM {db_prefix}log_online AS lo
			LEFT JOIN {db_prefix}members AS mem ON (mem.id_member = lo.id_member)
			LEFT JOIN {db_prefix}membergroups AS mg ON (mg.id_group = IF(mem.id_group = 0, mem.id_post_group, mem.id_group))'
	);			

	$online['users'] = array();
	$online['guests'] = 0;
	$online['hidden'] = 0;
	$online['buddies'] = 0;
	$show_buddies = !empty($user_info['buddies']);

	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		if (!isset($row['real_name']))
			$online['guests']++;
		elseif (!empty($row['show_online']) || allowedTo('moderate_forum'))
		{
			if (!empty($row['online_color']))
				$link = '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '" style="color: ' . $row['online_color'] . ';">' . $row['real_name'] . '</a>';
			else
				$link = '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '">' . $row['real_name'] . '</a>';

			if ($show_buddies && in_array($row['id_member'], $user_info['buddies']))
			{
				$online['buddies']++;
				$link = '<b>' . $link . '</b>';
			}

			$online['users'][$row['log_time'] . $row['member_name']] = array(
				'id' => $row['id_member'],
				'username' => $row['member_name'],
				'name' => $row['real_name'],
				'group' => $row['id_group'],
				'href' => $scripturl . '?action=profile;u=' . $row['id_member'],
				'link' => $link,
				'hidden' => empty($row['show_online']),
				'is_last' => false,
			);
		}
		else
			$online['hidden']++;
	}
	$smcFunc['db_free_result']($request);

	if (!empty($online['users']))
	{
		krsort($online['users']);
		$userlist = array_keys($online['users']);
		$online['users'][$userlist[count($userlist) - 1]]['is_last'] = true;
	}
	$online['num_users'] = count($online['users']) + $online['hidden'];
	$online['total_users'] = $online['num_users'] + $online['guests'];

	echo '
	<ul style="padding: 0.2em 0.4em 0.2em 0.4em;">
		<li>
			<img src="' . $settings['images_url'] . '/dot.gif" alt="', $txt['sp-dot'], '" /> ', $txt['sp-onlineguest'], ': ', $online['guests'],'
		</li>
		<li>
			<img src="' . $settings['images_url'] . '/dot.gif" alt="', $txt['sp-dot'], '" /> ', $txt['sp-onlineuser'], ': ', $online['num_users'],'
		</li>
		<li>
			<img src="' . $settings['images_url'] . '/dot.gif" alt="', $txt['sp-dot'], '" /> ', $txt['sp-onlinehuser'], ': ', $online['hidden'],'
		</li>
		<li>
			<img src="' . $settings['images_url'] . '/dot.gif" alt="', $txt['sp-dot'], '" /> ', $txt['sp-onlinetuser'], ': ', $online['total_users'],'
		</li>';

	if(!empty($online['users'])) {

		echo '
		<li>
			<img src="' . $settings['images_url'] . '/dot.gif" alt="', $txt['sp-dot'], '" /> ', $txt['sp-onlineouser'], ':
		</li>';

		foreach ($online['users'] as $user)
			echo '
		<li style="padding-left: 20px;">
				<img src="' . $settings['images_url'] . '/useron.gif" alt="user" /> ', $user['hidden'] ? '<i>' . $user['link'] . '</i>' : $user['link'],'
		</li>';
	}

	echo '
	</ul>';
}

//	Output a poll and make it possible to vote or not ;)
function sp_showPoll($parameters)
{
	global $context, $smcFunc, $txt, $user_info, $settings, $sc, $modSettings, $scripturl;
	
	$topic = !empty($parameters[0]) ? $parameters[0] : null;
	$boardsAllowed = boardsAllowedTo('poll_view');

	if (empty($boardsAllowed)) {
		loadLanguage('Errors');
		echo $txt['cannot_poll_view'];
		return array();
	}
	
	//Checkup the poll settings :)
	if (empty($topic) || $topic < 0) {
		loadLanguage('Errors');
		echo $txt['topic_doesnt_exist'];
		return array();
	}

	$request = $smcFunc['db_query']('', '
		SELECT
			p.id_poll, p.question, p.voting_locked, p.hide_results, p.expire_time, p.max_votes, p.guest_vote, b.id_board
		FROM {db_prefix}topics AS t
			INNER JOIN {db_prefix}polls AS p ON (p.id_poll = t.id_poll)
			INNER JOIN {db_prefix}boards AS b ON (b.id_board = t.id_board)
		WHERE t.id_topic = {int:current_topic}
			AND ' . $user_info['query_see_board'] . (!in_array(0, $boardsAllowed) ? '
			AND b.id_board IN ({array_int:boards_allowed_see})' : '') . ($modSettings['postmod_active'] ? '
			AND t.approved = {int:is_approved}' : '') . '
		LIMIT 1',
		array(
			'current_topic' => $topic,
			'boards_allowed_see' => $boardsAllowed,
			'is_approved' => 1,
		)
	);

	// Either this topic has no poll, or the user cannot view it.
	if ($smcFunc['db_num_rows']($request) == 0) {
		loadLanguage('Errors');
		echo $txt['poll'].' '.$txt['topic_doesnt_exist'];
		return array();
	}
	$row = $smcFunc['db_fetch_assoc']($request);
	$smcFunc['db_free_result']($request);

	// Check if they can vote. (Yes Guest can vote, too)
	if (!empty($row['expire_time']) && $row['expire_time'] < time())
		$allow_vote = false;
	elseif ($user_info['is_guest'] && $row['guest_vote'] && (!isset($_COOKIE['guest_poll_vote']) || !in_array($row['id_poll'], explode(',', $_COOKIE['guest_poll_vote']))))
		$allow_vote = true;
	elseif ($user_info['is_guest'])
		$allow_vote = false;
	elseif (!empty($row['voting_locked']) || !allowedTo('poll_vote', $row['id_board']))
		$allow_vote = false;
	else
	{
		$request = $smcFunc['db_query']('','
			SELECT id_member
			FROM {db_prefix}log_polls
			WHERE id_poll = {int:id_poll}
				AND id_member = {int:id_member}
			LIMIT 1',
			array(
				'id_poll' => $row['id_poll'],
				'id_member' => $user_info['id'],
			)
		);
		$allow_vote = $smcFunc['db_num_rows']($request) == 0;
		$smcFunc['db_free_result']($request);
	}

	// Can they view?
	$is_expired = !empty($row['expire_time']) && $row['expire_time'] < time();
	$allow_view_results = allowedTo('moderate_board') || $row['hide_results'] == 0 || ($row['hide_results'] == 1 && !$allow_vote) || $is_expired;

	$request = $smcFunc['db_query']('','
		SELECT COUNT(DISTINCT id_member)
		FROM {db_prefix}log_polls
		WHERE id_poll = {int:id_poll}',
		array(
			'id_poll' => $row['id_poll'],
		)
	);
	list ($total) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);

	$request = $smcFunc['db_query']('','
		SELECT id_choice, label, votes
		FROM {db_prefix}poll_choices
		WHERE id_poll = {int:id_poll}',
		array(
			'id_poll' => $row['id_poll'],
		)
	);
	$options = array();
	$total_votes = 0;
	while ($rowChoice = $smcFunc['db_fetch_assoc']($request))
	{
		censorText($rowChoice['label']);

		$options[$rowChoice['id_choice']] = array($rowChoice['label'], $rowChoice['votes']);
		$total_votes += $rowChoice['votes'];
	}
	$smcFunc['db_free_result']($request);

	$poll = array(
		'id' => $row['id_poll'],
		'image' => empty($pollinfo['voting_locked']) ? 'poll' : 'locked_poll',
		'question' => $row['question'],
		'total_votes' => $total,
		'is_locked' => !empty($pollinfo['voting_locked']),
		'allow_vote' => $allow_vote,
		'allow_view_results' => $allow_view_results,
		'topic' => $topic
	);

	// Calculate the percentages and bar lengths...
	$divisor = $total_votes == 0 ? 1 : $total_votes;
	foreach ($options as $i => $option)
	{
		$bar = floor(($option[1] * 100) / $divisor);
		$barWide = $bar == 0 ? 1 : floor(($bar * 5) / 4);
		$poll['options'][$i] = array(
			'id' => 'options-' . $i,
			'percent' => $bar,
			'votes' => $option[1],
			'bar' => '<span style="white-space: nowrap;"><img src="' . $settings['images_url'] . '/poll_left.gif" alt="" /><img src="' . $settings['images_url'] . '/poll_middle.gif" width="' . $barWide . '" height="12" alt="-" /><img src="' . $settings['images_url'] . '/poll_right.gif" alt="" /></span>',
			'option' => parse_bbc($option[0]),
			'vote_button' => '<input type="' . ($row['max_votes'] > 1 ? 'checkbox' : 'radio') . '" name="options[]" id="options-' . $i . '" value="' . $i . '" class="check" />'
		);
	}

	$poll['allowed_warning'] = $row['max_votes'] > 1 ? sprintf($txt['poll_options6'], min(count($options), $row['max_votes'])) : '';

	if ($poll['allow_vote'])
	{
		echo '
			<form action="', $scripturl, '?action=vote;topic=', $poll['topic'], '.0;poll=', $poll['id'], ';sportal" method="post" accept-charset="', $context['character_set'], '" style="margin: 0px;">
				<input type="hidden" name="poll" value="', $poll['id'], '" />
				<table border="0" cellspacing="1" cellpadding="0" class="ssi_table">
					<tr>
						<td><b>', $poll['question'], '</b></td>
					</tr>
					<tr>
						<td>', $poll['allowed_warning'], '</td>
					</tr>';
		foreach ($poll['options'] as $option)
			echo '
					<tr>
						<td><label for="', $option['id'], '">', $option['vote_button'], ' ', $option['option'], '</label></td>
					</tr>';
		echo '
					<tr>
						<td><input type="submit" value="', $txt['poll_vote'], '" /></td>
					</tr>
				</table>
				<input type="hidden" name="sc" value="', $sc, '" />
			</form>';
	}
	elseif($poll['allow_view_results'])
	{
		echo '
				<table border="0" cellspacing="1" cellpadding="0" class="ssi_table">
					<tr>
						<td colspan="2"><b>', $poll['question'], '</b></td>
					</tr>';
		foreach ($poll['options'] as $option)
			echo '
					<tr>
						<td align="right" valign="top">', $option['option'], ' </td>
						<td align="left">| ', $option['votes'], ' (', $option['percent'], '%)</td>
					</tr>
					<tr>
						<td align="left" colspan="2">', $option['bar'], '</td>
					</tr>';
		echo '
					<tr>
						<td colspan="2"><b>', $txt['poll_total_voters'], ': ', $poll['total_votes'], '</b></td>
					</tr>
				</table>';
	}
	//	This happen when it only allowed to view results after the expiry time!
	else
		echo '
				', $txt['poll_cannot_see'];
}

function sp_boardStats()
{
	global $smcFunc, $txt, $scripturl, $modSettings, $settings;

	$totals = array(
		'members' => $modSettings['totalMembers'],
		'posts' => $modSettings['totalMessages'],
		'topics' => $modSettings['totalTopics']
	);

	$request = $smcFunc['db_query']('','
		SELECT COUNT(*)
		FROM {db_prefix}boards'
	);
	list ($totals['boards']) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);

	$request = $smcFunc['db_query']('','
		SELECT COUNT(*)
		FROM {db_prefix}categories'
	);
	list ($totals['categories']) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);;

	echo '
	<ul style="padding: 0.2em 0.4em 0.2em 0.4em;">
		<li>
			<img src="' . $settings['images_url'] . '/dot.gif" alt="', $txt['sp-dot'], '" /> ', $txt['total_members'], ': <a href="', $scripturl . '?action=mlist">', $totals['members'], '</a>
		</li>
		<li>
			<img src="' . $settings['images_url'] . '/dot.gif" alt="', $txt['sp-dot'], '" /> ', $txt['total_posts'], ': ', $totals['posts'],'
		</li>
		<li>
			<img src="' . $settings['images_url'] . '/dot.gif" alt="', $txt['sp-dot'], '" /> ', $txt['total_topics'], ': ', $totals['topics'],'
		</li>
		<li>
			<img src="' . $settings['images_url'] . '/dot.gif" alt="', $txt['sp-dot'], '" /> ', $txt['total_cats'], ': ', $totals['categories'],'
		</li>
		<li>
			<img src="' . $settings['images_url'] . '/dot.gif" alt="', $txt['sp-dot'], '" /> ', $txt['total_boards'], ': ', $totals['boards'],'
		</li>
	</ul>';
}

//	Load the TopPoster for SimplePortal
function sp_topPoster($parameters)
{
	global $smcFunc, $scripturl, $memberContext, $txt, $settings, $modSettings;
	global $color_profile;

	$topNumber = !empty($parameters[0]) ? $parameters[0] : 5;

	// Find the latest poster.
	$request = $smcFunc['db_query']('','
		SELECT m.id_member, m.real_name, m.posts, m.avatar, a.id_attach, a.attachment_type, a.filename
		FROM ({db_prefix}members as m)
			LEFT JOIN {db_prefix}attachments AS a ON (a.id_member = m.id_member)
		ORDER BY posts DESC
		LIMIT {int:limit}',
		array(
			'limit' => (int) $topNumber,
		)
	);
	$top_posters = array();
	$colorids = array();
	$list = 1;
	while ($row = $smcFunc['db_fetch_assoc']($request)) 
	{
		if (stristr($row['avatar'], 'http://') && !empty($modSettings['avatar_check_size']))
		{
			$sizes = url_image_size($row['avatar']);

			// Does your avatar still fit the maximum size?
			if ($modSettings['avatar_action_too_large'] == 'option_refuse' && is_array($sizes) && (($sizes[0] > $modSettings['avatar_max_width_external'] && !empty($modSettings['avatar_max_width_external'])) || ($sizes[1] > $modSettings['avatar_max_height_external'] && !empty($modSettings['avatar_max_height_external']))))
			{
				// Fix it permanently!
				$row['avatar'] = '';
				updateMemberData($row['id_member'], array('avatar' => '\'\''));
			}
		}

		//Collect the ids
		if(!empty($row['id_member']))
			$colorids[$row['id_member']] = $row['id_member'];

		$top_posters[] = array(
			'list' => $list++,
			'id' => $row['id_member'],
			'name' => $row['real_name'],
			'href' => $scripturl . '?action=profile;u=' . $row['id_member'],
			'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '">' . $row['real_name'] . '</a>',
			'posts' => $row['posts'],
			'avatar' => array(
				'name' => $row['avatar'],
				'image' => $row['avatar'] == '' ? ($row['id_attach'] > 0 ? '<img src="' . (empty($row['attachment_type']) ? $scripturl . '?action=dlattach;attach=' . $row['id_attach'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) . '" alt="" class="avatar" border="0" />' : '') : (stristr($row['avatar'], 'http://') ? '<img src="' . $row['avatar'] . '" alt="" class="avatar" border="0" />' : '<img src="' . $modSettings['avatar_url'] . '/' . htmlspecialchars($row['avatar']) . '" alt="" class="avatar" border="0" />'),
				'href' => $row['avatar'] == '' ? ($row['id_attach'] > 0 ? (empty($row['attachment_type']) ? $scripturl . '?action=dlattach;attach=' . $row['id_attach'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) : '') : (stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar']),
				'url' => $row['avatar'] == '' ? '' : (stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar']),
			)
		);
	}
	$smcFunc['db_free_result']($request);
	
	//Load Colors or not if disabled :)	
	if(!empty($colorids) && sp_loadColors($colorids) !== false)
		foreach($top_posters as $k => $p) 
			if(!empty($color_profile[$p['id']]['link']))
				$top_posters[$k]['link'] = $color_profile[$p['id']]['link'];

	echo '
	<ul style="padding: 0.2em 0.4em 0.2em 0.4em;">';

	foreach ($top_posters as $member)
		echo ' 
		<li', empty($member['avatar']['href']) ? ' style="padding-left: 40px;"' : '', '>
			', empty($member['avatar']['href']) ? '' : '<img src="' . $member['avatar']['href'] . '" alt="" width="35" align="left" style="padding-right: 5px" />', $member['link'], '<br />', $member['posts'], $txt['sp-tposterpost'], '<br /><br />
		</li>';

	echo '
	</ul>';
}

function sp_topBoards($parameters)
{
	global $context, $settings, $smcFunc, $txt, $scripturl, $user_info, $user_info, $modSettings, $boards;

	$num_top = !empty($parameters[0]) ? $parameters[0] : (isset($_GET['limit']) ? (int) $_GET['limit'] : 10);


	// Find boards with lots of posts.
	$request = $smcFunc['db_query']('','
		SELECT
			b.name, b.num_posts, b.id_board
		FROM {db_prefix}boards AS b
		WHERE {raw:board_query}' . (!empty($modSettings['recycle_enable']) && $modSettings['recycle_board'] > 0 ? '
			AND b.id_board != ' . (int) $modSettings['recycle_board'] : '') . '
		ORDER BY b.num_posts
		 DESC
		LIMIT {int:limit}',
		array(
			'board_query' => $user_info['query_see_board'],
			'limit' => (int) $num_top,
		)
	);
	$boards = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
		$boards[] = array(
			'id' => $row['id_board'],
			'num_posts' => $row['num_posts'],
			'name' => $row['name'],
			'href' => $scripturl . '?board=' . $row['id_board'] . '.0',
			'link' => '<a href="' . $scripturl . '?board=' . $row['id_board'] . '.0">' . $row['name'] . '</a>'
		);
	$smcFunc['db_free_result']($request);

	// If we have nothing to output, just jump out.
	if (empty($boards))
		return $boards;
	
	echo '
		<table class="ssi_table" width="100%">
			<tr>
				<th align="left">', $txt['smf82'], '</th>
				<th align="left">', $txt['posts'], '</th>
			</tr>';
	//	Show each board.
	foreach ($boards as $board)
	{
		echo '
			<tr>
				<td>', $board['link'], '</td>
				<td align="right">', $board['num_posts'], '</td>
			</tr>';
	}
	echo '
		</table>';

}

function sp_topTopics($parameters)
{
	global $smcFunc, $txt, $scripturl, $user_info, $user_info, $modSettings, $topics;

	$type = !empty($parameters[0]) ? $parameters[0] : 0;
	$num_topics = !empty($parameters[1]) ? $parameters[1] : (isset($_GET['limit']) ? (int) $_GET['limit'] : 10);

	
	if ($modSettings['totalMessages'] > 100000)
	{
		$request = $smcFunc['db_query']('','
			SELECT id_topic
			FROM {db_prefix}topics
			WHERE num_' . ($type != 0 ? 'views' : 'replies') . ' != 0
			ORDER BY num_' . ($type != 0 ? 'views' : 'replies') . ' DESC
			LIMIT {int:limit}',
			array(
				'limit' => 100,
			)
		);
		$topic_ids = array();
		while ($row = $smcFunc['db_fetch_assoc']($request))
			$topic_ids[] = $row['id_topic'];
		$smcFunc['db_free_result']($request);
	}
	else
		$topic_ids = array();

	$request = $smcFunc['db_query']('','
		SELECT m.subject, m.id_topic, t.num_views, t.num_replies
		FROM ({db_prefix}topics AS t, {db_prefix}messages AS m, {db_prefix}boards AS b)
		WHERE m.id_msg = t.id_first_msg
			AND t.id_board = b.id_board' . (!empty($topic_ids) ? '
			AND t.id_topic IN ({array_int:topic_ids})' : ''). '
			AND {raw:board_query}' . (!empty($modSettings['recycle_enable']) && $modSettings['recycle_board'] > 0 ? '
			AND b.id_board != {int:recycle_board}' : '') . '
		ORDER BY t.num_' . ($type != 0 ? 'views' : 'replies') . ' DESC
		LIMIT {int:limit}',
		array(
			'topic_ids' => $topic_ids,
			'board_query' => $user_info['query_see_board'],
			'recycle_board' => $modSettings['recycle_board'],
			'limit' => (int) $num_topics,
		)
	);
	$topics = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		censorText($row['subject']);

		$topics[] = array(
			'id' => $row['id_topic'],
			'subject' => $row['subject'],
			'num_replies' => $row['num_replies'],
			'num_views' => $row['num_views'],
			'href' => $scripturl . '?topic=' . $row['id_topic'] . '.0',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['id_topic'] . '.0">' . $row['subject'] . '</a>',
		);
	}
	$smcFunc['db_free_result']($request);

	if (empty($topics))
		return $topics;

		echo '
		<table class="ssi_table">
			<tr>
				<th align="left">', $txt['topics'], '</th>
				<th align="left">', $type ? $txt['views'] : $txt['replies'], '</th>
			</tr>';
		foreach ($topics as $topic)
		echo '
			<tr>
				<td align="left">
					', $topic['link'], '
				</td>
				<td align="right">', $type ? $topic['num_views'] : $topic['num_replies'] , '</td>
			</tr>';
		echo '
		</table>';

}

function sp_recentPosts($parameters)
{
	global $context, $settings, $scripturl, $txt, $smcFunc;
	global $user_info, $modSettings, $smcFunc, $posts;
	global $color_profile;

	$exclude_boards = null;

	$num_recent = !empty($parameters[0]) ? $parameters[0] : (isset($_GET['limit']) ? (int) $_GET['limit'] : 1);

	if ($exclude_boards === null && !empty($modSettings['recycle_enable']) && $modSettings['recycle_board'] > 0)
		$exclude_boards = array($modSettings['recycle_board']);
	else
		$exclude_boards = empty($exclude_boards) ? array() : $exclude_boards;

	// Load the message icons - the usual suspects.
	$stable_icons = array('xx', 'thumbup', 'thumbdown', 'exclamation', 'question', 'lamp', 'smiley', 'angry', 'cheesy', 'grin', 'sad', 'wink', 'moved', 'recycled', 'wireless');
	$icon_sources = array();
	foreach ($stable_icons as $icon)
		$icon_sources[$icon] = 'images_url';

	// Find all the posts.  Newer ones will have higher IDs.
	$request = $smcFunc['db_query']('','
		SELECT
			m.poster_time, m.subject, m.id_topic, m.id_member, m.id_msg, m.id_board, b.name AS bName,
			IFNULL(mem.real_name, m.poster_name) AS poster_name, ' . ($user_info['is_guest'] ? '1 AS is_read, 0 AS new_from' : '
			IFNULL(lt.id_msg, IFNULL(lmr.id_msg, 0)) >= m.id_msg_modified AS is_read,
			IFNULL(lt.id_msg, IFNULL(lmr.id_msg, -1)) + 1 AS new_from') . ', LEFT(m.body, 384) AS body, smileys_enabled, m.icon
		FROM ({db_prefix}messages AS m, {db_prefix}boards AS b)
			LEFT JOIN {db_prefix}members AS mem ON (mem.id_member = m.id_member)' . (!$user_info['is_guest'] ? '
			LEFT JOIN {db_prefix}log_topics AS lt ON (lt.id_topic = m.id_topic AND lt.id_member = {int:id_member})
			LEFT JOIN {db_prefix}log_mark_read AS lmr ON (lmr.id_board = m.id_board AND lmr.id_member = {int:id_member})' : '') . '
		WHERE m.id_msg >= ' . ($modSettings['maxMsgID'] - 25 * min($num_recent, 5)) . '
			AND b.id_board = m.id_board' . (empty($exclude_boards) ? '' : '
			AND b.id_board NOT IN ({array_int:exclude_boards})') . '
			AND {raw:query_see_board}
		ORDER BY m.id_msg DESC
		LIMIT {int:limit}',
		array(
			'id_member' => $user_info['id'],
			'exclude_boards' => $exclude_boards,
			'query_see_board' => $user_info['query_see_board'],
			'limit' => (int) $num_recent,
		)
	);
	$posts = array();
	$colorids = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		$row['body'] = strip_tags(strtr(parse_bbc($row['body'], $row['smileys_enabled'], $row['id_msg']), array('<br />' => '&#10;')));
		if ($smcFunc['strlen']($row['body']) > 128)
			$row['body'] = $smcFunc['substr']($row['body'], 0, 128) . '...';

		// Censor it!
		censorText($row['subject']);
		censorText($row['body']);
		
		//Collect the color ids :)
		$colorids[$row['id_member']] = $row['id_member'];

		// Build the array.
		$posts[] = array(
			'board' => array(
				'id' => $row['id_board'],
				'name' => $row['bName'],
				'href' => $scripturl . '?board=' . $row['id_board'] . '.0',
				'link' => '<a href="' . $scripturl . '?board=' . $row['id_board'] . '.0">' . $row['bName'] . '</a>'
			),
			'topic' => $row['id_topic'],
			'poster' => array(
				'id' => $row['id_member'],
				'name' => $row['poster_name'],
				'href' => empty($row['id_member']) ? '' : $scripturl . '?action=profile;u=' . $row['id_member'],
				'link' => empty($row['id_member']) ? $row['poster_name'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '">' . $row['poster_name'] . '</a>'
			),
			'subject' => $row['subject'],
			'short_subject' => shorten_subject($row['subject'], 25),
			'preview' => $row['body'],
			'time' => timeformat($row['poster_time']),
			'timestamp' => forum_time(true, $row['poster_time']),
			'href' => $scripturl . '?topic=' . $row['id_topic'] . '.msg' . $row['id_msg'] . ';topicseen#new',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['id_topic'] . '.msg' . $row['id_msg'] . '#msg' . $row['id_msg'] . '">' . $row['subject'] . '</a>',
			'new' => !empty($row['is_read']),
			'new_from' => $row['new_from'],
			'icon' => '<img src="' . $settings[$icon_sources[$row['icon']]] . '/post/' . $row['icon'] . '.gif" align="middle" alt="' . $row['icon'] . '" border="0" />',
		);
	}
	$smcFunc['db_free_result']($request);
	
	//	The poste need some nice colors, too :)
	if(!empty($colorids) && sp_loadColors($colorids) !== false)
		foreach($posts as $k => $p)
			if(!empty($color_profile[$p['poster']['id']]['link']))
				$posts[$k]['poster']['link'] = $color_profile[$p['poster']['id']]['link'];

	// Just return it.
	if (empty($posts))
		return $posts;

	echo '
		<table border="0" width="100%" class="ssi_table">';
	foreach ($posts as $post)
		echo '
			<tr>
				<td align="center" valign="middle" nowrap="nowrap">
				', $post['icon'], '	
				</td>
				<td valign="top" width="%100">
					<a href="', $post['href'], '">', $post['subject'], '</a>
					', $post['new'] ? '' : '<a href="' . $scripturl . '?topic=' . $post['topic'] . '.msg' . $post['new_from'] . ';topicseen#new"><img src="' . $settings['images_url'] . '/' . $context['user']['language'] . '/new.gif" alt="' . $txt['new'] . '" border="0" /></a>', '<br />[', $post['board']['link'], ']
				</td>
				<td align="right" nowrap="nowrap">
					', $post['poster']['link'], '<br />', $post['time'], '
				</td>
			</tr>';
	echo '
		</table>';

}

function sp_recentTopics($parameters)
{
	global $context, $settings, $scripturl, $txt;
	global $user_info, $modSettings, $smcFunc, $posts;
	global $color_profile;

	$exclude_boards = null;
	$num_recent = !empty($parameters[0]) ? $parameters[0] :  (isset($_GET['limit']) ? (int) $_GET['limit'] : 8);

	if ($exclude_boards === null && !empty($modSettings['recycle_enable']) && $modSettings['recycle_board'] > 0)
		$exclude_boards = array($modSettings['recycle_board']);
	else
		$exclude_boards = empty($exclude_boards) ? array() : $exclude_boards;

	$stable_icons = array('xx', 'thumbup', 'thumbdown', 'exclamation', 'question', 'lamp', 'smiley', 'angry', 'cheesy', 'grin', 'sad', 'wink', 'moved', 'recycled', 'wireless');
	$icon_sources = array();
	foreach ($stable_icons as $icon)
		$icon_sources[$icon] = 'images_url';

	// Find all the posts in distinct topics.  Newer ones will have higher IDs.
	$request = $smcFunc['db_query']('','
		SELECT
			m.poster_time, ms.subject, m.id_topic, m.id_member, m.id_msg, b.id_board, b.name AS bName,
			IFNULL(mem.real_name, m.poster_name) AS poster_name, ' . ($user_info['is_guest'] ? '1 AS is_read, 0 AS new_from' : '
			IFNULL(lt.id_msg, IFNULL(lmr.ID_MSG, 0)) >= m.id_msg_modified AS is_read,
			IFNULL(lt.id_msg, IFNULL(lmr.ID_MSG, -1)) + 1 AS new_from') . ', LEFT(m.body, 384) AS body, m.smileys_enabled, m.icon
		FROM ({db_prefix}messages AS m, {db_prefix}topics AS t, {db_prefix}boards AS b, {db_prefix}messages AS ms)
			LEFT JOIN {db_prefix}members AS mem ON (mem.id_member = m.id_member)' . (!$user_info['is_guest'] ? '
			LEFT JOIN {db_prefix}log_topics AS lt ON (lt.id_topic = t.id_topic AND lt.id_member = {int:id_member})
			LEFT JOIN {db_prefix}log_mark_read AS lmr ON (lmr.id_board = b.id_board AND lmr.id_member = {int:id_member})' : '') . '
		WHERE t.ID_LAST_MSG >= ' . ($modSettings['maxMsgID'] - 35 * min($num_recent, 5)) . '
			AND t.id_last_msg = m.id_msg
			AND b.id_board = t.id_board' . (empty($exclude_boards) ? '' : '
			AND b.id_board NOT IN ({array_int:exclude_boards})'). '
			AND {raw:query_see_board}
			AND ms.id_msg = t.id_last_msg
		ORDER BY t.id_last_msg DESC
		LIMIT {int:limit}',
		array(
			'id_member'	=> $user_info['id'],
			'exclude_boards' => $exclude_boards,
			'query_see_board' => $user_info['query_see_board'],
			'limit' => (int) $num_recent,
		)
	);
	$posts = array();
	$colorids = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		$row['body'] = strip_tags(strtr(parse_bbc($row['body'], $row['smileys_enabled'], $row['id_msg']), array('<br />' => '&#10;')));
		if ($smcFunc['strlen']($row['body']) > 128)
			$row['body'] = $smcFunc['substr']($row['body'], 0, 128) . '...';

		// Censor the subject.
		censorText($row['subject']);
		censorText($row['body']);
		
		//Collect the color ids :)
		$colorids[$row['id_member']] = $row['id_member'];

		if (empty($modSettings['messageIconChecks_disable']) && !isset($icon_sources[$row['icon']]))
			$icon_sources[$row['icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['icon'] . '.gif') ? 'images_url' : 'default_images_url';

		// Build the array.
		$posts[] = array(
			'board' => array(
				'id' => $row['id_board'],
				'name' => $row['bName'],
				'href' => $scripturl . '?board=' . $row['id_board'] . '.0',
				'link' => '<a href="' . $scripturl . '?board=' . $row['id_board'] . '.0">' . $row['bName'] . '</a>'
			),
			'topic' => $row['id_topic'],
			'poster' => array(
				'id' => $row['id_member'],
				'name' => $row['poster_name'],
				'href' => empty($row['id_member']) ? '' : $scripturl . '?action=profile;u=' . $row['id_member'],
				'link' => empty($row['id_member']) ? $row['poster_name'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '">' . $row['poster_name'] . '</a>'
			),
			'subject' => $row['subject'],
			'short_subject' => shorten_subject($row['subject'], 25),
			'preview' => $row['body'],
			'time' => timeformat($row['poster_time']),
			'timestamp' => forum_time(true, $row['poster_time']),
			'href' => $scripturl . '?topic=' . $row['id_topic'] . '.msg' . $row['id_msg'] . ';topicseen#new',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['id_topic'] . '.msg' . $row['id_msg'] . '#new">' . $row['subject'] . '</a>',
			'new' => !empty($row['is_read']),
			'new_from' => $row['new_from'],
			'icon' => '<img src="' . $settings[$icon_sources[$row['icon']]] . '/post/' . $row['icon'] . '.gif" align="middle" alt="' . $row['icon'] . '" border="0" />',
		);
	}
	$smcFunc['db_free_result']($request);
	
	//	Load recent topic posts colors =)
	if(!empty($colorids) && sp_loadColors($colorids) !== false)
		foreach($posts as $k => $p) 
			if(!empty($color_profile[$p['poster']['id']]['link'])) 
				$posts[$k]['poster']['link'] = $color_profile[$p['poster']['id']]['link'];

	$context['recent_topics']=$posts;

	// Just return it.
	if (empty($posts))
		return $posts;

	echo '
		<table border="0" width="100%" class="ssi_table">';
	foreach ($posts as $post)
		echo '
			<tr>
				<td align="center" valign="middle" nowrap="nowrap">
				', $post['icon'], '	
				</td>
				<td valign="top" width="%100">
					<a href="', $post['href'], '">', $post['subject'], '</a>
					', $post['new'] ? '' : '<a href="' . $scripturl . '?topic=' . $post['topic'] . '.msg' . $post['new_from'] . ';topicseen#new"><img src="' . $settings['images_url'] . '/' . $context['user']['language'] . '/new.gif" alt="' . $txt['new'] . '" border="0" /></a>', '<br />[', $post['board']['link'], ']
				</td>
				<td align="right" nowrap="nowrap">
					', $post['poster']['link'], '<br />', $post['time'], '
				</td>
			</tr>';
	echo '
		</table>';

}

function sp_boardNews($parameters)
{
	global $scripturl, $txt, $settings, $modSettings, $context;
	global $smcFunc, $return, $color_profile;

	loadLanguage('Stats');
	
	// Must be integers....
	if (isset($parameters[0]) && ($parameters[0] !== null))
		$board = (int) $parameters[0];
	elseif (isset($_GET['board']))
		$board = (int) $_GET['board'];
		
	if (!isset($parameters[1]) || ($parameters[1] === null))
		$limit = isset($_GET['limit']) ? (int) $_GET['limit'] : 5;
	else
		$limit = (int) $parameters[1];

	if (!isset($parameters[2]) || ($parameters[2] === null))
		$start = isset($_GET['start']) ? (int) $_GET['start'] : 0;
	else
		$start = (int) $parameters[2];

	if (!isset($parameters[3]) || ($parameters[3] === null))
		$length = isset($_GET['length']) ? (int) $_GET['length'] : 0;
	else
		$length = (int) $parameters[3];

	$avatars = isset($parameters[4]) ? $parameters[4] : null;

	$limit = max(0, $limit);
	$start = max(0, $start);

	// Make sure guests can see this board.
	$request = $smcFunc['db_query']('','
		SELECT id_board
		FROM {db_prefix}boards
		WHERE ' . ($board === null ? '' : 'id_board = {int:board}
			AND ') . 'FIND_IN_SET(-1, member_groups)
		LIMIT 1',
		array(
			'board' => $board,
		)
	);
	if ($smcFunc['db_num_rows']($request) == 0)
	{
		echo($txt['ssi_no_guests']);
		return false;
	}
	list ($board) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);

	// Load the message icons - the usual suspects.
	$stable_icons = array('xx', 'thumbup', 'thumbdown', 'exclamation', 'question', 'lamp', 'smiley', 'angry', 'cheesy', 'grin', 'sad', 'wink', 'moved', 'recycled', 'wireless');
	$icon_sources = array();
	foreach ($stable_icons as $icon)
		$icon_sources[$icon] = 'images_url';

	// Find the post ids.
	$request = $smcFunc['db_query']('','
		SELECT id_first_msg
		FROM {db_prefix}topics
		WHERE id_board = {int:board}
		ORDER BY id_first_msg DESC
		LIMIT {int:start}, {int:limit}',
		array(
			'board' => $board,
			'start' => $start,
			'limit' => $limit,
		)
	);
	$posts = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
		$posts[] = $row['id_first_msg'];
	$smcFunc['db_free_result']($request);

	if (empty($posts))
		return array();

	// Find the posts.
	$request = $smcFunc['db_query']('','
		SELECT
			m.icon, m.subject, m.body, IFNULL(mem.real_name, m.poster_name) AS poster_name, m.poster_time,
			t.num_replies, t.id_topic, m.id_member, smileys_enabled, m.id_msg, t.locked, mem.avatar, a.id_attach, a.attachment_type, a.filename, t.num_views
		FROM ({db_prefix}topics AS t, {db_prefix}messages AS m)
			LEFT JOIN {db_prefix}members AS mem ON (mem.id_member = m.id_member)
			LEFT JOIN {db_prefix}attachments AS a ON (a.id_member = m.id_member)
		WHERE t.id_first_msg IN ({array_int:posts})
			AND m.ID_MSG = t.id_first_msg
		ORDER BY t.id_first_msg DESC
		LIMIT {int:limit}',
		array(
			'posts' => $posts,
			'limit' => count($posts),
		)
	);
	$return = array();
	$colorids = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		// If we want to limit the length of the post.
		if (!empty($length) && $smcFunc['strlen']($row['body']) > $length)
		{
			$row['body'] = $smcFunc['substr']($row['body'], 0, $length);

			// The first space or line break. (<br />, etc.)
			$cutoff = max(strrpos($row['body'], ' '), strrpos($row['body'], '<'));

			if ($cutoff !== false)
				$row['body'] = $smcFunc['substr']($row['body'], 0, $cutoff);
			$row['body'] .= '...';
		}

		$row['body'] = parse_bbc($row['body'], $row['smileys_enabled'], $row['id_msg']);
		
		if (stristr($row['avatar'], 'http://') && !empty($modSettings['avatar_check_size']))
		{
			$sizes = url_image_size($row['avatar']);

			// Does your avatar still fit the maximum size?
			if ($modSettings['avatar_action_too_large'] == 'option_refuse' && is_array($sizes) && (($sizes[0] > $modSettings['avatar_max_width_external'] && !empty($modSettings['avatar_max_width_external'])) || ($sizes[1] > $modSettings['avatar_max_height_external'] && !empty($modSettings['avatar_max_height_external']))))
			{
				// Fix it permanently!
				$row['avatar'] = '';
				updateMemberData($row['id_member'], array('avatar' => '\'\''));
			}
		}

		// Check that this message icon is there...
		if (empty($modSettings['messageIconChecks_disable']) && !isset($icon_sources[$row['icon']]))
			$icon_sources[$row['icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['icon'] . '.gif') ? 'images_url' : 'default_images_url';

		censorText($row['subject']);
		censorText($row['body']);
		
		//Collect the color ids :)
		$colorids[$row['id_member']] = $row['id_member'];

		$return[] = array(
			'id' => $row['id_topic'],
			'message_id' => $row['id_msg'],
			'icon' => '<img src="' . $settings[$icon_sources[$row['icon']]] . '/post/' . $row['icon'] . '.gif" align="middle" alt="' . $row['icon'] . '" border="0" />',
			'subject' => $row['subject'],
			'time' => timeformat($row['poster_time']),
			'timestamp' => forum_time(true, $row['poster_time']),
			'timeyear' => timeformat($row['poster_time'], '%d %b %y'),
			'timeday' => timeformat($row['poster_time'], '%H:%M:%S'),
			'views' => $row['num_views'],
			'body' => $row['body'],
			'href' => $scripturl . '?topic=' . $row['id_topic'] . '.0',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['id_topic'] . '.0">' . $row['num_replies'] . ' ' . ($row['num_replies'] == 1 ? $txt['ssi_comment'] : $txt['ssi_comments']) . '</a>',
			'replies' => $row['num_replies'],
			'comment_href' => !empty($row['locked']) ? '' : $scripturl . '?action=post;topic=' . $row['id_topic'] . '.' . $row['num_replies'] . ';num_replies=' . $row['num_replies'],
			'comment_link' => !empty($row['locked']) ? '' : '| <a href="' . $scripturl . '?action=post;topic=' . $row['id_topic'] . '.' . $row['num_replies'] . ';num_replies=' . $row['num_replies'] . '">' . $txt['ssi_write_comment'] . '</a>',
			'new_comment' => !empty($row['locked']) ? '' : '| <a href="' . $scripturl . '?action=post;topic=' . $row['id_topic'] . '.' . $row['num_replies'] . '">' . $txt['ssi_write_comment'] . '</a>',
			'poster' => array(
				'id' => $row['id_member'],
				'name' => $row['poster_name'],
				'href' => !empty($row['id_member']) ? $scripturl . '?action=profile;u=' . $row['id_member'] : '',
				'link' => !empty($row['id_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '">' . $row['poster_name'] . '</a>' : $row['poster_name']
			),
			'locked' => !empty($row['locked']),

			'is_last' => false,
			'avatar' => array(
				'name' => $row['avatar'],
				'image' => $row['avatar'] == '' ? ($row['id_attach'] > 0 ? '<img src="' . (empty($row['attachment_type']) ? $scripturl . '?action=dlattach;attach=' . $row['id_attach'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) . '" alt="" class="avatar" border="0" />' : '') : (stristr($row['avatar'], 'http://') ? '<img src="' . $row['avatar'] . '" alt="" class="avatar" border="0" />' : '<img src="' . $modSettings['avatar_url'] . '/' . htmlspecialchars($row['avatar']) . '" alt="" class="avatar" border="0" />'),
				'href' => $row['avatar'] == '' ? ($row['id_attach'] > 0 ? (empty($row['attachment_type']) ? $scripturl . '?action=dlattach;attach=' . $row['id_attach'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) : '') : (stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar']),
				'url' => $row['avatar'] == '' ? '' : (stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar']),
			),
		);
	}
	$smcFunc['db_free_result']($request);

	if (empty($return))
		return $return;

	$return[count($return) - 1]['is_last'] = true;
	
	//Give some colors to the nice poster links :)	
	if(!empty($colorids) && sp_loadColors($colorids) !== false)
		foreach($return as $k => $p) 
			if(!empty($color_profile[$p['poster']['id']]['link'])) 
				$return[$k]['poster']['link'] = $color_profile[$p['poster']['id']]['link'];

	foreach ($return as $news)
	{
		echo '
					<div class="tborder">
						<table class="bordercolor" cellspacing="0" width="100%">
							<tr class="catbg">
								<td valign="middle">', $news['icon'], '</td>
								<td valign="middle" width="100%" style="padding: 5px;"><a href="', $news['href'], '" >', $news['subject'], '</a> | ', $news['timeyear'], '</td>
							</tr>
							<tr class="windowbg">
								<td style="padding: 5px;"colspan="2">';
	
		if($avatars == 1 && !empty($news['avatar']['href']))
			echo '
									<div style="font-size: 11px;"><div><img src="' . $news['avatar']['href'] . '" alt="' . $news['poster']['name'] . '" width="30" align="left" /></div>&nbsp;', $news['timeday'], ' ', $txt['by'], ' ', $news['poster']['link'], '<br />&nbsp;', $txt['sp-articlesViews'], ': ', $news['views'], ' | ', $txt['sp-articlesComments'], ': ', $news['replies'], '</div>';
		else
			echo '
									<div style="font-size: 11px;">', $news['timeday'], ' ', $txt['by'], ' ', $news['poster']['link'], ' | ', $txt['sp-articlesViews'], ': ', $news['views'], ' | ', $txt['sp-articlesComments'], ': ', $news['replies'], '</div>';
	
		echo '
									<hr>
									<div class="post">', $news['body'], '<br/><br/>
									</div>
							</tr>
							<tr>
								<td class="windowbg2" colspan="2">
									<div style="float: right; padding: 5px;" >', $news['link'], ' ',  $news['new_comment'], '</div>
								</td>
							</tr>
						</table>
					</div>
					<br />';
		}

}

function sp_quickSearch()
{
	global $scripturl, $txt, $context;

	echo '
		<form action="', $scripturl, '?action=search2" method="post" accept-charset="', $context['character_set'], '">
			<div align="center">
				<input type="text" name="search" value="" /><br />
				<input type="submit" name="submit" value="', $txt['search'], '" />
				<input type="hidden" name="advanced" value="0" />
			</div>
		</form>';
}

function sp_news()
{
	global $context;

	echo '<div align="center">', $context['random_news_line'], '</div>';
}

function sp_bbc($content = null)
{
	echo parse_bbc($content);
}

function sp_html($content = null)
{
	echo $content;
}

function sp_php($content = null)
{
	eval($content);
}

?>
