<?php
/*
File: SPortal2.template.php
Version: Simple Portal Classic 2.0.5 for SMF 2 Beta 4.
*/

function template_main()
{
	global $txt, $context, $modSettings;

	sp_collapse_script();

	echo '
	<table cellpadding="5px" width="100%">
		<tr>';
	
	if(!empty($modSettings['showleft']) && !empty($context['SPortal']['blocks']['Left'])) 
	{
		echo '
			<td valign="top"', !empty($modSettings['leftwidth']) ? ' width="' . $modSettings['leftwidth'] . '"' : '', '>';
		
		foreach ($context['SPortal']['blocks']['Left'] as $block) {
			template_block($block);
		}
		echo '
			</td>';
	}

	echo '
			<td valign="top">';

	foreach ($context['SPortal']['blocks']['Top'] as $block) {
			template_block($block);
	}

	while (!empty($modSettings['articleactive']) && $article = $context['get_articles']())
	{
		echo '
				<div class="tborder">
					<table class="bordercolor" cellspacing="0" width="100%">
						<tr class="catbg">
							<td valign="middle">', $article['message']['icon'], '</td>
							<td valign="middle" width="100%" style="padding: 5px;">', $article['topic']['link'], ' | ', $article['message']['timeyear'], '</td>
						</tr>
						<tr class="windowbg">
							<td style="padding: 5px;"colspan="2">';

		if(!empty($modSettings['articleavatar']) && !empty($article['poster']['avatar']['href']))
			echo '
								<div style="font-size: 11px;"><div><img src="' . $article['poster']['avatar']['href'] . '" alt="' . $article['poster']['name'] . '" width="30" align="left" /></div>&nbsp;', $article['message']['timeday'], ' ', $txt['by'], ' ', $article['poster']['link'], '<br />&nbsp;', $txt['sp-articlesViews'], ': ', $article['topic']['views'], ' | ', $txt['sp-articlesComments'], ': ', $article['topic']['replies'], '</div>';
		else
			echo '
								<div style="font-size: 11px;">', $article['message']['timeday'], ' ', $txt['by'], ' ', $article['poster']['link'], ' | ', $txt['sp-articlesViews'], ': ', $article['topic']['views'], ' | ', $txt['sp-articlesComments'], ': ', $article['topic']['replies'], '</div>';

		echo '
								<hr />
								<div class="post">', !empty($article['category']['picture']['href']) ? '<div><img src="' . $article['category']['picture']['href'] . '" alt="' . $article['category']['name'] . '" width="90" align="right" /></div>' : '', $article['message']['body'], '<br/><br/>
								</div>
						</tr>
						<tr>
							<td class="windowbg2" colspan="2">
								<div style="float: right; padding: 5px;" >', $article['article']['link'], ' ',  $article['article']['new_comment'], '</div>
							</td>
						</tr>
					</table>
				</div>
				<br />';
	}

	if(!empty($modSettings['articleactive']))
		echo '<div align="center">', $txt['sp-articlesPages'], ': ', $context['page_index'], '<br /><br /></div>';

	foreach ($context['SPortal']['blocks']['Bottom'] as $block) {
			template_block($block);
	}
	echo '
			</td>';

	if(!empty($modSettings['showright']) && !empty($context['SPortal']['blocks']['Right'])) 
	{
		echo '
			<td valign="top"', !empty($modSettings['rightwidth']) ? ' width="' . $modSettings['rightwidth'] . '"' : '', '>';

		foreach ($context['SPortal']['blocks']['Right'] as $block) {
			template_block($block);
		}

		echo '
			</td>';
	}
	echo '
		</tr>
	</table>';
}

function template_article_add()
{
	global $context, $scripturl, $txt;

	echo '<br />
	<table border="0" align="center" cellspacing="1" cellpadding="4" class="tborder" width="40%">
		<tr class="catbg">
			<td>', $txt['sp-articlesAdd'], '</td>
		</tr>
		<tr class="windowbg2">
			<td align="center">
				<form action="', $scripturl, '?sa=createarticle" method="post" accept-charset="', $context['character_set'], '">
					<table cellpadding="4">
						<tr>
							<th align="right">', $txt['sp-articlesCategory'], ':</th>
							<td align="left">
								<select id="category" name="category">';
								foreach($context['list_categories'] as $category) {
									echo '
									<option value="' . $category['id'] . '">' . $category['name'] . '</option>';
								}
								echo '
								</select>
							</td>
						</tr><tr>
							<td colspan="2" align="center"><input type="submit" name="add_article" value="', $txt['sp-articlesAdd'], '" /></td>
						</tr>
					</table>
				<input type="hidden" name="return" value="', $context['return'], '" />
				<input type="hidden" name="message" value="', $context['message'], '" />
				<input type="hidden" name="sc" value="', $context['session_id'], '" />
				</form>
			</td>
		</tr>
	</table>';
}

function template_block($block)
{
	global $settings;
	//The user is not allowed to collapse this?
	if(empty($block['force_view']))
		$block['collapsed'] = sp_collapse_state('sp_block' . $block['id']);
	else
		$block['collapsed'] = false;

	echo '
				<div class="tborder">
					<table class="bordercolor" width="100%">
						<tr class="catbg">
							<td style="padding: 5px;"><span style="float: left;">', $block['label'], '</span>';
	if(empty($block['force_view']))						
		echo '
							<a style="float:right;" href="javascript:void(0);" onclick="doCollapseObject(\'sp_block' . $block['id'], '\', \'', $settings['csect_cookie'], '\')"><img id="img_sp_block', $block['id'], '" src="', $settings['images_url'], $block['collapsed'] ? '/expand.gif' : '/collapse.gif', '" alt="*" border="0" /></a>';
	echo '
							</td>
						</tr>
						<tr class="windowbg" ', (empty($block['force_view']) ? 'id="sp_block' . $block['id'] . '"' : '') , $block['collapsed'] ? ' style="display:none;"' : '', '>
							<td style="padding: 5px;">';

	if(in_array($block['type'], array('sp_bbc', 'sp_html', 'sp_php')))
	{
		$block['type']($block['content']);
	}
	else
	{
		$parameters = explode(',', $block['parameters']);
		$block['type']($parameters);
	}

	echo '
							</td>
						</tr>
					</table>
				</div>

				<br />';
}

function sp_collapse_state($block_id)
{
	global $settings;

	if(isset($settings['collapsed_sects']) && !empty($settings['collapsed_sects']))
	{
		if(array_search($block_id, $settings['collapsed_sects']) === false)
			return false;
		else
			return true;
	}
	return false;
}

function sp_collapse_script()
{
	global $settings, $context;

	$csect_cookie = 'SMF_user_' . $context['user']['id'] . '_CSect';

	if(isset($_COOKIE[$csect_cookie]) && !empty($_COOKIE[$csect_cookie]))
	    $settings['collapsed_sects'] = explode("\n", $_COOKIE[$csect_cookie]);
	$settings['csect_cookie'] = $csect_cookie;

	echo'
<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[

var dom_engine = \'\';
if (document.getElementById)
	dom_engine = 1;					// mozilla, opera etc..
else if (document.all)
	dom_engine = 0;					// IE (pls die, kthx)
else if (document.layers)
	dom_engine = 2;					// NS4, should never happen :P

var active_menu = "";
var mouse_over_menu = "";

function getObject(id)
{
	if(dom_engine == 1)
		obj = document.getElementById(id);
	else if(dom_engine == 0)
		obj = document.all[id];
	else if(dom_engine == 2)
		obj = document.layers[id];
		
	return obj;
}

function getCookieFromDocument(cookie_name)
{
	cname = cookie_name + "=";
	clength = document.cookie.length;
	begin = 0;
	
	while (begin < clength) {
	    vbegin = begin + cname.length;
	    if (document.cookie.substring(begin, vbegin) == cname) {
		var end = document.cookie.indexOf (";", vbegin);
		if (end == -1) {
		    end = clength;
		}
		return unescape(document.cookie.substring(vbegin, end));
	    }
	    begin = document.cookie.indexOf(" ", begin) + 1;
	    if (begin == 0)	{
		break;
	    }
	}
	return null;
}

function setCookieToDocument(cookie_name, cookie_expiredate, cookie_value)
{
    document.cookie=cookie_name+"="+escape(cookie_value)+"; expires="+cookie_expiredate.toGMTString()+"; path=/";
}

function saveObjectToCookie(obj, mode, cookiename)
{
	var already_collapsed=getCookieFromDocument(cookiename);
	var temp = new Array();
	cookieExpireDate = new Date();
	cookieExpireDate.setTime(cookieExpireDate.getTime() + 86400*1000*300);			// 300 days expiration date

	if (already_collapsed) {
	    already_collapsed = already_collapsed.split("\n");

	    for (i in already_collapsed) {
		if (already_collapsed[i] != obj && already_collapsed[i] != "")
		    temp[temp.length] = already_collapsed[i];
	    }
	}

	if (mode)
	    temp[temp.length] = obj;

	setCookieToDocument(cookiename, cookieExpireDate, temp.join("\n"));
}

function doCollapseObject(id, cookiename)
{
	obj = getObject(id);	
	imageid = getObject("img_" + id);
	tempobj = getObject(id);
			
	if (obj.style.display == "none") {	// object is collapsed, show it, clear the cookie
	    obj.style.display = "";
	    saveObjectToCookie(id, 0, cookiename);
	    if (imageid) {
		imageid.src = imageid.src.replace(\'expand.gif\', \'collapse.gif\');
	    }
	} else {				// hide the object, save it to the cookie
	    obj.style.display = "none";
	    saveObjectToCookie(id, 1, cookiename);
	    if (imageid) {
		imageid.src = imageid.src.replace(\'collapse.gif\', \'expand.gif\');
	    }
	}
	return false;
}
	// ]]></script>';
}

?>