<?php

if (!defined('SMF'))
	die('Hacking attempt...');

/*
File: SPortalAdmin1-1.php
Version: Simple Portal Classic 2.0.5 for SMF 1.1

SPortalAdmin()
GeneralSettings()
BlockList()
BlockAdd()
BlockEdit()
BlockDelete()
BlockMove()
CategoryList()
CategoryAdd()
CategoryEdit()
CategoryDelete()
ArticleList()
getArticleEntry()
ArticleAdd()
ArticleEdit()
ArticleDelete()
StateChange()

*/

// Main function handling all the actions.
function SPortalAdmin()
{
	global $context, $txt, $scripturl, $sourcedir;

	// Can you moderate it my dear?
	isAllowedTo('sp_moderate');
	
	// Set the index to recognize.
	adminIndex('sportal');

	// Love this template. :)
	loadTemplate('SPortalAdmin1-1');

	// This is only in SMF 1.1.x needed.
	if(loadLanguage('SPortalAdmin', '', false) === false)
			loadLanguage('SPortalAdmin', 'english');
	
	// Rather a *small* one, yeah? :P
	$subActions = array(
		'generalsettings' => 'GeneralSettings',
		'blocklist' => 'BlockList',
		'blockadd' => 'BlockEdit',
		'blockedit' => 'BlockEdit',
		'blockdelete' => 'BlockDelete',
		'blockmove' => 'BlockMove',
		'categorylist' => 'CategoryList',
		'categoryadd' => 'CategoryAdd',
		'categoryedit' => 'CategoryEdit',
		'categorydelete' => 'CategoryDelete',
		'articlelist' => 'ArticleList',
		'articleadd' => 'ArticleAdd',
		'articleedit' => 'ArticleEdit',
		'articledelete' => 'ArticleDelete',
		'statechange' => 'StateChange',
	);

	// Set the default as the general settings.
	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'generalsettings';

	$context['page_title'] = $txt['sp-adminTitle'];
	$context['sub_action'] = $_REQUEST['sa'];

	$context['admin_tabs'] = array(
		'title' => $txt['sp-adminCatTitle'],
		'help' => $txt['sp-adminCatHelp'],
		'description' => $txt['sp-adminCatDesc'],
		'tabs' => array(
			'settings' => array(
				'title' => $txt['sp-adminGeneralSettingsName'],
				'description' => $txt['sp-adminGeneralSettingsDesc'],
				'href' => $scripturl . '?action=spadmin;sa=generalsettings',
				'is_selected' => $_REQUEST['sa'] == 'generalsettings',
			),
			'blocklist' => array(
				'title' => $txt['sp-adminBlockListName'],
				'description' => $txt['sp-adminBlockListDesc'],
				'href' => $scripturl . '?action=spadmin;sa=blocklist',
				'is_selected' => $_REQUEST['sa'] == 'blocklist' || $_REQUEST['sa'] == 'blockedit',
			),
			'blockadd' => array(
				'title' => $txt['sp-adminBlockAddName'],
				'description' => $txt['sp-adminBlockAddDesc'],
				'href' => $scripturl . '?action=spadmin;sa=blockadd',
				'is_selected' => $_REQUEST['sa'] == 'blockadd',
			),
			'articlelist' => array(
				'title' => $txt['sp-adminArticleListName'],
				'description' => $txt['sp-adminArticleListDesc'],
				'href' => $scripturl . '?action=spadmin;sa=articlelist',
				'is_selected' => $_REQUEST['sa'] == 'articlelist' || $_REQUEST['sa'] == 'articleedit',
			),
			'articleadd' => array(
				'title' => $txt['sp-adminArticleAddName'],
				'description' => $txt['sp-adminArticleAddDesc'],
				'href' => $scripturl . '?action=spadmin;sa=articleadd',
				'is_selected' => $_REQUEST['sa'] == 'articleadd',
			),
			'categorylist' => array(
				'title' => $txt['sp-adminCategoryListName'],
				'description' => $txt['sp-adminCategoryListDesc'],
				'href' => $scripturl . '?action=spadmin;sa=categorylist',
				'is_selected' => $_REQUEST['sa'] == 'categorylist' || $_REQUEST['sa'] == 'categoryedit',
			),
			'categoryadd' => array(
				'title' => $txt['sp-adminCategoryAddName'],
				'description' => $txt['sp-adminCategoryAddDesc'],
				'href' => $scripturl . '?action=spadmin;sa=categoryadd',
				'is_selected' => $_REQUEST['sa'] == 'categoryadd',
			),
		),
	);

	// We need this everywhere.
	require_once($sourcedir . '/Subs-SPortal1-1.php');

	// Call the right function.
	$subActions[$_REQUEST['sa']]();
}

// Change general settings.
function GeneralSettings()
{
	global $txt, $scripturl, $context, $settings, $sc, $sourcedir, $db_prefix, $helptxt;
	
	//Don't know why but i need it here <<
	if(loadLanguage('SPortalHelp', '', false) === false)
		loadLanguage('SPortalHelp', 'english');

	// Include for the saveDB.
	require_once($sourcedir . '/ManageServer.php');

	// Start theme array with a default.
	$context['sp_themes'] = array('0' => &$txt['portalthemedefault']);
	
	// Load up all the themes for portal theme.
	$request = db_query("
		SELECT ID_THEME, value AS name
		FROM {$db_prefix}themes
		WHERE variable = 'name'
			AND ID_MEMBER = 0
		ORDER BY ID_THEME", __FILE__, __LINE__);

	while ($row = mysql_fetch_assoc($request))
	{
		$context['sp_themes'] += array(
			$row['ID_THEME'] => $row['name']
		);
	}
	mysql_free_result($request);
	
	// Same as the mod settings.
	$config_vars = array(
			array('check', 'portalactive'),
			array('select', 'portaltheme', $context['sp_themes']),
		'',
			array('check', 'showleft'),
			array('check', 'showright'),
			array('text', 'leftwidth'),
			array('text', 'rightwidth'),
			array('text', 'leftwidth'),
			array('text', 'rightwidth'),
		'',
			array('check', 'articleactive'),
			array('int', 'articleperpage'),
			array('int', 'articlelength'),
			array('check', 'articleavatar'),
		'',
			array('check', 'sp_disableColor'),
	);

	if (isset($_GET['save']))
	{
		//Fix the Size of the Portal blocks (later we can add some more, if needed ;), and fix it userfriendly
		//I allowe some mistakes with that like %5 or 100xp
		$width_checkup = array('left', 'right');
		foreach($width_checkup as $pos) {
			if(!empty($_POST[$pos.'width'])) {
				if(stripos($_POST[$pos.'width'], 'px') !== false) 
					$suffix = 'px';
				elseif(strpos($_POST[$pos.'width'], '%') !== false) 
					$suffix = '%';
				else
					$suffix = '';
				//Leave only the numbers :)
				preg_match_all('/(?:([0-9]+)|.)/i', $_POST[$pos.'width'], $matches);
				$number = (int) implode('', $matches[1]);
				if(!empty($number) && $number > 0)
					$_POST[$pos.'width'] = $number.$suffix;
				else
					$_POST[$pos.'width'] = '';
			}
			else
				$_POST[$pos.'width'] = '';
		}

		saveDBSettings($config_vars);
		redirectexit('action=spadmin;sa=generalsettings');
	}

	$context['post_url'] = $scripturl . '?action=spadmin;sa=generalsettings;save';
	$context['settings_title'] = $txt['sp-adminTitle'];

	prepareDBSettingContext($config_vars);
}

// Shows up block list.
function BlockList()
{
	global $txt, $context;
	
	// We have 4 sides...
	$context['sides'] = array(
		'left' => array(
			'id' => '1',
			'name' => 'Left',
			'label' => $txt['sp-positionLeft'],
		),
		'middle_top' => array(
			'id' => '2',
			'name' => 'Middle-Top',
			'label' => $txt['sp-positionTop'],
		),
		'middle_bottom' => array(
			'id' => '3',
			'name' => 'Middle-Bottom',
			'label' => $txt['sp-positionBottom'],
		),
		'right' => array(
			'id' => '4',
			'name' => 'Right',
			'label' => $txt['sp-positionRight'],
		),
	);

	// Columns to show.
	$context['columns'] = array(
		'label' => array(
			'width' => '45%',
			'label' => $txt['sp-adminColumnName'],
		),
		'type' => array(
			'width' => '40%',
			'label' => $txt['sp-adminColumnType'],
		),
		'action' => array(
			'width' => '15%',
			'label' => $txt['sp-adminColumnAction'],
		),
	);

	// Get block info for each side.
	foreach($context['sides'] as $side) {
		$context['blocks'][$side['name']] = getBlockInfo($side['id']);
	}

	// Call the sub template.
	$context['sub_template'] = 'block_list';

}

// Adding or editing a block.
function BlockEdit()
{
	global $txt, $context, $db_prefix, $func;

	//Some Lazy Compatible Things between SMF 2 ans SMF 1.1
	$txt['help'] = $txt[119];
	
	$newBlock = empty($_REQUEST['block_id']) ? true : false;

	// We are adding a new block and didn't select type yet.
	if($newBlock && empty($_POST['selected_type']) && empty($_POST['add_block']))
	{
		// Get all the block types.
		$context['SPortal']['block_types'] = getFunctionInfo();
			
		// Save this. We need while saving.
		if(!empty($_REQUEST['col']))
			$context['SPortal']['column'] = $_REQUEST['col'];
	}
	// We got the type! Now show them the block settings.
	elseif($newBlock && !empty($_POST['selected_type']))
	{
		// Set the block type.
		$context['SPortal']['block_type'] = $_POST['selected_type'][0];
		
		// Get the type info.
		$context['SPortal']['parameters'] = getFunctionInfo($context['SPortal']['block_type']);

		//	Get the function name/title.
		$context['SPortal']['block_info']['type_text'] = $txt['sp_function_'.$context['SPortal']['parameters'][0]['function'].'_label'];
		
		// Just save the parameter count.
		$context['SPortal']['parameters'] = (int) $context['SPortal']['parameters'][0]['parameter'];

		// Is the column defined?
		if(!empty($_POST['block_column'])) 
		{
			// Yes. Save it and get the list!
			$context['SPortal']['column'] = $_POST['block_column'];
			$context['SPortal']['list_blocks'] = getBlockInfo($context['SPortal']['column']);
		}
		
		// So i assume the user will activate it :)
		$context['SPortal']['block_info']['state'] = 1;
	}
	// We are editing a block, get needed info.
	elseif(!$newBlock && empty($_POST['add_block']))
	{
		// Sanitize the ID.
		$_REQUEST['block_id'] = (int) $_REQUEST['block_id'];

		// Get the block info as we need for template.
		$context['SPortal']['block_info'] = getBlockInfo(null, $_REQUEST['block_id']);
		$context['SPortal']['block_info'] = $context['SPortal']['block_info'][0];
		
		// Get number of parameters.
		$context['SPortal']['parameters'] = getFunctionInfo($context['SPortal']['block_info']['type']);
		$context['SPortal']['parameters'] = (int) $context['SPortal']['parameters'][0]['parameter'];

		// Make the parameter values an array.
		$context['SPortal']['parameter_values'] = explode(',', $context['SPortal']['block_info']['parameters']);
		
		// List the blocks for placement
		$context['SPortal']['list_blocks'] = getBlockInfo($context['SPortal']['block_info']['column']);
	}

	// We need this if we selected the type or editing a block.
	if(!empty($_POST['selected_type']) || !$newBlock)
	{
		// Okay prepare group data :)
		if(isset($_POST['member_groups']))
			$context['SPortal']['block_info']['allowed_groups'] = $_POST['member_groups'];
		sp_loadMemberGroups(!$newBlock ? $context['SPortal']['block_info']['allowed_groups'] : 'all');
	}

	// Ready to get into the action?
	if (!empty($_POST['add_block']))
	{
		// Check the label :)
		if (!isset($_POST['block_name']) || $func['htmltrim']($func['htmlspecialchars']($_POST['block_name']), ENT_QUOTES) === '')
			fatal_lang_error('error_sp_name_empty', false);

		// Double Insert?
		$request = db_query("
			SELECT id_block
			FROM {$db_prefix}sp_blocks
			WHERE label = '".addslashes($func['htmlspecialchars'](stripslashes($_POST['block_name']), ENT_QUOTES))."'". (!empty($_REQUEST['block_id']) ? "
            AND id_block != ".(int) $_REQUEST['block_id']."" : "" ) . "
			LIMIT 1", __FILE__, __LINE__);

		$doubleInsert = mysql_num_rows($request);
		mysql_free_result($request);
		if(!empty($doubleInsert))
			fatal_lang_error('error_sp_name_double', false);	
		
		// Putting this block before/after another block?
		if(!empty($_POST['placement']) && (($_POST['placement'] == 'before') || ($_POST['placement'] == 'after')))
		{
			// Get the current row value.
			// Try to get a current value for this blocks row.
			if(!empty($_REQUEST['block_id']) && ($temp = getBlockInfo(null, $_REQUEST['block_id'])))
				$current_row = $temp[0]['row'];
			// Otherwise, this is a new block and we will have to 'pretend' its at the end.
			else
				$current_row = null;
			
			// Get the new row value - assume thay we are moving the block to a higher position, it makes things easier for now. ;)
			// Putting the block before another? The block can take its place then. >:D
			if($_POST['placement'] == 'before')
				$row = (int) $_POST['block_row'];
			// Putting the block after another? No need to display the other block then. ;)
			else
				$row = (int) $_POST['block_row'] + 1;
			
			// Are we moving the block to a lower position?
			if(!empty($current_row) && ($row > $current_row))
			{
				// We have to do this because placements are different when we move blocks to lower positions. ;)
				$row = $row - 1;
				// Fix the row for any blocks inbetween. 
				db_query("
					UPDATE {$db_prefix}sp_blocks
					SET row = row - 1
					WHERE col = ".(int) $_POST['block_column']."
						AND row > $current_row
						AND row <= $row", __FILE__, __LINE__);
			}
			// Are we moving the block to a higher position?
			else
			{
				// Fix the row for any blocks inbetween. 
				db_query("
					UPDATE {$db_prefix}sp_blocks
					SET row = row + 1
					WHERE col = ".(int) $_POST['block_column']."
						AND row >= $row".(!empty($current_row) ? "
						AND row < $current_row" : ""), __FILE__, __LINE__);
			}
		}
		// Leave it where it is?
		elseif(!empty($_POST['placement']) && $_POST['placement'] == 'nochange') 
		{
			// You deserved that, hehe.
			$row = 0;
		}
		// Put it at the end?
		else 
		{
			// Get the last.
			$request = db_query("
				SELECT row
				FROM {$db_prefix}sp_blocks
				WHERE col = ".(int) $_POST['block_column']. (!empty($_REQUEST['block_id']) ? "
            AND id_block != ".(int) $_REQUEST['block_id']."" : "" ) . "
				ORDER BY row DESC
				LIMIT 1",__FILE__, __LINE__);

			list ($row) = mysql_fetch_row($request);
			mysql_free_result($request);
			
			// Now you're the last.
			$row++;
		}

		// Do we have any parameters?
		if(!empty($_POST['parameters']))
		{
			// Sanitize them.
			foreach ($_POST['parameters'] as $index => $parameter)
				$_POST['parameters'][(int) $index] = (int) $parameter;
		}
		
		// Counter for the parameter fix.
		$counter = 0;

		// Fix the parameter array.
		while($counter != 5) 
		{
			// Fill with zero if left empty.
			if(empty($_POST['parameters'][$counter]))
				$_POST['parameters'][$counter] = '0';

			$counter = $counter + 1;
		}

		// Time to arrange the allowed groups
		if (!empty($_POST['member_groups']) && is_array($_POST['member_groups']))
			$_POST['allowed_groups'] = implode(',', $_POST['member_groups']);
		else
			$_POST['allowed_groups'] = '';
	
		// Build the block info array. - Done like this for the day that we integrate the block add/edit functions. ;)
		$blockInfo = array(
			'id' => (int) $_POST['block_id'],
			'label' => addslashes($func['htmlspecialchars'](stripslashes($_POST['block_name']), ENT_QUOTES)),
			'type' => !empty($_POST['block_type']) ? $_POST['block_type'] : 0,
			'content' => ($_POST['block_type'] == 'sp_bbc' && !empty($_POST['block_content'])) ? addslashes($func['htmlspecialchars'](stripslashes($_POST['block_content']), ENT_QUOTES)) : (!empty($_POST['block_content']) ? $_POST['block_content'] : ''),
			'parameters' => implode(', ', $_POST['parameters']),
			'column' => !empty($_POST['block_column']) ? $_POST['block_column'] : 0,
			'row' => $row,
			'state' => empty($_POST['block_active']) ? '0' : '1',
			'force_view' => empty($_POST['block_force']) ? '0' : '1',
			'allowed_groups' => $_POST['allowed_groups'],
			'permission_type' => empty($_POST['permission_type']) || $_POST['permission_type'] > 2 ? '0' : $_POST['permission_type'],
		);

		if($newBlock)
		{
			// Insert the block data.
			db_query("
				INSERT INTO {$db_prefix}sp_blocks
					(label, type, content, parameters, col, row, state, force_view, allowed_groups, permission_type)
				VALUES
					('$blockInfo[label]', '$blockInfo[type]', '$blockInfo[content]', '$blockInfo[parameters]', '$blockInfo[column]', '$blockInfo[row]', '$blockInfo[state]', '$blockInfo[force_view]', '$blockInfo[allowed_groups]', '$blockInfo[permission_type]')", __FILE__, __LINE__);
		}
		else
		{
			// What to change?
			$block_fields = array();
			$block_fields[] = "label = '$blockInfo[label]'";
			if(!empty($blockInfo['content']))
				$block_fields[] = "content = '$blockInfo[content]'";
			if(!empty($blockInfo['parameters']))
				$block_fields[] = "parameters = '$blockInfo[parameters]'";
			if(!empty($blockInfo['row']))
				$block_fields[] = "row = '$blockInfo[row]'";
			$block_fields[] = "state = '$blockInfo[state]'";
			$block_fields[] = "force_view = '$blockInfo[force_view]'";
			$block_fields[] = "allowed_groups = '$blockInfo[allowed_groups]'";
			$block_fields[] = "permission_type = '$blockInfo[permission_type]'";
	
			// Do it!
			db_query("
				UPDATE {$db_prefix}sp_blocks
				SET " . implode(', ', $block_fields) . "
				WHERE ID_BLOCK = $_POST[block_id]
				LIMIT 1", __FILE__, __LINE__);
		}

		// Go back to the blocklist.
		redirectexit('action=spadmin;sa=blocklist');
	}
	
	// Needed to determine if we have help language strings for block parameters.
	if(loadLanguage('SPortalHelp', '', false) === false)
		loadLanguage('SPortalHelp', 'english');

	if($newBlock && empty($_POST['selected_type']) && empty($_POST['add_block']))
	{
		// Call the sub template.
		$context['sub_template'] = 'block_select_type';
	}
	else
	{
		// Lastly load the sub template.
		$context['sub_template'] = 'block_edit';
	}
}

// Function for deteling a block.
function BlockDelete()
{
	global $db_prefix;

	// Check if he can?
	checkSession('get');

	// Make sure ID is an integer.
	$_REQUEST['id'] = (int)$_REQUEST['id'];

	// Do we have that?
	if(empty($_REQUEST['id']))
		fatal_lang_error('error_sp_id_empty', false);

	// Make sure column ID is an integer too.
	$_REQUEST['col'] = (int)$_REQUEST['col'];
	
	// We don't need it anymore.
	db_query("
		DELETE FROM {$db_prefix}sp_blocks
		WHERE ID_BLOCK = '$_REQUEST[id]'
		LIMIT 1", __FILE__, __LINE__);

	// Fix column rows.
	fixColumnRows($_REQUEST['col']);

	// Return back to the block list.
	redirectexit('action=spadmin;sa=blocklist');
}

// Function for moving a block.
function BlockMove()
{
	global $db_prefix;

	// Check if he can?
	checkSession('get');

	// Make sure ID is an integer.
	$_REQUEST['id'] = (int)$_REQUEST['id'];

	// Check it!
	if(empty($_REQUEST['id']))
		fatal_lang_error('error_sp_id_empty', false);

	// Change it with the magical tool.
	changeBlockRow($_REQUEST['id'], $_REQUEST['direction']);
	
	// Return back to the block list.
	redirectexit('action=spadmin;sa=blocklist');
}

// Gets the category list.
function CategoryList()
{
	global $txt, $context;

	// Category list columns.
	$context['columns'] = array(
		'picture' => array(
			'width' => '35%',
			'label' => $txt['sp-adminColumnPicture'],
		),
		'name' => array(
			'width' => '45%',
			'label' => $txt['sp-adminColumnName'],
		),
		'articles' => array(
			'width' => '5%',
			'label' => $txt['sp-adminColumnArticles'],
		),
		'publish' => array(
			'width' => '5%',
			'label' => $txt['sp-adminColumnPublish'],
		),
		'action' => array(
			'width' => '10%',
			'label' => $txt['sp-adminColumnAction'],
		),
	);

	// Get all the categories.
	$context['categories'] = getCategoryInfo();

	// Call the sub template.
	$context['sub_template'] = 'category_list';
}

// Function for adding a category.
function CategoryAdd()
{
	global $txt, $db_prefix, $context, $func;

	// Not now...
	if(empty($_POST['add_category'])) {

		// Just we need the template.
		$context['sub_template'] = 'category_add';
	}
	else {

		// Session check.
		checkSession();

		// Category name can't be empty.
		if (empty($_POST['category_name']))
			fatal_lang_error('error_sp_name_empty', false);

		// A small info array.
		$categoryInfo = array(
			'name' => addslashes($func['htmlspecialchars'](stripslashes($_POST['category_name']), ENT_QUOTES)),
			'picture' => addslashes($func['htmlspecialchars'](stripslashes($_POST['picture_url']), ENT_QUOTES)),
			'publish' => empty($_POST['show_on_index']) ? '0' : '1',
		);

		// Here we go!
		db_query("
			INSERT INTO {$db_prefix}sp_categories
				(name, picture, articles, publish)
			VALUES ('$categoryInfo[name]', '$categoryInfo[picture]', 0, $categoryInfo[publish])", __FILE__, __LINE__);

		// Return back to the category list.
		redirectexit('action=spadmin;sa=categorylist');
	}
}

// Handles the category edit issue.
function CategoryEdit()
{
	global $txt, $db_prefix, $context, $func;

	// Time to edit? Noo!
	if(empty($_POST['add_category'])) {

		// Be sure you made it an integer.
		$_REQUEST['id'] = (int)$_REQUEST['id'];

		// Show you ID.
		if(empty($_REQUEST['id']))
			fatal_lang_error('error_sp_id_empty', false);

		// Get the category info. You need in template.
		$context['category_info'] = getCategoryInfo($_REQUEST['id']);
		$context['category_info'] = $context['category_info'][0];

		// Call the right sub template.
		$context['sub_template'] = 'category_edit';
	}
	else {

		// Again.
		checkSession();

		// Why empty? :S
		if (empty($_POST['category_name']))
			fatal_lang_error('error_sp_name_empty', false);

		// Array for the db.		
		$categoryInfo = array(
			'name' => addslashes($func['htmlspecialchars'](stripslashes($_POST['category_name']), ENT_QUOTES)),
			'picture' => addslashes($func['htmlspecialchars'](stripslashes($_POST['picture_url']), ENT_QUOTES)),
			'publish' => empty($_POST['show_on_index']) ? '0' : '1',
		);

		// What to change?
		$category_fields = array();
		$category_fields[] = "name = '$categoryInfo[name]'";
		if(!empty($categoryInfo['picture']))
			$category_fields[] = "picture = '$categoryInfo[picture]'";
		$category_fields[] = "publish = '$categoryInfo[publish]'";

		// Go on.
		db_query("
			UPDATE {$db_prefix}sp_categories
			SET " . implode(', ', $category_fields) . "
			WHERE ID_CATEGORY = $_POST[category_id]
			LIMIT 1", __FILE__, __LINE__);

		// Take him back to the list.
		redirectexit('action=spadmin;sa=categorylist');
	}
}

// Does more than deleting...
function CategoryDelete()
{
	global $db_prefix, $context;

	// Check if the ID is set.
	if(!empty($_REQUEST['id'])) {

		// Be sure you made it an integer.
		$_REQUEST['id'] = (int)$_REQUEST['id'];

		// Do you know which one to delete?
		if(empty($_REQUEST['id']))
			fatal_lang_error('error_sp_id_empty', false);

		// Get the category info. You need in template.
		$context['category_info'] = getCategoryInfo($_REQUEST['id']);
		$context['category_info'] = $context['category_info'][0];

		// Also get the category list.
		$context['list_categories'] = getCategoryInfo();

		// If we have one, that is itself. Delete it.
		if(count($context['list_categories']) < 2)
			$context['list_categories'] = array();
	}

	if(empty($_REQUEST['id']) && empty($_POST['category_id']))
		fatal_lang_error('error_sp_id_empty', false);

	// No need if category has no articles. But articles are executed if there isn't any other category. :P
	if(empty($_POST['delete_category']) && !empty($context['category_info']['articles'])) {

		// Call the right sub template.
		$context['sub_template'] = 'category_delete';
	}
	elseif(!empty($_POST['delete_category'])) {

		// Again.
		checkSession();

		// Are we going to move something?
		if(!empty($_POST['category_move']) && !empty($_POST['category_move_to'])) {

			// We just need an integer.
			$_POST['category_move_to'] = (int) $_POST['category_move_to'];
			
			// These are the lucky ones, move them.
			db_query("
				UPDATE {$db_prefix}sp_articles
				SET ID_CATEGORY = '$_POST[category_move_to]'
				WHERE ID_CATEGORY = '$_POST[category_id]'", __FILE__, __LINE__);
			
			// Fix the article counts.
			fixCategoryArticles();
		}
		else {
	
			// Kill 'em all. (It's not the Metallica album. :P)
			db_query("
				DELETE FROM {$db_prefix}sp_articles
				WHERE ID_CATEGORY = '$_POST[category_id]'", __FILE__, __LINE__);
		}
			
		// Everybody will die one day...
		db_query("
			DELETE FROM {$db_prefix}sp_categories
			WHERE ID_CATEGORY = '$_POST[category_id]'
			LIMIT 1", __FILE__, __LINE__);
	
		// Return to the list.
		redirectexit('action=spadmin;sa=categorylist');
	}
	else {

		// Again.
		checkSession('get');

		// Just delete the category.
		db_query("
			DELETE FROM {$db_prefix}sp_categories
			WHERE ID_CATEGORY = '$_REQUEST[id]'
			LIMIT 1", __FILE__, __LINE__);

		// Fix the article counts.
		fixCategoryArticles();
			
		// Return to the list.
		redirectexit('action=spadmin;sa=categorylist');
	}
}

// A rahter complex one: Article list.
function ArticleList()
{
	global $txt, $db_prefix, $context, $article_request, $scripturl;

	// Call the template.
	$context['sub_template'] = 'article_list';

	// You clicked to the remove button? Naughty boy. :P
	if (!empty($_POST['removeArticles']) && !empty($_POST['remove']) && is_array($_POST['remove']))
	{

		// But can you?
		checkSession();

		// Are they integer?
		foreach ($_POST['remove'] as $index => $article_id)
			$_POST['remove'][(int) $index] = (int) $article_id;

		// Delete 'em all.
		db_query("
			DELETE FROM {$db_prefix}sp_articles
			WHERE ID_ARTICLE IN (" . implode(', ', $_POST['remove']) . ')
			LIMIT ' . count($_POST['remove']), __FILE__, __LINE__);
		
		//Fix the category article counts.
		fixCategoryArticles();
	}

	// How can we sort the list?
	$sort_methods = array(
		'topic' =>  array(
			'down' => 'm.subject ASC',
			'up' => 'm.subject DESC'
		),
		'board' => array(
			'down' => 'b.name ASC',
			'up' => 'b.name DESC'
		),
		'poster' => array(
			'down' => 'm.posterName ASC',
			'up' => 'm.posterName DESC'
		),
		'time' => array(
			'down' => 'm.posterTime ASC',
			'up' => 'm.posterTime DESC'
		),
		'category' => array(
			'down' => 'c.name ASC',
			'up' => 'c.name DESC'
		),
		'approved' => array(
			'down' => 'a.approved ASC',
			'up' => 'a.approved DESC'
		),
	);

	// Columns to show.
	$context['columns'] = array(
		'topic' => array(
			'width' => '20%',
			'label' => $txt['sp-adminColumnTopic'],
			'sortable' => true
		),
		'board' => array(
			'width' => '20%',
			'label' => $txt['sp-adminColumnBoard'],
			'sortable' => true
		),
		'poster' => array(
			'width' => '10%',
			'label' => $txt['sp-adminColumnPoster'],
			'sortable' => true
		),
		'time' => array(
			'width' => '20%',
			'label' => $txt['sp-adminColumnTime'],
			'sortable' => true
		),
		'category' => array(
			'width' => '20%',
			'label' => $txt['sp-adminColumnCategory'],
			'sortable' => true
		),
		'approved' => array(
			'width' => '5%',
			'label' => $txt['sp-adminColumnApproved'],
			'sortable' => true,
		),
		'actions' => array(
			'width' => '5%',
			'label' => $txt['sp-adminColumnAction'],
			'sortable' => false
		)
	);

	// Default sort is according to the topic.
	if (!isset($_REQUEST['sort']) || !isset($sort_methods[$_REQUEST['sort']]))
		$_REQUEST['sort'] = 'topic';

	// Set the sort links.
	foreach ($context['columns'] as $col => $dummy)
	{
		$context['columns'][$col]['selected'] = $col == $_REQUEST['sort'];
		$context['columns'][$col]['href'] = $scripturl . '?action=spadmin;sa=articlelist;sort=' . $col;

		if (!isset($_REQUEST['desc']) && $col == $_REQUEST['sort'])
			$context['columns'][$col]['href'] .= ';desc';

		$context['columns'][$col]['link'] = '<a href="' . $context['columns'][$col]['href'] . '">' . $context['columns'][$col]['label'] . '</a>';
	}

	$context['sort_by'] = $_REQUEST['sort'];
	$context['sort_direction'] = !isset($_REQUEST['desc']) ? 'down' : 'up';

	// Count all the articles.
	$request = db_query("
		SELECT COUNT(*)
		FROM {$db_prefix}sp_articles", __FILE__, __LINE__);
	list ($totalArticles) = mysql_fetch_row($request);
	mysql_free_result($request);

	// Construct the page index. 20 articles per page.
	$context['page_index'] = constructPageIndex($scripturl . '?action=spadmin;sa=articlelist;sort=' . $_REQUEST['sort'] . (isset($_REQUEST['desc']) ? ';desc' : ''), $_REQUEST['start'], $totalArticles, 20);
	$context['start'] = $_REQUEST['start'];

	// A *small* query to get article info.
	$article_request = db_query("
		SELECT a.ID_ARTICLE, a.ID_CATEGORY, a.ID_MESSAGE, a.approved, c.name as cname, m.ID_MEMBER, m.posterName,
			m.posterTime,	m.subject, t.ID_TOPIC, t.numReplies, t.numViews, b.ID_BOARD, b.name	as bname, mem.realName		
		FROM {$db_prefix}sp_articles AS a
			LEFT JOIN {$db_prefix}sp_categories AS c ON (c.ID_CATEGORY = a.ID_CATEGORY)
			LEFT JOIN {$db_prefix}messages AS m ON (m.ID_MSG = a.ID_MESSAGE)
			LEFT JOIN {$db_prefix}topics AS t ON (t.ID_FIRST_MSG = a.ID_MESSAGE)
			LEFT JOIN {$db_prefix}boards AS b ON (b.ID_BOARD = m.ID_BOARD)
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER)
		ORDER BY " . $sort_methods[$_REQUEST['sort']][$context['sort_direction']] . "
		LIMIT $context[start], 20", __FILE__, __LINE__);

	// Call-back...
	$context['get_article'] = 'getArticleEntry';
}

// Call-back for getting a row of article data.
function getArticleEntry($reset = false)
{
	global $scripturl, $article_request, $txt, $context, $settings;

	if ($article_request == false)
		return false;

	if (!($row = mysql_fetch_assoc($article_request)))
		return false;

	// Build up the array.		
	$output = array(
		'article' => array(
			'id' => $row['ID_ARTICLE'],
			'approved' => $row['approved'],
		),
		'category' => array(
			'id' => $row['ID_CATEGORY'],
         	'name' => '<a href="' . $scripturl . '?action=spadmin;sa=categoryedit;id=' . $row['ID_CATEGORY'] . '">'.$row['cname'].'</a>',
		),
		'message' => array(
			'id' => $row['ID_MESSAGE'],
			'subject' => $row['subject'],
			'time' => timeformat($row['posterTime'], '%H:%M:%S, %d/%m/%y'),
		),
		'poster' => array(
			'id' => $row['ID_MEMBER'],
			'name' => $row['posterName'],
			'link' => (empty($row['ID_MEMBER']) ? $row['posterName'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['realName'] . '</a>'),
		),
		'topic' => array(
			'id' => $row['ID_TOPIC'],
			'replies' => $row['numReplies'],
			'views' => $row['numViews'],
			'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0">' . $row['subject'] . '</a>',
		),
		'board' => array(
			'id' => $row['ID_BOARD'],
			'name' => $row['bname'],
			'link' => '<a href="' . $scripturl . '?board=' . $row['ID_BOARD'] . '.0">' . $row['bname'] . '</a>',
		),
		'edit' => '<a href="' . $scripturl . '?action=spadmin;sa=articleedit;id=' . $row['ID_ARTICLE'] . ';sesc=' . $context['session_id'] . '"><img src="' . $settings['default_theme_url'] . '/images/buttons/modify.gif" alt="' . $txt[17] . '" title="' . $txt[17] . '" /></a>',
		'delete' => '<a href="' . $scripturl . '?action=spadmin;sa=articledelete;id=' . $row['ID_ARTICLE'] . ';sesc=' . $context['session_id'] . '" onclick="return confirm(\''.$txt['sp-articlesDeleteConfirm'].'\');"><img src="' . $settings['default_theme_url'] . '/images/buttons/delete.gif" alt="' . $txt['smf138'] . '" title="' . $txt['smf138'] . '" /></a>'
	);

	return $output;
}

// Function for adding articles.
function ArticleAdd()
{
	global $txt, $context, $scripturl, $db_prefix, $modSettings;

	// Are we ready?
	if(empty($_POST['createArticle']) || empty($_POST['articles'])) {

		// List all the categories.
		$context['list_categories'] = getCategoryInfo();

		// Do we have any category to add?
		if(empty($context['list_categories']))
			fatal_lang_error('error_sp_no_category', false);
			
		// Which board to show?
		if(isset($_REQUEST['targetboard']))
			$_REQUEST['targetboard'] = (int) $_REQUEST['targetboard'];
		else {

			// Find one yourself.
			$request = db_query("
				SELECT ID_BOARD
				FROM {$db_prefix}boards
				ORDER BY ID_BOARD DESC
				LIMIT 1", __FILE__, __LINE__);
			list ($_REQUEST['targetboard']) = mysql_fetch_row($request);
			mysql_free_result($request);
		}
		
		$context['target_board'] = $_REQUEST['targetboard'];

		// Get the total topic count.
		$request = db_query("
			SELECT COUNT(*)
			FROM {$db_prefix}topics as t
				LEFT JOIN {$db_prefix}sp_articles as a ON (a.ID_MESSAGE = t.ID_FIRST_MSG)
			WHERE ID_BOARD = $_REQUEST[targetboard]
				AND IFNULL(a.ID_ARTICLE, 0) = 0", __FILE__, __LINE__);
		list ($topiccount) = mysql_fetch_row($request);
		mysql_free_result($request);

		// Create the page index.
		$context['page_index'] = constructPageIndex($scripturl . '?action=spadmin;sa=articleadd;targetboard=' . $_REQUEST['targetboard'] . ';board=' . $_REQUEST['targetboard'] . '.%d', $_REQUEST['start'], $topiccount, $modSettings['defaultMaxTopics'], true);

		// Get some info about the boards and categories.
		$request = db_query("
			SELECT b.ID_BOARD, b.name AS bName, c.name AS cName
			FROM {$db_prefix}boards AS b
				LEFT JOIN {$db_prefix}categories AS c ON (c.ID_CAT = b.ID_CAT)", __FILE__, __LINE__);
		$context['boards'] = array();
		while ($row = mysql_fetch_assoc($request))
			$context['boards'][] = array(
				'id' => $row['ID_BOARD'],
				'name' => $row['bName'],
				'category' => $row['cName']
			);
		mysql_free_result($request);

		// Time to get the topic data.
		$request = db_query("
			SELECT t.ID_TOPIC, m.subject, m.ID_MEMBER, IFNULL(mem.realName, m.posterName) AS posterName, m.ID_MSG
			FROM ({$db_prefix}topics AS t, {$db_prefix}messages AS m)
				LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER)
				LEFT JOIN {$db_prefix}sp_articles as a ON (a.ID_MESSAGE = t.ID_FIRST_MSG)
			WHERE m.ID_MSG = t.ID_FIRST_MSG
				AND IFNULL(a.ID_ARTICLE, 0) = 0
				AND t.ID_BOARD = $_REQUEST[targetboard]
			ORDER BY " . (!empty($modSettings['enableStickyTopics']) ? 't.isSticky DESC, ' : '') . "t.ID_LAST_MSG DESC
			LIMIT $_REQUEST[start], $modSettings[defaultMaxTopics]", __FILE__, __LINE__);
		$context['topics'] = array();
		while ($row = mysql_fetch_assoc($request))
		{
			censorText($row['subject']);

			$context['topics'][] = array(
				'id' => $row['ID_TOPIC'],
				'msg_id' => $row['ID_MSG'],
				'poster' => array(
					'id' => $row['ID_MEMBER'],
					'name' => $row['posterName'],
					'href' => empty($row['ID_MEMBER']) ? '' : $scripturl . '?action=profile;u=' . $row['ID_MEMBER'],
					'link' => empty($row['ID_MEMBER']) ? $row['posterName'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '" target="_blank">' . $row['posterName'] . '</a>'
				),
				'subject' => $row['subject'],
				'js_subject' => addcslashes(addslashes($row['subject']), '/')
			);
		}
		mysql_free_result($request);

		// Set the page title and sub-template.
		$context['page_title'] = $txt['sp-articlesAdd'];
		$context['sub_template'] = 'article_add';
	}
	else {
	
		// But can you?
		checkSession();

		// Are they integer?
		foreach ($_POST['articles'] as $index => $article_id)
			$_POST['articles'][(int) $index] = (int) $article_id;
			
		// Add all of them.
		foreach($_POST['articles'] as $article) {

			// Set them. They have their own IDs.
			$articleOptions = array(
				'ID_CATEGORY' => !empty($_POST['category']) ? (int) $_POST['category'] : 0,
				'ID_MESSAGE' => $article,
				'approved' => 1,
			);

			// A tricky function.
			createArticle($articleOptions);
		}

		// Time to go back.
		redirectexit('action=spadmin;sa=articlelist');
	}
}

// Function for editing an article.
function ArticleEdit()
{
	global $txt, $db_prefix, $context;
	global $func;

	// Seems that we aren't ready.
	if(empty($_POST['add_article'])) {

		// Check it as we just accept integer.
		$_REQUEST['id'] = (int)$_REQUEST['id'];

		// Do we know the one to be edited?
		if(empty($_REQUEST['id']))
			fatal_lang_error('error_sp_id_empty', false);

		// Get the article info.
		$context['article_info'] = getArticleInfo($_REQUEST['id']);
		$context['article_info'] = $context['article_info'][0];

		// List all the categories.
		$context['list_categories'] = getCategoryInfo();

		// Call the right template.
		$context['sub_template'] = 'article_edit';
	}
	else {

		// A small array.
		$articleInfo = array(
			'category' => $_POST['category'],
			'approved' => empty($_POST['approved']) ? '0' : '1',
		);

		// Set the fields to change.
		$category_fields = array();
		$category_fields[] = "ID_CATEGORY = '$articleInfo[category]'";
		$category_fields[] = "approved = '$articleInfo[approved]'";

		// Do it please.
		db_query("
			UPDATE {$db_prefix}sp_articles
			SET " . implode(', ', $category_fields) . "
			WHERE ID_ARTICLE = $_POST[article_id]
			LIMIT 1", __FILE__, __LINE__);

		// Fix the article counts.
		fixCategoryArticles();

		// I wanna go back to the list. :)
		redirectexit('action=spadmin;sa=articlelist');
	}
}

// Deleting an article...
function ArticleDelete()
{
	global $db_prefix, $context;

	// Check if he can?
	checkSession('get');

	// We just accept integers.
	$_REQUEST['id'] = (int)$_REQUEST['id'];
	
	// Can't delete without an ID.
	if(empty($_REQUEST['id']))
		fatal_lang_error('error_sp_id_empty', false);

	// Life is short... Delete it.
	db_query("
		DELETE FROM {$db_prefix}sp_articles
		WHERE ID_ARTICLE = '$_REQUEST[id]'
		LIMIT 1", __FILE__, __LINE__);

	// Fix the article counts.
	fixCategoryArticles();
	
	// Again comes the list.
	redirectexit('action=spadmin;sa=articlelist');
}

// Function for changing the state of everything.
function StateChange()
{
	// Check if he can?
	checkSession('get');

	// Make sure ID is an integer.
	$_REQUEST['id'] = (int)$_REQUEST['id'];

	// We need an ID...
	if(empty($_REQUEST['id']))
		fatal_lang_error('error_sp_id_empty', false);

	// I love these Subs functions. :)
	changeState($_REQUEST['type'], $_REQUEST['id']);
	
	// Return back to the list where we were.
	if($_REQUEST['type'] == 'block')
		redirectexit('action=spadmin;sa=blocklist');
	elseif($_REQUEST['type'] == 'category')
		redirectexit('action=spadmin;sa=categorylist');
	elseif($_REQUEST['type'] == 'article')
		redirectexit('action=spadmin;sa=articlelist');
	else
		redirectexit('action=spadmin');
}

?>