<?php
//	HACKER???
if (!defined('SMF'))
	die('Hacking attempt...');

/*
File: SPortalAdmin2.php.
Version: Simple Portal Classic 2.0.5 for SMF 2 Beta 4.

// The "Configuration" Area.
SPortalAdmin_Config()
GeneralSettings()

// The "Blocks" Area.
SPortalAdmin_Blocks()
BlockList()
BlockEdit()
BlockDelete()
BlockMove()

// The "Article" Area.
SPortalAdmin_Articles()
ArticleList()
getArticleEntry()
ArticleAdd()
ArticleEdit()
ArticleDelete()

// The "Categories" Area.
SPortalAdmin_Categories()
CategoryList()
CategoryAdd()
CategoryEdit()
CategoryDelete()

// Misc Admin functions.
StateChange()

*/

// This is the main function for the 'Configuration' admin area.
function SPortalAdmin_Config()
{
	global $context, $txt, $scripturl, $sourcedir;

	// Can you moderate it my dear?
	isAllowedTo('sp_moderate');

	// Love this template. :)
	loadTemplate('SPortalAdmin2');

	// Setup some stuff for the template.
	$context['page_title'] = $txt['sp-adminTitle'];
	
	// Setup some more information for the menu template.
	$context[$context['admin_menu_name']]['tab_data'] = array(
		'title' => $txt['admin_config'],
		'help' => 'sp_ConfigurationArea',
		'description' => $txt['sp-adminGeneralSettingsDesc'],
	);

	// For the moment we will call the general settings function, we don't have multiple tabs in this area... yet. ;)
	GeneralSettings();
}

// Change general settings.
function GeneralSettings($return_config = '')
{
	global $txt, $scripturl, $context, $settings, $sc, $sourcedir, $smcFunc;

	// Include for the saveDBSettings and prepareDBSettings function.
	require_once($sourcedir . '/ManageServer.php');

	// Start theme array with a default.
	$context['SPortal']['themes'] = array('0' => &$txt['portalthemedefault']);
	
	// Get a list of all of the SMF themes.
	$request = $smcFunc['db_query']('','
		SELECT id_theme, value AS name
		FROM {db_prefix}themes
		WHERE variable = {string:name}
			AND id_member = {int:member}
		ORDER BY id_theme',
		array(
			'member' => 0,
			'name' => 'name',
		)
	);
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		$context['SPortal']['themes'] += array(
			$row['id_theme'] => $row['name']
		);
	}
	$smcFunc['db_free_result']($request);
	
	// Show the general settings.
	$config_vars = array(
			array('check', 'portalactive'),
			array('select', 'portaltheme', $context['SPortal']['themes']),
		'',
			array('check', 'showleft'),
			array('check', 'showright'),
			array('text', 'leftwidth'),
			array('text', 'rightwidth'),
		'',
			array('check', 'articleactive'),
			array('int', 'articleperpage'),
			array('int', 'articlelength'),
			array('check', 'articleavatar'),
		'',
			array('check', 'sp_disableColor'),
	);
	
	// Are we getting info for the search/help section?
	if ($return_config)
		return $config_vars;
	
	// Do we need to save?
	if (isset($_GET['save']))
	{
		// Check the session.
		checkSession();

		// Fix up the left and right side widths. ;)
	    $width_checkup = array('left', 'right');
	    foreach($width_checkup as $pos) 
		{
	        if(!empty($_POST[$pos.'width'])) 
			{
	            if(stripos($_POST[$pos.'width'], 'px') !== false)
					$suffix = 'px';
	            elseif(strpos($_POST[$pos.'width'], '%') !== false)
					$suffix = '%';
	            else
					$suffix = '';
	            // Leave only the numbers :)
	            preg_match_all('/(?:([0-9]+)|.)/i', $_POST[$pos.'width'], $matches);
	            $number = (int) implode('', $matches[1]);
	            if(!empty($number) && $number > 0)
					$_POST[$pos.'width'] = $number.$suffix;
				else
					$_POST[$pos.'width'] = '';
			}
			else
				$_POST[$pos.'width'] = '';
		}
		
		// Save the data and redirect the admin.
		saveDBSettings($config_vars);
		redirectexit('action=admin;area=sportalconfig');
	}
	
	// Setup some necessary variables for the template.
	$context['post_url'] = $scripturl . '?action=admin;area=sportalconfig;save';
	$context['settings_title'] = $txt['sp-adminTitle'];

	// Prepare the settings for the template.
	prepareDBSettingContext($config_vars);
}

// This is the main function for the 'Blocks' admin area.
function SPortalAdmin_Blocks()
{
	global $context, $txt, $scripturl, $sourcedir;

	// Can you moderate it my dear?
	isAllowedTo('sp_moderate');

	// Love this template. :)
	loadTemplate('SPortalAdmin2');

	// Rather a *small* one, yeah? :P
	$subActions = array(
		'list' => 'BlockList',
		'left' => 'BlockList',
		'right' => 'BlockList',
		'top' => 'BlockList',
		'bottom' => 'BlockList',
		'add' => 'BlockEdit',
		'edit' => 'BlockEdit',
		'delete' => 'BlockDelete',
		'move' => 'BlockMove',
		'statechange' => 'StateChange',
	);

	// Set the default as the general settings.
	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'list';

	// Setup some stuff for the template.
	$context['page_title'] = $txt['sp-adminTitle'];
	$context['sub_action'] = $_REQUEST['sa'];
	
	// Setup some more information for the menu template.
	$context[$context['admin_menu_name']]['tab_data'] = array(
		'title' => $txt['sp-blocksBlocks'],
		'help' => 'sp_BlocksArea',
		'description' => $txt['sp-adminBlockListDesc'],
		'tabs' => array(
			'list' => array(
				'description' => $txt['sp-adminBlockListDesc'],
			),
			'add' => array(
				'description' => $txt['sp-adminBlockAddDesc'],
			),
			'left' => array(
				'description' => $txt['sp-adminBlockLeftListDesc'],
			),
			'top' => array(
				'description' => $txt['sp-adminBlockTopListDesc'],
			),
			'bottom' => array(
				'description' => $txt['sp-adminBlockBottomListDesc'],
			),
			'right' => array(
				'description' => $txt['sp-adminBlockRightListDesc'],
			),
		),
	);

	// We need this everywhere.
	require_once($sourcedir . '/Subs-SPortal2.php');

	// Call the right function.
	$subActions[$_REQUEST['sa']]();
}

// Show the Block List.
function BlockList()
{
	global $txt, $context;

	// We have 4 sides...
	$context['SPortal']['sides'] = array(
		'left' => array(
			'id' => '1',
			'name' => 'adminLeft',
			'label' => $txt['sp-positionLeft'],
		),
		'top' => array(
			'id' => '2',
			'name' => 'adminTop',
			'label' => $txt['sp-positionTop'],
		),
		'bottom' => array(
			'id' => '3',
			'name' => 'adminBottom',
			'label' => $txt['sp-positionBottom'],
		),
		'right' => array(
			'id' => '4',
			'name' => 'adminRight',
			'label' => $txt['sp-positionRight'],
		),
	);
	
	$sides = array('left', 'top', 'bottom', 'right');
	// Are we viewing any of the sub lists for an individual side?
	if(in_array($context['sub_action'], $sides))
	{
		// Remove any sides that we don't need to show. ;)
		foreach($sides as $side)
		{
			if($context['sub_action'] != $side)
				unset($context['SPortal']['sides'][$side]);
		}
	}

	// Columns to show.
	$context['SPortal']['columns'] = array(
		'label' => array(
			'width' => '45%',
			'label' => $txt['sp-adminColumnName'],
		),
		'type' => array(
			'width' => '40%',
			'label' => $txt['sp-adminColumnType'],
		),
		'action' => array(
			'width' => '15%',
			'label' => $txt['sp-adminColumnAction'],
		),
	);

	// Get the block info for each side.
	foreach($context['SPortal']['sides'] as $side)
		$context['SPortal']['blocks'][$side['name']] = getBlockInfo($side['id']);

	// Call the sub template.
	$context['sub_template'] = 'block_list';
}

// Adding or editing a block.
function BlockEdit()
{
	global $txt, $context, $smcFunc;
	
	$newBlock = empty($_REQUEST['block_id']) ? true : false;

	// We are adding a new block and didn't select type yet.
	if($newBlock && empty($_POST['selected_type']) && empty($_POST['add_block']))
	{
		// Get all the block types.
		$context['SPortal']['block_types'] = getFunctionInfo();
			
		// Save this. We need while saving.
		if(!empty($_REQUEST['col']))
			$context['SPortal']['column'] = $_REQUEST['col'];
	}
	// We got the type! Now show them the block settings.
	elseif($newBlock && !empty($_POST['selected_type']))
	{
		// Set the block type.
		$context['SPortal']['block_type'] = $_POST['selected_type'][0];
		
	    // Get the type info.
	    $context['SPortal']['parameters'] = getFunctionInfo($context['SPortal']['block_type']);
		
	    //   Get the function name/title.
	    $context['SPortal']['block_info']['type_text'] = $txt['sp_function_'.$context['SPortal']['parameters'][0]['function'].'_label'];
		
		// Just save the parameter count.
		$context['SPortal']['parameters'] = (int) $context['SPortal']['parameters'][0]['parameter'];

		// Is the column defined?
		if(!empty($_POST['block_column'])) 
		{
			// Yes. Save it and get the list!
			$context['SPortal']['column'] = $_POST['block_column'];
			$context['SPortal']['list_blocks'] = getBlockInfo($context['SPortal']['column']);
		}
		
		// So i assume the user will activate it :)
		$context['SPortal']['block_info']['state'] = 1;
	}
	// We are editing a block, get needed info.
	elseif(!$newBlock && empty($_POST['add_block']))
	{
		// Sanitize the ID.
		$_REQUEST['block_id'] = (int) $_REQUEST['block_id'];

		// Get the block info as we need for template.
		$context['SPortal']['block_info'] = getBlockInfo(null, $_REQUEST['block_id']);
		$context['SPortal']['block_info'] = $context['SPortal']['block_info'][0];
		
		// Get number of parameters.
		$context['SPortal']['parameters'] = getFunctionInfo($context['SPortal']['block_info']['type']);
		$context['SPortal']['parameters'] = (int) $context['SPortal']['parameters'][0]['parameter'];

		// Make the parameter values an array.
		$context['SPortal']['parameter_values'] = explode(',', $context['SPortal']['block_info']['parameters']);
		
		// List the blocks for placement
		$context['SPortal']['list_blocks'] = getBlockInfo($context['SPortal']['block_info']['column']);
	}

	// We need this if we selected the type or editing a block.
	if(!empty($_POST['selected_type']) || !$newBlock)
	{
		// Okay prepare group data :)
		if(isset($_POST['member_groups']))
			$context['SPortal']['block_info']['allowed_groups'] = $_POST['member_groups'];
		sp_loadMemberGroups(!$newBlock ? $context['SPortal']['block_info']['allowed_groups'] : 'all');
	}

	// Ready to get into the action?
	if (!empty($_POST['add_block']))
	{
		// Make sure that we don't have an empty name.
		if (!isset($_POST['block_name']) || $smcFunc['htmltrim']($smcFunc['htmlspecialchars']($_POST['block_name']), ENT_QUOTES) === '')
			fatal_lang_error('error_sp_name_empty', false);
		
		// Does this name already exist in the database?
		$request =  $smcFunc['db_query']('','
			SELECT id_block
			FROM {db_prefix}sp_blocks
			WHERE label = {string:label}' . (!empty($_REQUEST['block_id']) ? '
				AND id_block != {int:current_id}' : '' ) . '
			LIMIT 1',
			array(
				'label' => addslashes($smcFunc['htmlspecialchars'](stripslashes($_POST['block_name']), ENT_QUOTES)),   
				'current_id' => $_REQUEST['block_id'],
			)
		);
		$doubleInsert = $smcFunc['db_num_rows']($request);
		$smcFunc['db_free_result']($request);
		if(!empty($doubleInsert))
			fatal_lang_error('error_sp_name_double', false);
	
		// Putting this block before/after another block?
		if(!empty($_POST['placement']) && (($_POST['placement'] == 'before') || ($_POST['placement'] == 'after')))
		{
			// Get the current row value.
			// Try to get a current value for this blocks row.
			if(!empty($_REQUEST['block_id']) && ($temp = getBlockInfo(null, $_REQUEST['block_id'])))
				$current_row = $temp[0]['row'];
			// Otherwise, this is a new block and we will have to 'pretend' its at the end.
			else
				$current_row = null;
			// Get the new row value - assume thay we are moving the block to a higher position, it makes things easier for now. ;)
			// Putting the block before another? The block can take its place then. >:D
			if($_POST['placement'] == 'before')
				$row = (int) $_POST['block_row'];
			// Putting the block after another? No need to display the other block then. ;)
			else
				$row = (int) $_POST['block_row'] + 1;
			
			// Are we moving the block to a lower position?
			if(!empty($current_row) && ($row > $current_row))
			{
				// We have to do this because placements are different when we move blocks to lower positions. ;)
				$row = $row - 1;
				// Fix the row for any blocks inbetween. 
				$smcFunc['db_query']('','
					UPDATE {db_prefix}sp_blocks
					SET row = row - 1
					WHERE col = {int:col}
						AND row > {int:start}
						AND row <= {int:end}',
					array(
						'col' => (int) $_POST['block_column'],
						'start' => $current_row,
						'end' => $row,
					)
				);
			}
			// Are we moving the block to a higher position?
			else
			{
				// Fix the row for any blocks inbetween. 
				$smcFunc['db_query']('','
					UPDATE {db_prefix}sp_blocks
					SET row = row + 1
					WHERE col = {int:col}
						AND row >= {int:start}'.(!empty($current_row) ? '
						AND row < {int:end}' : ''),
					array(
						'col' => (int) $_POST['block_column'],
						'start' => $row,
						'end' => !empty($current_row) ? $current_row : 0,
					)
				);
			}
		}
		// Leave it where it is?
		elseif(!empty($_POST['placement']) && $_POST['placement'] == 'nochange') 
		{
			// You deserved that, hehe.
			$row = 0;
		}
		// Put it at the end?
		else 
		{
	         // Get the last.
	         $request =  $smcFunc['db_query']('','
	            SELECT row
	            FROM {db_prefix}sp_blocks
	            WHERE col = {int:col}' . (!empty($_REQUEST['block_id']) ? '
	            AND id_block != {int:current_id}' : '' ) . '
	            ORDER BY row DESC
	            LIMIT 1',
	            array(
	               'col' => $_POST['block_column'],   
	               'current_id' => $_REQUEST['block_id'],
	            )
	         );
			list ($row) = $smcFunc['db_fetch_row']($request);
			$smcFunc['db_free_result']($request);
			
			// Now you're the last.
			$row = $row + 1;
		}

		// Do we have any parameters?
		if(!empty($_POST['parameters']))
		{
			// Sanitize them.
			foreach ($_POST['parameters'] as $index => $parameter)
				$_POST['parameters'][(int) $index] = (int) $parameter;
		}
		
		// Counter for the parameter fix.
		$counter = 0;

		// Fix the parameter array.
		while($counter != 5) 
		{
			// Fill with zero if left empty.
			if(empty($_POST['parameters'][$counter]))
				$_POST['parameters'][$counter] = '0';

			$counter = $counter + 1;
		}

		// Time to arrange the allowed groups
		if (!empty($_POST['member_groups']) && is_array($_POST['member_groups']))
			$_POST['allowed_groups'] = implode(',', $_POST['member_groups']);
		else
			$_POST['allowed_groups'] = '';
	
		// Build the block info array. - Done like this for the day that we integrate the block add/edit functions. ;)
		$blockInfo = array(
			'id' => (int) $_POST['block_id'],
			'label' => addslashes($smcFunc['htmlspecialchars'](stripslashes($_POST['block_name']), ENT_QUOTES)),
			'type' => !empty($_POST['block_type']) ? $_POST['block_type'] : 0,
			'content' => ($_POST['block_type'] == 'sp_bbc' && !empty($_POST['block_content'])) ? addslashes($smcFunc['htmlspecialchars'](stripslashes($_POST['block_content']), ENT_QUOTES)) : (!empty($_POST['block_content']) ? $_POST['block_content'] : ''),
			'parameters' => implode(', ', $_POST['parameters']),
			'column' => !empty($_POST['block_column']) ? $_POST['block_column'] : 0,
			'row' => $row,
			'state' => empty($_POST['block_active']) ? '0' : '1',
			'force_view' => empty($_POST['block_force']) ? '0' : '1',
			'allowed_groups' => $_POST['allowed_groups'],
			'permission_type' => empty($_POST['permission_type']) || $_POST['permission_type'] > 2 ? '0' : $_POST['permission_type'],
		);

		if($newBlock)
		{
			// Insert the block data.
			$smcFunc['db_insert']('normal', '{db_prefix}sp_blocks',
				// Columns to insert.
				array(
					'label' => 'string',
					'type' => 'string',
					'content' => 'string',
					'parameters' => 'string',
					'col' => 'int',
					'row' => 'int',
					'state' => 'int',
					'force_view' => 'int',
					'allowed_groups' => 'string',
					'permission_type' => 'string',
				),
				// Data to put in.
				array(
					'label' => $blockInfo['label'],
					'type' => $blockInfo['type'],
					'content' => $blockInfo['content'],
					'parameters' => $blockInfo['parameters'],
					'column' => $blockInfo['column'],
					'row' => $blockInfo['row'],
					'state' => $blockInfo['state'],
					'force_view' => $blockInfo['force_view'],
					'allowed_groups' => $blockInfo['allowed_groups'],
					'permission_type' => $blockInfo['permission_type'],
				),
				// We had better tell SMF about the key, even though I can't remember why? ;)
				array('id_block')
			);
		}
		else
		{
			// What to change?
			$block_fields = array();
			$block_fields[] = "label = {string:label}";
			if(!empty($blockInfo['content']))
				$block_fields[] = "content = {string:content}";
			if(!empty($blockInfo['parameters']))
				$block_fields[] = "parameters = {string:parameters}";
			if(!empty($blockInfo['row']))
				$block_fields[] = "row = {int:row}";
			$block_fields[] = "state = {int:state}";
			$block_fields[] = "force_view = {int:force_view}";
			$block_fields[] = "allowed_groups = {string:allowed_groups}";
			$block_fields[] = "permission_type = {string:permission_type}";

			// Do it!
			$smcFunc['db_query']('','
				UPDATE {db_prefix}sp_blocks
				SET ' . implode(', ', $block_fields) . '
				WHERE id_block = {int:id}
				LIMIT 1',
				$blockInfo
			);
		}

		// Go back to the blocklist.
		redirectexit('action=admin;area=blocks');
	}
	
	// Needed to determine if we have help language strings for block parameters.
	loadLanguage('SPortalHelp', sp_languageSelect('SPortalHelp'));

	if($newBlock && empty($_POST['selected_type']) && empty($_POST['add_block']))
	{
		// Call the sub template.
		$context['sub_template'] = 'block_select_type';
	}
	else
	{
		// Lastly load the sub template.
		$context['sub_template'] = 'block_edit';
	}
}

// Function for deleting a block.
function BlockDelete()
{
	global $smcFunc;

	// Check if he can?
	checkSession('get');

	// Make sure ID is an integer.
	$_REQUEST['block_id'] = (int) $_REQUEST['block_id'];

	// Do we have that?
	if(empty($_REQUEST['block_id']))
		fatal_lang_error('error_sp_id_empty', false);

	// Make sure column ID is an integer too.
	$_REQUEST['col'] = (int) $_REQUEST['col'];
	
	// We don't need it anymore.
	$smcFunc['db_query']('','
		DELETE FROM {db_prefix}sp_blocks
		WHERE id_block = {int:id}
		LIMIT 1',
		array(
			'id' => $_REQUEST['block_id'],
		)
	);

	// Fix column rows.
	fixColumnRows($_REQUEST['col']);

	// Return back to the block list.
	redirectexit('action=admin;area=blocks');
}

// Function for moving a block.
function BlockMove()
{
	// Check if he can?
	checkSession('get');

	// Make sure ID is an integer.
	$_REQUEST['block_id'] = (int) $_REQUEST['block_id'];

	// Check it!
	if(empty($_REQUEST['block_id']))
		fatal_lang_error('error_sp_id_empty', false);

	// Change it with the magical tool.
	changeBlockRow($_REQUEST['block_id'], $_REQUEST['direction']);
	
	// Return back to the block list.
	redirectexit('action=admin;area=blocks');
}

// This is the main function for the 'Articles' admin area.
function SPortalAdmin_Articles()
{
	global $context, $txt, $scripturl, $sourcedir;

	// Can you moderate it my dear?
	isAllowedTo('sp_moderate');

	// Love this template. :)
	loadTemplate('SPortalAdmin2');

	// Rather a *small* one, yeah? :P
	$subActions = array(
		'list' => 'ArticleList',
		'add' => 'ArticleAdd',
		'edit' => 'ArticleEdit',
		'delete' => 'ArticleDelete',
		'statechange' => 'StateChange',
	);

	// Set the default as the general settings.
	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'list';

	// Setup some stuff for the template.
	$context['page_title'] = $txt['sp-adminTitle'];
	$context['sub_action'] = $_REQUEST['sa'];
	
	// Setup some more information for the menu template.
	$context[$context['admin_menu_name']]['tab_data'] = array(
		'title' => $txt['sp-adminCatTitle'],
		'help' => 'sp_ArticlesArea',
		'description' => $txt['sp-adminCatDesc'],
		'tabs' => array(
			'list' => array(
				'description' => $txt['sp-adminArticleListDesc'],
			),
			'add' => array(
				'description' => $txt['sp-adminArticleAddDesc'],
			),
		),
	);

	// We need this everywhere.
	require_once($sourcedir . '/Subs-SPortal2.php');

	// Call the right function.
	$subActions[$_REQUEST['sa']]();
}

// Function to 'Show' a list of Articles, and allow 'quick' deletion of them.
function ArticleList()
{
	global $txt, $smcFunc, $context, $article_request, $scripturl;

	// Call the template.
	$context['sub_template'] = 'article_list';

	// You clicked the remove button? Naughty boy. :P
	if (!empty($_POST['removeArticles']) && !empty($_POST['remove']) && is_array($_POST['remove']))
	{
		// Are you even allowed to be here?
		checkSession();

		// Sanitize the articles to remove non integers.
		foreach ($_POST['remove'] as $index => $article_id)
			$_POST['remove'][(int) $index] = (int) $article_id;

		// Delete the required articles.
		$smcFunc['db_query']('','
			DELETE FROM {db_prefix}sp_articles
			WHERE id_article IN ({array_int:remove})
			LIMIT {int:limit}',
			array(
				'remove' => $_POST['remove'],
				'limit' => count($_POST['remove']),
			)
		);
		
		// Fix the category article count.
		fixCategoryArticles();
	}

	// How can we sort the list of articles?
	$sort_methods = array(
		'topic' =>  array(
			'down' => 'm.subject ASC',
			'up' => 'm.subject DESC'
		),
		'board' => array(
			'down' => 'b.name ASC',
			'up' => 'b.name DESC'
		),
		'poster' => array(
			'down' => 'm.poster_name ASC',
			'up' => 'm.poster_name DESC'
		),
		'time' => array(
			'down' => 'm.poster_time ASC',
			'up' => 'm.poster_time DESC'
		),
		'category' => array(
			'down' => 'c.name ASC',
			'up' => 'c.name DESC'
		),
		'approved' => array(
			'down' => 'a.approved ASC',
			'up' => 'a.approved DESC'
		),
	);

	// Columns to show.
	$context['columns'] = array(
		'topic' => array(
			'width' => '20%',
			'label' => $txt['sp-adminColumnTopic'],
			'sortable' => true
		),
		'board' => array(
			'width' => '20%',
			'label' => $txt['sp-adminColumnBoard'],
			'sortable' => true
		),
		'poster' => array(
			'width' => '10%',
			'label' => $txt['sp-adminColumnPoster'],
			'sortable' => true
		),
		'time' => array(
			'width' => '20%',
			'label' => $txt['sp-adminColumnTime'],
			'sortable' => true
		),
		'category' => array(
			'width' => '20%',
			'label' => $txt['sp-adminColumnCategory'],
			'sortable' => true
		),
		'approved' => array(
			'width' => '5%',
			'label' => $txt['sp-adminColumnApproved'],
			'sortable' => true,
		),
		'actions' => array(
			'width' => '5%',
			'label' => $txt['sp-adminColumnAction'],
			'sortable' => false
		)
	);

	// Default sort is according to the topic.
	if (!isset($_REQUEST['sort']) || !isset($sort_methods[$_REQUEST['sort']]))
		$_REQUEST['sort'] = 'topic';

	// Setup the sort links.
	foreach ($context['columns'] as $col => $dummy)
	{
		$context['columns'][$col]['selected'] = $col == $_REQUEST['sort'];
		$context['columns'][$col]['href'] = $scripturl . '?action=admin;area=articles;sa=list;sort=' . $col;

		if (!isset($_REQUEST['desc']) && $col == $_REQUEST['sort'])
			$context['columns'][$col]['href'] .= ';desc';

		$context['columns'][$col]['link'] = '<a href="' . $context['columns'][$col]['href'] . '">' . $context['columns'][$col]['label'] . '</a>';
	}

	$context['sort_by'] = $_REQUEST['sort'];
	$context['sort_direction'] = !isset($_REQUEST['desc']) ? 'down' : 'up';

	// Count all the articles.
	$request = $smcFunc['db_query']('','
		SELECT COUNT(*)
		FROM {db_prefix}sp_articles'
	);
	list ($totalArticles) =  $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);

	// Construct the page index. 20 articles per page.
	$context['page_index'] = constructPageIndex($scripturl . '?action=admin;area=articles;sa=list;sort=' . $_REQUEST['sort'] . (isset($_REQUEST['desc']) ? ';desc' : ''), $_REQUEST['start'], $totalArticles, 20);
	$context['start'] = $_REQUEST['start'];

	// A *small* query to get article info.
	$article_request = $smcFunc['db_query']('','
		SELECT a.id_article, a.id_category, a.id_message, a.approved, c.name as cname, m.id_member, m.poster_name,
			m.poster_time, m.subject, t.id_topic, t.num_replies, t.num_views, b.id_board, b.name as bname, mem.real_name		
		FROM {db_prefix}sp_articles AS a
			LEFT JOIN {db_prefix}sp_categories AS c ON (c.id_category = a.id_category)
			LEFT JOIN {db_prefix}messages AS m ON (m.id_msg = a.id_message)
			LEFT JOIN {db_prefix}topics AS t ON (t.id_first_msg = a.id_message)
			LEFT JOIN {db_prefix}boards AS b ON (b.id_board = m.id_board)
			LEFT JOIN {db_prefix}members AS mem ON (mem.id_member = m.id_member)
		ORDER BY {raw:sort}
		LIMIT {int:start}, {int:limit}',
		array(
			'sort' => $sort_methods[$_REQUEST['sort']][$context['sort_direction']],
			'start' => $context['start'],
			'limit' => 20,
		)
	);

	// Call-back...
	$context['get_article'] = 'getArticleEntry';
}

// Call-back for getting a row of article data.
function getArticleEntry($reset = false)
{
	global $scripturl, $article_request, $txt, $context, $settings, $smcFunc;

	if ($article_request == false)
		return false;

	if (!($row = $smcFunc['db_fetch_assoc']($article_request)))
		return false;

	// Build up the array.		
	$output = array(
		'article' => array(
			'id' => $row['id_article'],
			'approved' => $row['approved'],
		),
		'category' => array(
			'id' => $row['id_category'],
			'name' => '<a href="' . $scripturl . '?action=admin;area=categories;sa=edit;id=' . $row['id_category'] . '">'.$row['cname'].'</a>',
		),
		'message' => array(
			'id' => $row['id_message'],
			'subject' => $row['subject'],
			'time' => timeformat($row['poster_time'], '%H:%M:%S, %d/%m/%y'),
		),
		'poster' => array(
			'id' => $row['id_member'],
			'name' => $row['poster_name'],
			'link' => !empty($row['id_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '">' . $row['real_name'] . '</a>' : $row['poster_name'],
		),
		'topic' => array(
			'id' => $row['id_topic'],
			'replies' => $row['num_replies'],
			'views' => $row['num_views'],
			'link' => '<a href="' . $scripturl . '?topic=' . $row['id_topic'] . '.0">' . $row['subject'] . '</a>',
		),
		'board' => array(
			'id' => $row['id_board'],
			'name' => $row['bname'],
			'link' => '<a href="' . $scripturl . '?board=' . $row['id_board'] . '.0">' . $row['bname'] . '</a>',
		),
		'edit' => '<a href="' . $scripturl . '?action=admin;area=articles;sa=edit;id=' . $row['id_article'] . ';sesc=' . $context['session_id'] . '"><img src="' . $settings['default_theme_url'] . '/images/buttons/modify.gif" alt="' . $txt['modify'] . '" title="' . $txt['modify'] . '" /></a>',
		'delete' => '<a href="' . $scripturl . '?action=admin;area=articles;sa=delete;id=' . $row['id_article'] . ';sesc=' . $context['session_id'] . '" onclick="return confirm(\'' . $txt['sp-articlesDeleteConfirm'] . '\');"><img src="' . $settings['default_theme_url'] . '/images/buttons/delete.gif" alt="' . $txt['delete'] . '" title="' . $txt['delete'] . '" /></a>'
	);

	return $output;
}

// Function for adding articles.
function ArticleAdd()
{
	global $txt, $context, $scripturl, $smcFunc, $modSettings;

	// Are we ready?
	if(empty($_POST['createArticle']) || empty($_POST['articles'])) 
	{
		// List all the categories.
		$context['list_categories'] = getCategoryInfo();

		// Do we have any category to add?
		if(empty($context['list_categories']))
			fatal_lang_error('error_sp_no_category', false);
			
		// Which board to show?
		if(isset($_REQUEST['targetboard']))
			$_REQUEST['targetboard'] = (int) $_REQUEST['targetboard'];
		else 
		{
			// Find one yourself.
			$request = $smcFunc['db_query']('','
				SELECT id_board
				FROM {db_prefix}boards
				WHERE redirect = \'\'
				ORDER BY id_board DESC
				LIMIT 1'
			);
			list ($_REQUEST['targetboard']) = $smcFunc['db_fetch_row']($request);
			$smcFunc['db_free_result']($request);
		}
		
		$context['target_board'] = $_REQUEST['targetboard'];

		// Get the total topic count.
		$request = $smcFunc['db_query']('','
			SELECT COUNT(*)
			FROM {db_prefix}topics as t
				LEFT JOIN {db_prefix}sp_articles as a ON (a.id_message = t.id_first_msg)
			WHERE id_board = {int:targetboard}
				AND IFNULL(a.id_article, 0) = 0',
			array(
				'targetboard' => $_REQUEST['targetboard'],
			)
		);
		list ($topiccount) = $smcFunc['db_fetch_row']($request);
		$smcFunc['db_free_result']($request);

		// Create the page index.
		$context['page_index'] = constructPageIndex($scripturl . '?action=admin;area=articles;sa=add;targetboard=' . $_REQUEST['targetboard'] . ';board=' . $_REQUEST['targetboard'] . '.%d', $_REQUEST['start'], $topiccount, $modSettings['defaultMaxTopics'], true);

		// Get some info about the boards and categories.
		$request = $smcFunc['db_query']('','
			SELECT b.id_board, b.name AS bName, c.name AS cName
			FROM {db_prefix}boards AS b
				LEFT JOIN {db_prefix}categories AS c ON (c.id_cat = b.id_cat)
			WHERE b.redirect = \'\''
		);
		$context['boards'] = array();
		while ($row = $smcFunc['db_fetch_assoc']($request))
			$context['boards'][] = array(
				'id' => $row['id_board'],
				'name' => $row['bName'],
				'category' => $row['cName']
			);
		$smcFunc['db_free_result']($request);

		// Time to get the topic data.
		$request = $smcFunc['db_query']('','
			SELECT t.id_topic, m.subject, m.id_member, IFNULL(mem.real_name, m.poster_name) AS poster_name, m.id_msg
			FROM ({db_prefix}topics AS t, {db_prefix}messages AS m)
				LEFT JOIN {db_prefix}members AS mem ON (mem.id_member = m.id_member)
				LEFT JOIN {db_prefix}sp_articles as a ON (a.id_message = t.id_first_msg)
			WHERE m.id_msg = t.id_first_msg
				AND IFNULL(a.id_article, 0) = {int:article}
				AND t.id_board = {int:targetboard}
			ORDER BY ' . (!empty($modSettings['enableStickyTopics']) ? 't.is_sticky DESC, ' : '') . 't.id_last_msg DESC
			LIMIT {int:start}, {int:max}',
			array(
				'article' => 0,
				'targetboard' => $_REQUEST['targetboard'],
				'start' => $_REQUEST['start'],
				'max' => $modSettings['defaultMaxTopics'],
			)
		);
		$context['topics'] = array();
		while ($row = $smcFunc['db_fetch_assoc']($request))
		{
			censorText($row['subject']);

			$context['topics'][] = array(
				'id' => $row['id_topic'],
				'msg_id' => $row['id_msg'],
				'poster' => array(
					'id' => $row['id_member'],
					'name' => $row['poster_name'],
					'href' => empty($row['id_member']) ? '' : $scripturl . '?action=profile;u=' . $row['id_member'],
					'link' => empty($row['id_member']) ? $row['poster_name'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '" target="_blank">' . $row['poster_name'] . '</a>'
				),
				'subject' => $row['subject'],
				'js_subject' => addcslashes(addslashes($row['subject']), '/')
			);
		}
		$smcFunc['db_free_result']($request);

		// Set the page title and sub-template.
		$context['page_title'] = $txt['sp-articlesAdd'];
		$context['sub_template'] = 'article_add';
	}
	else 
	{
		// But can you?
		checkSession();

		// Are they integer?
		foreach ($_POST['articles'] as $index => $article_id)
			$_POST['articles'][(int) $index] = (int) $article_id;
			
		// Add all of them.
		foreach($_POST['articles'] as $article) {

			// Set them. They have their own IDs.
			$articleOptions = array(
				'id_category' => !empty($_POST['category']) ? (int) $_POST['category'] : 0,
				'id_message' => $article,
				'approved' => 1,
			);

			// A tricky function.
			createArticle($articleOptions);
		}

		// Time to go back.
		redirectexit('action=admin;area=articles');
	}
}

// Function for editing an article.
function ArticleEdit()
{
	global $txt, $smcFunc, $context;
	global $func;

	// Seems that we aren't ready.
	if(empty($_POST['add_article'])) 
	{
		// Check it as we just accept integer.
		$_REQUEST['id'] = (int) $_REQUEST['id'];

		// Do we know the one to be edited?
		if(empty($_REQUEST['id']))
			fatal_lang_error('error_sp_id_empty', false);

		// Get the article info.
		$context['article_info'] = getArticleInfo($_REQUEST['id']);
		$context['article_info'] = $context['article_info'][0];

		// List all the categories.
		$context['list_categories'] = getCategoryInfo();

		// Call the right template.
		$context['sub_template'] = 'article_edit';
	}
	else 
	{
		// A small array.
		$articleInfo = array(
			'category' => $_POST['category'],
			'approved' => empty($_POST['approved']) ? '0' : '1',
		);

		// Do it please.
		$smcFunc['db_query']('','
			UPDATE {db_prefix}sp_articles
			SET id_category = {int:category}, approved = {int:approved}
			WHERE id_article = {int:id}
			LIMIT 1',
			array(
				'id' => $_POST['article_id'],
				'category' => $articleInfo['category'],
				'approved' => $articleInfo['approved'],
			)
		);

		// Fix the article counts.
		fixCategoryArticles();

		// I wanna go back to the list. :)
		redirectexit('action=admin;area=articles');
	}
}

// Deleting an article...
function ArticleDelete()
{
	global $smcFunc, $context;

	// Check if he can?
	checkSession('get');

	// We just accept integers.
	$_REQUEST['id'] = (int)$_REQUEST['id'];
	
	// Can't delete without an ID.
	if(empty($_REQUEST['id']))
		fatal_lang_error('error_sp_id_empty', false);

	// Life is short... Delete it.
	$smcFunc['db_query']('','
		DELETE FROM {db_prefix}sp_articles
		WHERE id_article = {int:id}
		LIMIT 1',
		array(
			'id' => $_REQUEST['id'],
		)
	);

	// Fix the article counts.
	fixCategoryArticles();
	
	// Again comes the list.
	redirectexit('action=admin;area=articles');
}

// Function to handle the category admin pages.
function SPortalAdmin_Categories()
{
	global $context, $txt, $scripturl, $sourcedir;

	// Can you moderate it my dear?
	isAllowedTo('sp_moderate');

	// Love this template. :)
	loadTemplate('SPortalAdmin2');

	$subActions = array(
		'list' => 'CategoryList',
		'add' => 'CategoryAdd',
		'edit' => 'CategoryEdit',
		'delete' => 'CategoryDelete',
		'statechange' => 'StateChange',
	);

	// Set the default as the general settings.
	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'list';

	// Setup some stuff for the template.
	$context['page_title'] = $txt['sp-adminTitle'];
	$context['sub_action'] = $_REQUEST['sa'];
	
	// Setup some more information for the menu template.
	$context[$context['admin_menu_name']]['tab_data'] = array(
		'title' => $txt['sp-adminCatTitle'],
		'help' => 'sp_CategoriesArea',
		'description' => $txt['sp-adminCatDesc'],
		'tabs' => array(
			'list' => array(
				'description' => $txt['sp-adminCategoryListDesc'],
			),
			'add' => array(
				'description' => $txt['sp-adminCategoryAddDesc'],
			),
		),
	);

	// We need this everywhere.
	require_once($sourcedir . '/Subs-SPortal2.php');

	// Call the right function.
	$subActions[$_REQUEST['sa']]();
}

// Gets the category list.
function CategoryList()
{
	global $txt, $context;

	// Category list columns.
	$context['columns'] = array(
		'picture' => array(
			'width' => '35%',
			'label' => $txt['sp-adminColumnPicture'],
		),
		'name' => array(
			'width' => '45%',
			'label' => $txt['sp-adminColumnName'],
		),
		'articles' => array(
			'width' => '5%',
			'label' => $txt['sp-adminColumnArticles'],
		),
		'publish' => array(
			'width' => '5%',
			'label' => $txt['sp-adminColumnPublish'],
		),
		'action' => array(
			'width' => '10%',
			'label' => $txt['sp-adminColumnAction'],
		),
	);

	// Get all the categories.
	$context['categories'] = getCategoryInfo();

	// Call the sub template.
	$context['sub_template'] = 'category_list';
}

// Function for adding a category.
function CategoryAdd()
{
	global $txt, $smcFunc, $context, $func;

	// Not actually adding a category? Show the add category page.
	if(empty($_POST['add_category'])) 
	{
		// Just we need the template.
		$context['sub_template'] = 'category_add';
	}
	// Adding a category? Lets do this thang! ;D
	else 
	{
		// Session check.
		checkSession();

		// Category name can't be empty.
		if (empty($_POST['category_name']))
			fatal_lang_error('error_sp_name_empty', false);

		// A small info array.
		$categoryInfo = array(
			'name' => addslashes($smcFunc['htmlspecialchars'](stripslashes($_POST['category_name']), ENT_QUOTES)),
			'picture' => addslashes($smcFunc['htmlspecialchars'](stripslashes($_POST['picture_url']), ENT_QUOTES)),
			'publish' => empty($_POST['show_on_index']) ? '0' : '1',
		);
		
		// Insert the category data.
		$smcFunc['db_insert']('normal', '{db_prefix}sp_categories',
			// Columns to insert.
			array(
				'name' => 'string',
				'picture' => 'string',
				'articles' => 'int',
				'publish' => 'int'
			),
			// Data to put in.
			array(
				'name' => $categoryInfo['name'],
				'picture' => $categoryInfo['picture'],
				'articles' => 0,
				'publish' => $categoryInfo['publish']
			),
			// We had better tell SMF about the key, even though I can't remember why? ;)
			array('id_category')
		);
		
		// Return back to the category list.
		redirectexit('action=admin;area=categories');
	}
}

// Handles the category edit issue.
function CategoryEdit()
{
	global $txt, $smcFunc, $context, $func;

	// Not Time to edit? Show the cagegory edit page.
	if(empty($_POST['add_category'])) 
	{
		// Be sure you made it an integer.
		$_REQUEST['id'] = (int)$_REQUEST['id'];

		// Show you ID.
		if(empty($_REQUEST['id']))
			fatal_lang_error('error_sp_id_empty', false);

		// Get the category info. You need in template.
		$context['category_info'] = getCategoryInfo($_REQUEST['id']);
		$context['category_info'] = $context['category_info'][0];

		// Call the right sub template.
		$context['sub_template'] = 'category_edit';
	}
	// Perform the actual edits.
	else 
	{
		// Again.
		checkSession();

		// Why empty? :S
		if (empty($_POST['category_name']))
			fatal_lang_error('error_sp_name_empty', false);

		// Array for the db.		
		$categoryInfo = array(
			'name' => addslashes($smcFunc['htmlspecialchars'](stripslashes($_POST['category_name']), ENT_QUOTES)),
			'picture' => addslashes($smcFunc['htmlspecialchars'](stripslashes($_POST['picture_url']), ENT_QUOTES)),
			'publish' => empty($_POST['show_on_index']) ? '0' : '1',
		);

		// What to change?
		$category_fields = array();
		$category_fields[] = "name = {string:name}";
		if(!empty($categoryInfo['picture']))
			$category_fields[] = "picture = {string:picture}";
		$category_fields[] = "publish = {int:publish}";

		// Go on.
		$smcFunc['db_query']('','
			UPDATE {db_prefix}sp_categories
			SET ' . implode(', ', $category_fields) . '
			WHERE id_category = {int:id}
			LIMIT 1',
			array(
				'id' => $_POST['category_id'],
				'name' => $categoryInfo['name'],
				'picture' => $categoryInfo['picture'],
				'publish' => $categoryInfo['publish'],
			)
		);

		// Take him back to the list.
		redirectexit('action=admin;area=categories');
	}
}

// Does more than deleting...
function CategoryDelete()
{
	global $smcFunc, $context;

	// Is an id set? If yes, then we need to get some category information.
	if(!empty($_REQUEST['id'])) 
	{
		// Be sure you made it an integer.
		$_REQUEST['id'] = (int)$_REQUEST['id'];

		// Do you know which one to delete?
		if(empty($_REQUEST['id']))
			fatal_lang_error('error_sp_id_empty', false);

		// Get the category info. You need in template.
		$context['category_info'] = getCategoryInfo($_REQUEST['id']);
		$context['category_info'] = $context['category_info'][0];

		// Also get the category list.
		$context['list_categories'] = getCategoryInfo();

		// If we have one, that is itself. Delete it.
		if(count($context['list_categories']) < 2)
			$context['list_categories'] = array();
	}

	if(empty($_REQUEST['id']) && empty($_POST['category_id']))
		fatal_lang_error('error_sp_id_empty', false);

	// No need to delete articles if category has no articles. But articles are executed if there isn't any other category. :P
	if(empty($_POST['delete_category']) && !empty($context['category_info']['articles'])) 
	{
		// Call the right sub template.
		$context['sub_template'] = 'category_delete';
	}
	elseif(!empty($_POST['delete_category'])) 
	{
		// Again.
		checkSession();

		// Are we going to move something?
		if(!empty($_POST['category_move']) && !empty($_POST['category_move_to'])) {

			// We just need an integer.
			$_POST['category_move_to'] = (int) $_POST['category_move_to'];
			
			// These are the lucky ones, move them.
			$smcFunc['db_query']('','
				UPDATE {db_prefix}sp_articles
				SET id_category = {int:category_move_to}
				WHERE id_category = {int:category_id}',
				array(
					'category_move_to' => $_POST['category_move_to'],
					'category_id' => $_POST['category_id'],
				)
			);
			
			// Fix the article counts.
			fixCategoryArticles();
		}
		else 
		{
			// Kill 'em all. (It's not the Metallica album. :P)
			$smcFunc['db_query']('','
				DELETE FROM {db_prefix}sp_articles
				WHERE id_category = {int:category_id}',
				array(
					'category_id' => $_POST['category_id'],
				)
			);
		}
			
		// Everybody will die one day...
		$smcFunc['db_query']('','
			DELETE FROM {db_prefix}sp_categories
			WHERE id_category = {int:category_id}
			LIMIT 1',
			array(
				'category_id' => $_POST['category_id'],
			)
		);
		
		// Return to the list.
		redirectexit('action=admin;area=categories');
	}
	else 
	{
		// Again.
		checkSession('get');

		// Just delete the category.
		$smcFunc['db_query']('','
			DELETE FROM {db_prefix}sp_categories
			WHERE id_category = {int:category_id}
			LIMIT 1',
			array(
				'category_id' => $_REQUEST['id'],
			)
		);

		// Fix the article counts.
		fixCategoryArticles();
			
		// Return to the list.
		redirectexit('action=admin;area=categories');
	}
}

// Function for changing the state of everything.
function StateChange()
{
	// Check if he can?
	checkSession('get');

	// Make sure ID is an integer.
	$_REQUEST['id'] = (int) $_REQUEST['id'];

	// We need an ID...
	if(empty($_REQUEST['id']))
		fatal_lang_error('error_sp_id_empty', false);

	// I love these Subs functions. :)
	changeState($_REQUEST['type'], $_REQUEST['id']);
	
	// Return back to the list where we were.
	if($_REQUEST['type'] == 'block')
		redirectexit('action=admin;area=blocks');
	elseif($_REQUEST['type'] == 'category')
		redirectexit('action=admin;area=categories');
	elseif($_REQUEST['type'] == 'article')
		redirectexit('action=admin;area=articles');
	else
		redirectexit('action=admin;area=sportalconfig');
}

?>