<?php
/*
File: SPortalAdmin2.template.php.
Version: Simple Portal Classic 2.0.5 for SMF 2 Beta 4.
	 
// "Config" Area subtemplates.
template_main()

// "Block" Area subtemplate.
template_block_list()
template_block_edit()
template_block_select_type()

// "Articles" Area subtemplate.
template_article_list()
template_article_add()
template_article_edit()

// "Category" Area subtemplate.
template_category_list()
template_category_add()
template_category_edit()
template_category_delete()

// Misc Subtemplates.
sp_template_inline_permissions()
	
*/

// The template function for the General Settings area.
function template_main()
{
	global $context, $txt, $settings, $scripturl;

	echo '
	<form action="', $context['post_url'], '" method="post" accept-charset="', $context['character_set'], '">
		<table width="80%" border="0" cellspacing="0" cellpadding="0" class="tborder" align="center">
			<tr><td>
				<table border="0" cellspacing="0" cellpadding="4" width="100%">
					<tr class="titlebg">
						<td colspan="3">', $context['settings_title'], '</td>
					</tr>';

	// Have we got some custom code to insert?
	if (!empty($context['settings_message']))
		echo '
					<tr>
						<td class="windowbg2" colspan="3">', $context['settings_message'], '</td>
					</tr>';

	// Now actually loop through all the variables.
	foreach ($context['config_vars'] as $config_var)
	{
		echo '
					<tr class="windowbg2">';

		if (is_array($config_var))
		{
			// Show the [?] button.
			if ($config_var['help'])
				echo '
						<td class="windowbg2" valign="top" width="16"><a href="', $scripturl, '?action=helpadmin;help=', $config_var['help'], '" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt['help'], '" border="0" align="top" /></a></td>';
			else
				echo '
						<td class="windowbg2"></td>';

			echo '
						<td valign="top" ', ($config_var['disabled'] ? ' style="color: #777777;"' : ''), '><label for="', $config_var['name'], '">', $config_var['label'], ($config_var['type'] == 'password' ? '<br /><i>' . $txt['admin_confirm_password'] . '</i>' : ''), '</label></td>
						<td class="windowbg2" width="50%">';

			// Show a check box.
			if ($config_var['type'] == 'check')
				echo '
							<input type="hidden" name="', $config_var['name'], '" value="0" /><input type="checkbox"', ($config_var['disabled'] ? ' disabled="disabled"' : ''), ' name="', $config_var['name'], '" id="', $config_var['name'], '" ', ($config_var['value'] ? ' checked="checked"' : ''), ' class="check" />';
			// Escape (via htmlspecialchars.) the text box.
			elseif ($config_var['type'] == 'password')
				echo '
							<input type="password"', ($config_var['disabled'] ? ' disabled="disabled"' : ''), ' name="', $config_var['name'], '[0]"', ($config_var['size'] ? ' size="' . $config_var['size'] . '"' : ''), ' value="*#fakepass#*" onfocus="this.value = \'\'; this.form.', $config_var['name'], '.disabled = false;" /><br />
							<input type="password" disabled="disabled" id="', $config_var['name'], '" name="', $config_var['name'], '[1]"', ($config_var['size'] ? ' size="' . $config_var['size'] . '"' : ''), ' />';
			// Show a selection box.
			elseif ($config_var['type'] == 'select')
			{
				echo '
							<select name="', $config_var['name'], '"', ($config_var['disabled'] ? ' disabled="disabled"' : ''), '>';
				foreach ($config_var['data'] as $option)
					echo '
								<option value="', $option[0], '"', ($option[0] == $config_var['value'] ? ' selected="selected"' : ''), '>', $option[1], '</option>';
				echo '
							</select>';
			}
			// Text area?
			elseif ($config_var['type'] == 'large_text')
			{
				echo '
							<textarea rows="', ($config_var['size'] ? $config_var['size'] : 4), '" cols="30" ', ($config_var['disabled'] ? ' disabled="disabled"' : ''), ' name="', $config_var['name'], '">', $config_var['value'], '</textarea>';
			}
			// Assume it must be a text box.
			else
				echo '
							<input type="text"', ($config_var['disabled'] ? ' disabled="disabled"' : ''), ' name="', $config_var['name'], '" value="', $config_var['value'], '"', ($config_var['size'] ? ' size="' . $config_var['size'] . '"' : ''), ' />';

			echo '
						</td>';
		}
		else
		{
			// Just show a separator.
			if ($config_var == '')
				echo '
							<td colspan="3" class="windowbg2"><hr size="1" width="100%" class="hrcolor" /></td>';
			else
				echo '
							<td colspan="3" class="windowbg2" align="center"><b>' . $config_var . '</b></td>';
		}
		echo '
					</tr>';
	}
	echo '
					</tr><tr>
						<td class="windowbg2" colspan="3" align="center" valign="middle"><input type="submit" value="', $txt['save'], '"', (!empty($context['save_disabled']) ? ' disabled="disabled"' : ''), ' /></td>
					</tr>
				</table>
			</td></tr>
		</table>
		<input type="hidden" name="sc" value="', $context['session_id'], '" />
	</form>';
}

// Function to show the 'Block List' page.
function template_block_list()
{
	global $context, $settings, $options, $scripturl, $txt;

	echo '
		<table border="0" align="center" cellspacing="1" cellpadding="4" class="bordercolor" width="100%">';

	// Create a list for each block side/area.
	foreach($context['SPortal']['sides'] as $id => $side) 
	{
		// Setup the table for the list.
		echo '
				<tr class="catbg3">
					<td colspan="3" align="left">
						<div style="float: left;" valign="middle">
							<a href="', $scripturl, '?action=helpadmin;help=sp-blocks', $side['label'], 'List" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt['help'], '" border="0" align="top" /></a>
							<b><a href="', $scripturl, '?action=admin;area=blocks;sa=', $id, '">' . $side['label'] . ' ', $txt['sp-blocksBlocks'], '</a></b> - <a href="' . $scripturl . '?action=admin;area=blocks;sa=add;col=' . $side['id'] . '">(', $txt['sp-blocksCreate'], ')</a>
						</div>
					</td>
				</tr>';

		echo '
				<tr class="titlebg">';
		foreach ($context['SPortal']['columns'] as $column)
		{
				echo '
					<th', isset($column['width']) ? ' width="' . $column['width'] . '"' : '', '>
						', $column['label'], '
					</th>';
		}
		echo '
				</tr>';
		
		// Show all of the blocks.
		foreach($context['SPortal']['blocks'][$side['name']] as $block)
		{
			echo '
				<tr>
					<td align="left" valign="top" class="windowbg">', $block['label'], '</td>
					<td align="left" valign="top" class="windowbg2">', $txt['sp_function_' . $block['type'] . '_label'], '</td>
					<td align="center" valign="top" class="windowbg2">', empty($block['state']) ? '<a href="' . $scripturl . '?action=admin;area=blocks;sa=statechange;id=' . $block['id'] . ';type=block;sesc=' . $context['session_id'] . '"><img src="' . $settings['default_theme_url'] . '/images/icons/package_old.gif" alt="' . $txt['sp-blocksActivate'] . '" title="' . $txt['sp-blocksActivate'] . '" /></a>' : '<a href="' . $scripturl . '?action=admin;area=blocks;sa=statechange;id=' . $block['id'] . ';type=block;sesc=' . $context['session_id'] . '"><img src="' . $settings['default_theme_url'] . '/images/icons/package_installed.gif" alt="' . $txt['sp-blocksDeactivate'] . '" title="' . $txt['sp-blocksDeactivate'] . '" /></a>', ' ';
			// Do we need to show a moveup button?
			if($block['row'] != 1)
				echo '
						<a href="', $scripturl, '?action=admin;area=blocks;sa=move;block_id=', $block['id'] . ';direction=up;sesc=', $context['session_id'], '"><img src="', $settings['default_theme_url'], '/images/sort_up.gif" alt="', $txt['sp-blocksMoveUp'], '" title="', $txt['sp-blocksMoveUp'], '" /></a> '; 
			// Do we need to show a movedown button?
			if($block['row'] != count($context['SPortal']['blocks'][$side['name']]))
				echo '
						<a href="', $scripturl, '?action=admin;area=blocks;sa=move;block_id=', $block['id'] . ';direction=down;sesc=', $context['session_id'], '"><img src="', $settings['default_theme_url'], '/images/sort_down.gif" alt="', $txt['sp-blocksMoveDown'], '" title="', $txt['sp-blocksMoveDown'], '" /></a> ';
			// Show an edit and a delete link.
			echo '
						<a href="', $scripturl, '?action=admin;area=blocks;sa=edit;block_id=', $block['id'], ';sesc=', $context['session_id'], '"><img src="', $settings['default_theme_url'], '/images/buttons/modify.gif" alt="', $txt['modify'], '" title="', $txt['modify'], '" /></a>
						<a href="', $scripturl, '?action=admin;area=blocks;sa=delete;block_id=', $block['id'], ';col=', $block['column'], ';sesc=', $context['session_id'], '" onclick="return confirm(\'', $txt['sp-deleteblock'], '\');"><img src="', $settings['default_theme_url'], '/images/buttons/delete.gif" alt="', $txt['delete'], '" title="', $txt['delete'], '" /></a>
					</td>
				</tr>';

		}
	}
	echo '
			<tr class="catbg3">
				<td colspan="3" align="left">
				</td>
			</tr>
		</table>';
}

// Function to show the 'Add or Edit Block' page.
function template_block_edit()
{
	global $context, $settings, $options, $scripturl, $txt, $helptxt, $modSettings;

	echo '<br />
	<table border="0" align="center" cellspacing="1" cellpadding="4" class="tborder" width="65%">
		<tr class="catbg">
			<td>
				<a href="', $scripturl, '?action=helpadmin;help=sp-blocks', !empty($context['SPortal']['block_info']['id']) ? 'Edit' : 'Add', '" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt['help'], '" border="0" align="top" /></a>&nbsp;
				', !empty($context['SPortal']['block_info']['id']) ? $txt['sp-blocksEdit'] : $txt['sp-blocksAdd'], '
			</td>
		</tr>
		<tr class="windowbg2">
			<td align="center">
				<form action="', $scripturl, '?action=admin;area=blocks;sa=edit" method="post" accept-charset="', $context['character_set'], '">
					<table border="0" cellspacing="0" cellpadding="4" width="100%">';
	
	if(empty($modSettings['showleft']) || empty($modSettings['showright']))
	{
		echo
						'<tr class="windowbg3">
							<td colspan="3" style="font-weight:bold;text-align:center;">';
		
		if(empty($modSettings['showleft']) && empty($modSettings['showright']))
			echo $txt['sp-blocksDisabledBoth'];
		elseif(empty($modSettings['showleft']))
			echo $txt['sp-blocksDisabledLeft'];
		else
			echo $txt['sp-blocksDisabledRight'];
		
		echo '
							</td>
						</tr>';
	}
	
	echo
						'<tr>
							<td class="windowbg2" valign="top" width="16">&nbsp;</td>
							<th style="text-align:right;" valign="top">', $txt['sp-adminColumnType'], ':</th>
							<td class="windowbg2">', !empty($context['SPortal']['block_info']['type_text']) ? $context['SPortal']['block_info']['type_text'] : $txt['sp_function_unkown_label'], '</td>
						<tr>
						<tr>
							<td class="windowbg2" valign="top" width="16">&nbsp;</td>
							<th style="text-align:right;" valign="top">', $txt['sp-adminColumnName'], ':</th>
							<td class="windowbg2"><input type="text" name="block_name" value="', !empty($context['SPortal']['block_info']['label']) ? $context['SPortal']['block_info']['label'] : '', '" size="30" /></td>
						<tr>
							<td class="windowbg2" valign="top" width="16">&nbsp;</td>
							<th style="text-align:right;" valign="top">', $txt['sp-blocksPermissions'], ':</th>
							<td class="windowbg2">';
	sp_template_inline_permissions();
	echo '
							</td>
						</tr>
						<tr>
							<td class="windowbg2" valign="top" width="16"><a href="', $scripturl, '?action=helpadmin;help=sp-blocksPermissionType" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt['help'], '" border="0" align="top" /></a></td>
							<th style="text-align:right;" valign="top">', $txt['sp-blocksPermissionType'], ':</th>
							<td class="windowbg2">
								<input class="check" type="radio" name="permission_type" value="0" ', empty($context['SPortal']['block_info']['permission_type']) || $context['SPortal']['block_info']['permission_type'] > 2 ? 'checked="checked" ' : '', 'id="permission_type" />'.$txt['sp-blocksPermissionOne'].'<br />
								<input class="check" type="radio" name="permission_type" value="1" ', !empty($context['SPortal']['block_info']['permission_type']) && $context['SPortal']['block_info']['permission_type'] == 1 ? 'checked="checked" ' : '', 'id="permission_type" />'.$txt['sp-blocksPermissionAll'].'<br />
								<input class="check" type="radio" name="permission_type" value="2" ', !empty($context['SPortal']['block_info']['permission_type']) && $context['SPortal']['block_info']['permission_type'] == 2 ? 'checked="checked" ' : '', 'id="permission_type" />'.$txt['sp-blocksPermissionIgnore'].'<br />
							</td>
						</tr>';
				$counter = 0;
				$parameters = $context['SPortal']['parameters'];
				while($parameters != 0) 
				{
					$counter = $counter + 1;

					echo '
						<tr>
							<td class="windowbg2" valign="top" width="16">';
					// Do we have help popup text for this parameter?
					if(!empty($helptxt['sp_function_' . (!empty($context['SPortal']['block_info']['id']) ? $context['SPortal']['block_info']['type'] : $context['SPortal']['block_type']) . '_param'.$counter]))
					echo '
								<a href="', $scripturl, '?action=helpadmin;help=sp_function_', (!empty($context['SPortal']['block_info']['id']) ? $context['SPortal']['block_info']['type'] : $context['SPortal']['block_type']) , '_param' , $counter, '" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt['help'], '" border="0" align="top" /></a>';
					echo '
							</td>
							<th style="text-align:right;" valign="top">', $txt['sp_function_' . (!empty($context['SPortal']['block_info']['id']) ? $context['SPortal']['block_info']['type'] : $context['SPortal']['block_type']) . '_param'.$counter], '</th>
							<td class="windowbg2">
								<input type="text" name="parameters[]" value="', !empty($context['SPortal']['parameter_values'][$counter - 1]) ? trim($context['SPortal']['parameter_values'][$counter - 1], ' ') : '', '" size="10" />
							</td>
						</tr>';
					$parameters = $parameters - 1;
				}
				if(in_array(!empty($context['SPortal']['block_info']['id']) ? $context['SPortal']['block_info']['type'] : $context['SPortal']['block_type'], array('sp_bbc', 'sp_html', 'sp_php')))
					echo '
						<tr>
							<td class="windowbg2" valign="top" width="16"><a href="', $scripturl, '?action=helpadmin;help=sp_function_'. (!empty($context['SPortal']['block_info']['id']) ? $context['SPortal']['block_info']['type'] : $context['SPortal']['block_type']) . '_content" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt['help'], '" border="0" align="top" /></a></td>
							<th style="text-align:right;" valign="top">', $txt['sp_function_'. (!empty($context['SPortal']['block_info']['id']) ? $context['SPortal']['block_info']['type'] : $context['SPortal']['block_type']) . '_content'], '</th>
							<td class="windowbg2">
								<textarea name="block_content" cols="50" rows="3">', !empty($context['SPortal']['block_info']['content']) ? $context['SPortal']['block_info']['content'] : '', '</textarea>
							</td>
						</tr>';
				if(empty($context['SPortal']['column']) && empty($context['SPortal']['block_info']['id']))
					echo '
						<tr>
							<td class="windowbg2" valign="top" width="16">&nbsp;</td>
							<th style="text-align:right;" valign="top">', $txt['sp-blocksColumn'], ':</th>
							<td class="windowbg2">
								<select id="block_column" name="block_column">
									<option value="1">', $txt['sp-positionLeft'], '</option>
									<option value="2">', $txt['sp-positionTop'], '</option>
									<option value="3">', $txt['sp-positionBottom'], '</option>
									<option value="4">', $txt['sp-positionRight'], '</option>
								</select>
							</td>
						</tr>';
				else
					echo '
					<input type="hidden" name="block_column" value="', !empty($context['SPortal']['block_info']['id']) ? $context['SPortal']['block_info']['column'] : $context['SPortal']['column'], '" />';

				if((!empty($context['SPortal']['column']) && !empty($context['SPortal']['list_blocks'])) || (!empty($context['SPortal']['block_info']['id']) && count($context['SPortal']['list_blocks']) > 1))  {
					echo '
						<tr>
							<td class="windowbg2" valign="top" width="16">&nbsp;</td>
							<th style="text-align:right;" valign="top">', $txt['sp-blocksRow'], ':</th>
							<td class="windowbg2">
								<select id="order" name="placement"', !empty($context['SPortal']['block_info']['id']) ? ' onchange="this.form.block_row.disabled = this.options[this.selectedIndex].value == \'\';"' : '', '>
									', !empty($context['SPortal']['block_info']['id']) ? '<option value="nochange">' . $txt['sp-placementUnchanged'] . '</option>' : '', '
									<option value="before">', $txt['sp-placementBefore'], '...</option>
									<option value="after">', $txt['sp-placementAfter'], '...</option>
								</select>
								<select id="block_row" name="block_row"', !empty($context['SPortal']['block_info']['id']) ? ' disabled="disabled"' : '', '>';
								foreach($context['SPortal']['list_blocks'] as $block) {
									if(empty($context['SPortal']['block_info']['id']) || ($block['id'] != $context['SPortal']['block_info']['id']))
										echo '
										<option value="' . $block['row'] . '">' . $block['label'] . '</option>';
								}
								echo '
								</select>
							</td>
						</tr>';
				}
				echo '
						<tr>
							<td class="windowbg2" valign="top" width="16">&nbsp;</td>
							<th style="text-align:right;" valign="top">', $txt['sp-blocksForce'], ':</th>
							<td class="windowbg2"><input type="checkbox" name="block_force" value="1" id="block_force"', !empty($context['SPortal']['block_info']['force_view']) ? ' checked="checked"' : '', ' /></td>
						</tr>
						<tr>
							<td class="windowbg2" valign="top" width="16">&nbsp;</td>
							<th style="text-align:right;" valign="top">', $txt['sp-blocksActive'], ':</th>
							<td class="windowbg2"><input type="checkbox" name="block_active" value="1" id="block_active"', !empty($context['SPortal']['block_info']['state']) ? ' checked="checked"' : '', ' /></td>
						</tr>
						<tr>
							<td colspan="3" align="center"><input type="submit" name="add_block" value="', !empty($context['SPortal']['block_info']['id']) ? $txt['sp-blocksEdit'] : $txt['sp-blocksAdd'], '" /></td>
						</tr>
					</table>
					<input type="hidden" name="block_type" value="', !empty($context['SPortal']['block_info']['id']) ? $context['SPortal']['block_info']['type'] : $context['SPortal']['block_type'], '" />
					<input type="hidden" name="block_id" value="', !empty($context['SPortal']['block_info']['id']) ? $context['SPortal']['block_info']['id'] : '', '" />
					<input type="hidden" name="sc" value="', $context['session_id'], '" />
				</form>
			</td>
		</tr>
	</table>';
}

function template_block_select_type()
{
	global $context, $settings, $options, $scripturl, $txt, $modSettings;

	echo '<br />
	<table border="0" align="center" cellspacing="1" cellpadding="4" class="tborder" width="80%">
		<tr class="catbg">
			<td>
				<a href="', $scripturl, '?action=helpadmin;help=sp-blocksSelectType" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt['help'], '" border="0" align="top" /></a>&nbsp;
				', $txt['sp-blocksSelectType'], '
			</td>
		</tr>
		<tr class="windowbg">
			<td align="center">
				<form action="', $scripturl, '?action=admin;area=blocks;sa=add" method="post" accept-charset="', $context['character_set'], '">
					<table cellpadding="4">';

	$row_check = 0;
	$function_count = 0;

	foreach($context['SPortal']['block_types'] as $type) {

		$function_count = $function_count + 1;

		if($row_check == 0)
			echo '
						<tr>';
		echo '
							<td width="190px" valign="top" class="windowbg2">
								<input type="radio" name="selected_type[]" value="', $type['function'], '" id="', $type['function'], '" class="check" />&nbsp;&nbsp;<label for="', $type['function'], '"><b>', $txt['sp_function_' . $type['function'] . '_label'], '</b></label><br /><br />
								<span class="smalltext">', $txt['sp_function_' . $type['function'] . '_desc'], '<br /><br />', $txt['sp-blocksParameters'], ': ', $type['parameter'], '</span>
							</td>';
		$row_check = $row_check + 1;
		if($row_check == 3) {
			echo '
						</tr>';
			$row_check = 0;
		}
	}			

	if($function_count % 3 != 0) {

		$empty_cells = 3 - ($function_count % 3);

		while($empty_cells > 0) {

		echo '
							<td class="windowbg2">
								&nbsp;
							</td>';
		$empty_cells = $empty_cells - 1;
		}
		
			echo '
						</tr>';
	}
				echo '
						<tr>
							<td colspan="3" align="center"><input type="submit" name="select_type" value="', $txt['sp-blocksSelectType'], '" /></td>
						</tr>
					</table>';

				if(!empty($context['SPortal']['column']))
					echo '
					<input type="hidden" name="block_column" value="', $context['SPortal']['column'], '" />';

				echo '
					<input type="hidden" name="sc" value="', $context['session_id'], '" />
				</form>
			</td>
		</tr>
	</table>';
}

// Template function for the 'Admin' -> 'Sportal' -> 'ArticleList' page.
function template_article_list()
{
	global $context, $settings, $options, $scripturl, $txt, $modSettings;

	echo '
	<form action="', $scripturl, '?action=admin;area=articles;sa=list" method="post" accept-charset="', $context['character_set'], '" onsubmit="return confirm(\'', $txt['sp-articlesConfirm'], '\');">
		<table border="0" align="center" cellspacing="1" cellpadding="4" class="bordercolor" width="100%">
			<tr class="catbg3">
				<td colspan="8"><b>', $txt['pages'], ':</b> ', $context['page_index'], '</td>
			</tr><tr class="titlebg">';
	// Show each columns header.
	foreach ($context['columns'] as $column)
	{
		if ($column['selected'])
			echo '
				<th', isset($column['width']) ? ' width="' . $column['width'] . '"' : '', '>
					<a href="', $column['href'], '">', $column['label'], '&nbsp;<img src="', $settings['images_url'], '/sort_', $context['sort_direction'], '.gif" alt="" /></a>
				</th>';
		elseif ($column['sortable'])
			echo '
				<th', isset($column['width']) ? ' width="' . $column['width'] . '"' : '', '>
					', $column['link'], '
				</th>';
		else
			echo '
				<th', isset($column['width']) ? ' width="' . $column['width'] . '"' : '', '>
					', $column['label'], '
				</th>';
	}
	// Show the Select/Deselect all checkbox.
	echo '
				<th><input type="checkbox" class="check" onclick="invertAll(this, this.form);" /></th>
			</tr>';
	
	// Show each individual article.
	while ($article = $context['get_article']())
	{
		echo '
			<tr>
				<td align="left" valign="top" class="windowbg">', $article['topic']['link'], '</td>
				<td align="left" valign="top" class="windowbg">', $article['board']['link'], '</td>
				<td align="center" valign="top" class="windowbg">', $article['poster']['link'], '</td>
				<td align="center" valign="top" class="windowbg">', $article['message']['time'], '</td>
				<td align="left" valign="top" class="windowbg">', $article['category']['name'], '</td>
				<td align="center" valign="top" class="windowbg"><a href="' . $scripturl . '?action=admin;area=articles;sa=statechange;id=' . $article['article']['id'] . ';type=article;sesc=' . $context['session_id'] . '" title="'.(empty($article['article']['approved']) ? $txt['sp-blocksActivate'] : $txt['sp-blocksDeactivate']).'">', empty($article['article']['approved']) ? $txt['sp-stateNo'] : $txt['sp-stateYes'], '</a></td>
				<td align="center" valign="top" class="windowbg">', $article['edit'], $article['delete'], '</td>
				<td align="center" valign="top" class="windowbg2"><input type="checkbox" name="remove[]" value="', $article['article']['id'], '" class="check" /></td>
			</tr>';
	}
	echo '
			<tr class="catbg3">
				<td colspan="8" align="left">
					<div style="float: left;">
						<b>', $txt['pages'], ':</b> ', $context['page_index'], '
					</div>
					<div style="float: right;">
						<input type="submit" name="removeArticles" value="', $txt['sp-articlesRemove'], '" />
					</div>
				</td>
			</tr>
		</table>
		<input type="hidden" name="sc" value="', $context['session_id'], '" />
	</form>';
}

function template_article_add()
{
	global $context, $settings, $options, $txt, $scripturl;

	echo '
		<form action="' . $scripturl . '?action=admin;area=articles;sa=add;targetboard=' . $context['target_board'] . '" method="post" accept-charset="', $context['character_set'], '">
			<table border="0" width="540" cellspacing="1" class="bordercolor" cellpadding="4" align="center">
				<tr class="catbg3">
					<td>
						<a href="', $scripturl, '?action=helpadmin;help=sp-articlesAdd" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt['help'], '" border="0" align="top" /></a>&nbsp;
						<b>', $txt['sp-articlesAdd'], '</b>
					</td>
				</tr>
				<tr>
					<td class="windowbg" align="center">
						<table border="0" width="100%">
							<tr>
								<td class="windowbg" valign="top" width="16"><a href="', $scripturl, '?action=helpadmin;help=sp-articlesCategory" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt['help'], '" border="0" align="top" /></a></td>
								<td style="text-align:right;">', $txt['sp-articlesCategory'], ':</td>
								<td width="50%">
									<select id="category" name="category">';
												foreach($context['list_categories'] as $category) {
													echo '
													<option value="' . $category['id'] . '">' . $category['name'] . '</option>';
												}
												echo '
									</select>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td class="titlebg">
						<table cellpadding="0" cellspacing="0" border="0"><tr>
							<td><b>' . $txt['pages'] . ':</b> ' . $context['page_index'] . '</td>
						</tr></table>
					</td>
				</tr>
				<tr>
					<td class="windowbg" valign="middle" align="center">
						<table border="0" width="100%">
							<tr>';

	if (!empty($context['boards']) && count($context['boards']) > 1)
	{
		echo '
								<td class="windowbg" valign="top" width="16"><a href="', $scripturl, '?action=helpadmin;help=sp-articlesBoards" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt['help'], '" border="0" align="top" /></a></td>
								<td align="right"><br /><b>', $txt['board'], ':</b></td>
								<td align="left" width="50%">
									<br />
									<select name="targetboard" onchange="this.form.submit();">';
		foreach ($context['boards'] as $board)
			echo '
										<option value="', $board['id'], '"', $board['id'] == $context['target_board'] ? ' selected="selected"' : '', '>', $board['category'], ' - ', $board['name'], '</option>';
		echo '
									</select><noscript><input type="submit" value="', $txt['sp-articlesAdd'], '" /></noscript>
								</td>
								<td class="windowbg" valign="top" width="16"></td>';
	}

	echo '
							</tr><tr>
								<td class="windowbg" valign="top" width="16"><a href="', $scripturl, '?action=helpadmin;help=sp-articlesTopics" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt['help'], '" border="0" align="top" /></a></td>
								<td align="right" valign="top"><br /><b>', $txt['topics'], ':</b></td>
								<td align="left" style="white-space: nowrap;" width="50%">
									<br />
									<table>';

	foreach ($context['topics'] as $topic)
		echo '
										<tr>
											<td align="center" valign="top" class="windowbg">
												<input type="checkbox" name="articles[]" value="', $topic['msg_id'], '" class="check" />
											</td>
											<td valign="middle" style="white-space: nowrap;">
												<a href="' . $scripturl . '?topic=' . $topic['id'] . '.0" target="_blank">' . $topic['subject'] . '</a> ' . $txt['started_by'] . ' ' . $topic['poster']['link'] . '
											</td>
										</tr>';
	echo '
									</table>
								</td>
								<td class="windowbg" valign="top" width="16"></td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td class="windowbg2" align="center">
						<input type="submit" name="createArticle" value="', $txt['sp-articlesAdd'], '" />
						<input type="hidden" name="sc" value="', $context['session_id'], '" />
					</td>
				</tr>
				<tr>
					<td class="titlebg">
						<table cellpadding="0" cellspacing="0" border="0"><tr>
							<td><b>' . $txt['pages'] . ':</b> ' . $context['page_index'] . '</td>
						</tr></table>
					</td>
				</tr>
			</table>
		</form>';
}

function template_article_edit()
{
	global $context, $settings, $options, $scripturl, $txt, $modSettings;

	echo '<br />
	<table border="0" align="center" cellspacing="1" cellpadding="4" class="tborder" width="60%">
		<tr class="catbg">
			<td>
				<a href="', $scripturl, '?action=helpadmin;help=sp-articlesEdit" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt['help'], '" border="0" align="top" /></a>&nbsp;
				', $txt['sp-articlesEdit'], '
			</td>
		</tr>
		<tr class="windowbg2">
			<td>
				<form action="', $scripturl, '?action=admin;area=articles;sa=edit" method="post" accept-charset="', $context['character_set'], '">
					<table border="0" cellspacing="0" cellpadding="4" width="100%">
						<tr>
							<td class="windowbg2" valign="top" width="16"><a href="', $scripturl, '?action=helpadmin;help=sp-articlesCategory" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt['help'], '" border="0" align="top" /></a></td>
							<th style="text-align:right;" valign="top">', $txt['sp-articlesCategory'], ':</th>
							<td class="windowbg2" width="50%"">
								<select id="category" name="category">';
								foreach($context['list_categories'] as $category) {
									echo '
									<option value="' . $category['id'] . '"' . ($context['article_info']['category']['id'] == $category['id'] ? ' selected="selected"' : '') . ' >' . $category['name'] . '</option>';
								}
								echo '
								</select>
							</td>
						</tr>
						<tr>
							<td class="windowbg2" valign="top" width="16"><a href="', $scripturl, '?action=helpadmin;help=sp-articlesApproved" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt['help'], '" border="0" align="top" /></a></td>
							<th style="text-align:right;" valign="top">', $txt['sp-articlesApproved'], ':</th>
							<td class="windowbg2" width="50%"">
								<input type="checkbox" name="approved" value="1" id="approved"', !empty($context['article_info']['article']['approved']) ? ' checked="checked"' : '', ' />
							</td>
						</tr>
						<tr>
							<td colspan="3" align="center"><input type="submit" name="add_article" value="', $txt['sp-articlesEdit'], '" /></td>
						</tr>
					</table>
				<input type="hidden" name="article_id" value="', $context['article_info']['article']['id'], '" />
				<input type="hidden" name="sc" value="', $context['session_id'], '" />
				</form>
			</td>
		</tr>
	</table>';
}

function template_category_list()
{
	global $context, $settings, $options, $scripturl, $txt;

	echo '
		<table border="0" align="center" cellspacing="1" cellpadding="4" class="bordercolor" width="100%">
			<tr class="catbg3">
				<td colspan="5" align="left">
					<div style="float: left;">
						<a href="', $scripturl, '?action=helpadmin;help=sp-categoriesCategories" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt['help'], '" border="0" align="top" /></a>
						<b>', $txt['sp-categoriesCategories'], '</b>
					</div>
				</td>
			</tr>';

	echo '
			<tr class="titlebg">';
	foreach ($context['columns'] as $column)
	{
			echo '
				<th', isset($column['width']) ? ' width="' . $column['width'] . '"' : '', '>
					', $column['label'], '
				</th>';
	}
	echo '
			</tr>';

	foreach($context['categories'] as $category)
	{
		echo '
			<tr>
				<td align="center" valign="top" class="windowbg">', !empty($category['picture']['href']) ? $category['picture']['image'] : '', '</td>
				<td align="left" valign="middle" class="windowbg2">', $category['name'], '</td>
				<td align="center" valign="middle" class="windowbg2">', $category['articles'], '</td>
				<td align="center" valign="middle" class="windowbg2"><a href="' . $scripturl . '?action=admin;area=categories;sa=statechange;id=' . $category['id'] . ';type=category;sesc=' . $context['session_id'] . '" title="' , empty($category['publish']) ? $txt['sp-blocksActivate'] : $txt['sp-blocksDeactivate'], '">', empty($category['publish']) ? $txt['sp-stateNo'] : $txt['sp-stateYes'], '</a></td>
				<td align="center" valign="middle" class="windowbg2">', $category['edit'], $category['delete'], '</td>
			</tr>';
	}
	echo '
			<tr class="catbg3">
				<td colspan="5" align="left">
				</td>
			</tr>
		</table>';
}

function template_category_add()
{
	global $context, $settings, $options, $scripturl, $txt, $modSettings;

	echo '<br />
	<table border="0" align="center" cellspacing="1" cellpadding="4" class="tborder" width="60%">
		<tr class="catbg">
			<td>
				<a href="', $scripturl, '?action=helpadmin;help=sp-categoriesAdd" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt['help'], '" border="0" align="top" /></a>&nbsp;
				', $txt['sp-categoriesAdd'], '
			</td>
		</tr>
		<tr class="windowbg2">
			<td align="center">
				<form action="', $scripturl, '?action=admin;area=categories;sa=add" method="post" accept-charset="', $context['character_set'], '">
					<table border="0" cellspacing="0" cellpadding="4" width="100%">
						<tr>
							<th style="text-align:right;" valign="top">', $txt['sp-categoriesName'], ':</th>
							<td class="windowbg2" width="50%"><input type="text" name="category_name" value="" size="20" /></td>
						</tr>
						<tr>
							<th style="text-align:right;" valign="top">', $txt['sp-categoriesPicture'], ':</th>
							<td class="windowbg2" width="50%"><input type="text" name="picture_url" value="" size="30" /></td>
						</tr>
						<tr>
							<th style="text-align:right;" valign="top">', $txt['sp-categoriesPublish'], ':</th>
							<td class="windowbg2" width="50%"><input type="checkbox" name="show_on_index" value="1" id="show_on_index" checked="checked" /></td>
						</tr>
						<tr>
							<td colspan="2" align="right"><input type="submit" name="add_category" value="', $txt['sp-categoriesAdd'], '" /></td>
						</tr>
					</table>
				<input type="hidden" name="sc" value="', $context['session_id'], '" />
				</form>
			</td>
		</tr>
	</table>';
}

function template_category_edit()
{
	global $context, $settings, $options, $scripturl, $txt, $modSettings;

	echo '<br />
	<table border="0" align="center" cellspacing="1" cellpadding="4" class="tborder" width="60%">
		<tr class="catbg">
			<td>
				<a href="', $scripturl, '?action=helpadmin;help=sp-categoriesEdit" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt['help'], '" border="0" align="top" /></a>&nbsp;
				', $txt['sp-categoriesEdit'], '
			</td>
		</tr>
		<tr class="windowbg2">
			<td align="center">
				<form action="', $scripturl, '?action=admin;area=categories;sa=edit" method="post" accept-charset="', $context['character_set'], '">
					<table border="0" cellspacing="0" cellpadding="4" width="100%">
						<tr>
							<th style="text-align:right;" valign="top">', $txt['sp-categoriesName'], ':</th>
							<td class="windowbg2" width="50%"><input type="text" name="category_name" value="', $context['category_info']['name'], '" size="20" /></td>
						</tr>
						<tr>
							<th style="text-align:right;" valign="top">', $txt['sp-categoriesPicture'], ':</th>
							<td class="windowbg2" width="50%"><input type="text" name="picture_url" value="', $context['category_info']['picture']['href'], '" size="30" /></td>
						</tr>
						<tr>
							<th style="text-align:right;" valign="top">', $txt['sp-categoriesPublish'], ':</th>
							<td align="left"><input type="checkbox" name="show_on_index" value="1" id="show_on_index"', !empty($context['category_info']['publish']) ? ' checked="checked"' : '', ' /></td>
						</tr>
						<tr>
							<td colspan="3" align="center"><input type="submit" name="add_category" value="', $txt['sp-categoriesEdit'], '" /></td>
						</tr>
					</table>
				<input type="hidden" name="category_id" value="', $context['category_info']['id'], '" />
				<input type="hidden" name="sc" value="', $context['session_id'], '" />
				</form>
			</td>
		</tr>
	</table>';
}

function template_category_delete()
{
	global $context, $settings, $options, $scripturl, $txt, $modSettings;

	echo '<br />
	<table border="0" align="center" cellspacing="1" cellpadding="4" class="tborder" width="60%">
		<tr class="catbg">
			<td>
				<a href="', $scripturl, '?action=helpadmin;help=sp-categoriesDelete" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt['help'], '" border="0" align="top" /></a>&nbsp;
				', $txt['sp-categoriesDelete'], '
			</td>
		</tr>
		<tr class="windowbg2">
			<td align="center">
				<form action="', $scripturl, '?action=admin;area=categories;sa=delete" method="post" accept-charset="', $context['character_set'], '">
					<table border="0" cellspacing="0" cellpadding="4" width="100%">
						<tr>
							<td colspan="2" align="center">';
							printf($txt['sp-categoriesDeleteCount'], $context['category_info']['articles']);
	echo '<br />', !empty($context['list_categories']) ? $txt['sp-categoriesDeleteOption1'] : $txt['sp-categoriesDeleteOption2'], '</td>
						</tr>';
	if(!empty($context['list_categories'])) {
		echo '
						<tr>
							<th style="text-align:right;" valign="top">', $txt['sp-categoriesMove'], ':</th>
							<td class="windowbg2" width="50%">
								<input type="checkbox" name="category_move" value="1" id="category_move" checked="checked" />
							</td>
						</tr>
						<tr>
							<th style="text-align:right;" valign="top">', $txt['sp-categoriesMoveTo'], ':</th>
							<td class="windowbg2" width="50%">
								<select id="category_move_to" name="category_move_to">';
								foreach($context['list_categories'] as $category) {
									if($category['id'] != $context['category_info']['id'])
										echo '
										<option value="' . $category['id'] . '">' . $category['name'] . '</option>';
								}
								echo '
								</select>
							</td>
						</tr>';
	}
	echo '
						<tr>
							<td colspan="2" align="center"><input type="submit" name="delete_category" value="', $txt['sp-categoriesDelete'], '"  onclick="return confirm(\'' . $txt['sp-categoriesDeleteConfirm'] . '\');" /></td>
						</tr>
					</table>
				<input type="hidden" name="category_id" value="', $context['category_info']['id'], '" />
				<input type="hidden" name="sc" value="', $context['session_id'], '" />
				</form>
			</td>
		</tr>
	</table>';
}

function sp_template_inline_permissions()
{
	global $context, $settings, $options, $txt;

	echo '
		<fieldset id="permissions">
			<legend><a href="javascript:void(0);" onclick="document.getElementById(\'permissions\').style.display = \'none\';document.getElementById(\'permissions_link\').style.display = \'block\'; return false;">', $txt['avatar_select_permission'], '</a></legend>';
		echo '
			<table width="100%" border="0">';
	foreach ($context['member_groups'] as $group)
	{
		echo '
				<tr>
					<td align="center"><input type="checkbox" name="member_groups[]" value="', $group['id'], '"', !empty($group['checked']) ? ' checked="checked"' : '', ' class="check" /></td>
					<td><span', $group['is_post_group'] ? ' style="border-bottom: 1px dotted;" title="' . $txt['mboards_groups_post_group'] . '"' : '', '>', $group['name'], '</span></td>
				</tr>';
	}
	echo '
				<tr>
					<td colspan="2">
						<i>', $txt['check_all'], '</i> <input type="checkbox" onclick="invertAll(this, this.form, \'member_groups[]\');" />
					</td>
				</tr>
			</table>
		</fieldset>

		<a href="javascript:void(0);" onclick="document.getElementById(\'permissions\').style.display = \'block\'; document.getElementById(\'permissions_link\').style.display = \'none\'; return false;" id="permissions_link" style="display: none;">[ ', $txt['avatar_select_permission'], ' ]</a>

		<script language="JavaScript" type="text/javascript"><!-- // --><' . '!' . '[' . 'CDATA' . '[
			document.getElementById("permissions").style.display = "none";
			document.getElementById("permissions_link").style.display = "";
		// ' . ']' . ']' . '></script>';
}

?>